searchNodes=[{"type":"module","title":"Image","doc":"Image is based upon the fabulous vix library that provides a libvips wrapper for Elixir. Image is intended to provide well-documented common image processing functions in an idiomatic Elixir functional style as a layer above the very comprehensive set of functions in Vix and libvips . In a very simple image resizing benchmark , Image is approximately 2 to 3 times faster than Mogrify and uses about 5 times less memory.","ref":"Image.html"},{"type":"function","title":"Image.add_alpha/2","doc":"Add an alpha band to an image. Arguments image is any Vix.Vips.Image.t/0 . alpha_image is any single-band image that will be added as an alpha image to image OR an integer in the range 0..255 that represents the level of transparency of the alpha band. 0 represents fully opaque and 255 represents fully transparent. The atoms :opaque and :transparent may also be provided representing the values of 0 and 255 respectively. Returns {:ok, image_with_added_alpha_band} or {:error, reason}","ref":"Image.html#add_alpha/2"},{"type":"function","title":"Image.add_alpha!/2","doc":"Add an alpha band to an image. Arguments image is any Vix.Vips.Image.t/0 . alpha_image is any single-band image that will be added as an alpha image to image OR :color which defines the color of the alpha image. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The default is 0 , meaning black. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Note If color is provided then the alpha layer determines the level of transparency of image . White (RGB color 255) means that image will be opaque. Black (the default, RGB 0) means that image will be transparent. Other colors will determine the level of transparency between the two. Returns image_with_added_alpha_band or raises an exception.","ref":"Image.html#add_alpha!/2"},{"type":"function","title":"Image.alpha_band/1","doc":"Returns the band number of the alpha channel of an image, or nil if it doesn't have one. The determination is a heuristic so certainty cannot be guaranteed. Arguments image is any Vix.Vips.Image.t/0 . Returns An integer in the range 1..4 depending on the image interpretation. Returns nil if there is no alpha band. The integer is a 0-based offset and can therefore be directly used to access the band. For example image[alpha_band(image)] .","ref":"Image.html#alpha_band/1"},{"type":"function","title":"Image.apply_tone_curve/2","doc":"Applies a tone curve to an image. A tone curve is typically used to affect overall image contrast. It is a function to adjust brightness and contrast by controlling the input-output density curve for each band of an image. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :black_point is an integer between 0 (the default) and 100 indicating the darkest and most dense black area of the image will lie in the overall range of the image. :white_point is an integer between 0 and 100 (the default) indicating the lightest area of the image will lie in the overall range of the image. :shadow_point is the point on the tone curve around which the shadow values are tone mapped. The value is between 0.0 and 1.0 . The default is 0.2 . :mid_point is the point on the tone curve around which the mid tone values are tone mapped. The value is between 0.0 and 1.0 . The default is 0.5 . :highlight_point is the point on the tone curve around which the highlight values are tone mapped. The value is between 0.0 and 1.0 . The default is 0.8 . :shadows indicates by how much the shadows should be adjusted. The value is in the range -30 to 30 . The default is 0 . :mid_points indicates by how much the mid tones should be adjusted. The value is in the range -30 to 30 . The default is 0 . :highlights indicates by how much the highlights should be adjusted. The value is in the range -30 to 30 . The default is 0 . Returns {:ok, tone_mapped_image} or {:error, reason} .","ref":"Image.html#apply_tone_curve/2"},{"type":"function","title":"Image.apply_tone_curve!/2","doc":"Applies a tone curve to an image or raises an exception. A tone curve is typically used to affect overall image contrast. It is a function to adjust brightness and contrast by controlling the input-output density curve for each band of an image. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :black_point is an integer between 0 (the default) and 100 indicating the darkest and most dense black area of the image will lie in the overall range of the image. :white_point is an integer between 0 and 100 (the default) indicating the lightest area of the image will lie in the overall range of the image. :shadow_point is the point on the tone curve around which the shadow values are tone mapped. The value is between 0.0 and 1.0 . The default is 0.2 . :mid_point is the point on the tone curve around which the mid tone values are tone mapped. The value is between 0.0 and 1.0 . The default is 0.5 . :highlight_point is the point on the tone curve around which the highlight values are tone mapped. The value is between 0.0 and 1.0 . The default is 0.8 . :shadows indicates by how much the shadows should be adjusted. The value is in the range -30 to 30 . The default is 0 . :mid_points indicates by how much the mid tones should be adjusted. The value is in the range -30 to 30 . The default is 0 . :highlights indicates by how much the highlights should be adjusted. The value is in the range -30 to 30 . The default is 0 . Returns tone_mapped_image or raises an exception.","ref":"Image.html#apply_tone_curve!/2"},{"type":"function","title":"Image.aspect/2","doc":"Returns the aspect of an image. Arguments image is any Vix.Vips.Image.t/0 options is a keyword list of options Options :square_ratio indicates when an image is to be considered square. It is a floating point indicator of the ratio between the width and height below which the image is considered square. The default is 0.0 meaning that the dimensions must be exactly equal in order for the image to be considered square. Returns Either :landscape , :portrait or :square . Example iex&gt; puppy = Image . open! ( Path . expand ( &quot;test/support/images/puppy.webp&quot; ) ) iex&gt; Image . aspect ( puppy , square_ratio : 0.05 ) :landscape","ref":"Image.html#aspect/2"},{"type":"function","title":"Image.autorotate/1","doc":"Rotate an image based upon the orientation information in an image's EXIF data. Arguments image is any Vix.Vips.Image.t/0 . Returns {:ok, {auto_rotated_image, flags}} or {:error, reason} Flags Two flags are returned indicating what action was taken: :flip which is a boolean indicating if the image was flipped or not and :angle through which the image was rotated. This value will be one of 0 , 90 , 180 or 270 representing the degrees of rotation.","ref":"Image.html#autorotate/1"},{"type":"function","title":"Image.autorotate!/1","doc":"Rotate an image based upon the orientation information in an image's EXIF data. Returns a potentially rotated image or raises and exception. Arguments image is any Vix.Vips.Image.t/0 . Returns auto_rotated_image or raises an exception.","ref":"Image.html#autorotate!/1"},{"type":"function","title":"Image.avatar/2","doc":"Make a circular or square image intended to be used as an avatar image. The image is resized and all metadata is removed from the image. Depending on the :shape option the image may be center cropped to a square and may have a circular mask applied. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. The default is [shape: :cirlce, crop: :none] . Options :size is the diameter (in the case of shape: :circle or width/height in the case of shape: :square of the resulting image after resizing. The default value is 180 . :shape defines shape of the avator which can be either :circle (the default) or :square . In both cases the image is first center cropped to a square shape. Then if the format is :circle a circular image mask is applied. For other options see Image.thumbnail/3 . Returns {:ok, avatar_image} or {:error, reason}","ref":"Image.html#avatar/2"},{"type":"function","title":"Image.avatar!/2","doc":"Make a circular or square image intended to be used as an avatar image or raise an exception. The image is resized and all metadata is removed from the image. Depending on the :shape option the image may be center cropped to a square and may have a circular mask applied. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. The default is [shape: :cirlce, crop: :none] . Options :size is the diameter (in the case of shape: :circle or width/height in the case of shape: :square of the resulting image after resizing. The default value is 180 . :shape defines shape of the avator which can be either :circle (the default) or :square . In both cases the image is first center cropped to a square shape. Then if the format is :circle a circular image mask is applied. For other options see Image.thumbnail/3 . Returns avatar_image or raises an exception.","ref":"Image.html#avatar!/2"},{"type":"function","title":"Image.average/1","doc":"Returns the average color of an image. The average is calculated for each band of an image and then combined. Arguments image is any Vix.Vips.Image.t/0 . Returns A list of average pixel values which can be interpreted as the average color of the image. Example iex&gt; Image . open! ( &quot;./test/support/images/Hong-Kong-2015-07-1998.jpg&quot; ) ...&gt; |&gt; Image . average ( ) [ 66 , 86 , 106 ]","ref":"Image.html#average/1"},{"type":"function","title":"Image.average!/1","doc":"Returns the average color of an image or raises and exception. The average is calculated for each band of an image and then combined. Arguments image is any Vix.Vips.Image.t/0 . Returns A list of average pixel values which can be interpreted as the average color of the image. Example iex&gt; Image . open! ( &quot;./test/support/images/Hong-Kong-2015-07-1998.jpg&quot; ) ...&gt; |&gt; Image . average! ( ) [ 66 , 86 , 106 ]","ref":"Image.html#average!/1"},{"type":"function","title":"Image.band_format/1","doc":"Returns the band format of an image. Arguments image is any Vix.Vips.Image.t/0 . Returns The band format of the image in Nx notation. Examples iex&gt; image = Image . open! ( &quot;./test/support/images/Singapore-2016-09-5887.jpg&quot; ) iex&gt; Image . band_format ( image ) { :u , 8 }","ref":"Image.html#band_format/1"},{"type":"function","title":"Image.bands/1","doc":"Return the number of bands in an image. A band is sometimes referred to as a channel. Note than bands are 0-indexed. That is, the first band is band 0, the second band is band 1 and so on. Arguments image is any Vix.Vips.Image.t/0 . Returns An integer number of bands in the image.","ref":"Image.html#bands/1"},{"type":"function","title":"Image.blur/2","doc":"Applies a gaussian blur to an image. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :sigma is the float size of the mask to use. A larger number makes the image more blurry. A range between 1.0 and 10.0 is normally appropriate. The default is 5 . :min_amplitude is a float that determines the accuracy of the mask. The default is 0.2 . A smaller number will generate a larger, more accurate mask, Returns {:ok, blurred_image} or {:error reason}","ref":"Image.html#blur/2"},{"type":"function","title":"Image.blur!/2","doc":"Applies a gaussian blur to an image. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :sigma is the float size of the mask to use. A larger number makes the image more blurry. A range between 1.0 and 10.0 is normally appropriate. The default is 5 . :min_amplitude is a float that determines the accuracy of the mask. The default is 0.2 . A smaller number will generate a larger, more accurate mask, Returns blurred_image or raises an exception.","ref":"Image.html#blur!/2"},{"type":"function","title":"Image.brightness/2","doc":"Apply a percentage adjustment to an image's brightness (luminance). The image is converted to the lch color space, multiplies the luminance band by the provided float percentage and converts the image back to its original color space. Arguments image is any Vix.Vips.Image.t/0 . brightness is any float greater than 0.0 . A number less than 1.0 means reduce brightness. A number greater than 1.0 means increas brightness. Returns {:ok, adjusted_image} or {:error, reason} .","ref":"Image.html#brightness/2"},{"type":"function","title":"Image.brightness!/2","doc":"Apply a percentage adjustment to an image's brightness (luminance) or raises an exception. The image is converted to the lch color space, multiplies the luminance band by the provided float percentage and converts the image back to its original color space. Arguments image is any Vix.Vips.Image.t/0 . brightness is any float greater than 0.0 . A number less than 1.0 means reduce brightness. A number greater than 1.0 means increas brightness. Returns adjusted_image or raises an exception.","ref":"Image.html#brightness!/2"},{"type":"function","title":"Image.cast/2","doc":"Casts an image from one band format to another. The band format is the numeric type of each pixel. In the common case of sRGB images, the format is {:u, 8} meaning unsigned 8-bit values. Arguments image is any Vix.Vips.Image.t/0 . band_format is any known band format. See Image.BandFormat.known_band_formats/0 . Returns {:ok, cast_image} or {:error, reason} .","ref":"Image.html#cast/2"},{"type":"function","title":"Image.center_crop/3","doc":"Crops the center from an image. Arguments image is any Vix.Vips.Image.t/0 . width is the width of area remaining as a positive integer or float in the range 0.0..1.0 . If width is an integer it is the absolute number of pixels. If width is a float it is the fraction of the original image width. height is the width of area remaining as a positive integer or float in the range 0.0..1.0 . If height is an integer it is the absolute number of pixels. If height is a float it is the fraction of the original image height. Notes An error will be returned if width and height are not equal to or smaller than the image dimensions. This function is a convenience function equivalent to calling Image.crop(image, :center, :middle, width, height) . Returns {:ok, cropped_image} or {:error, reason} .","ref":"Image.html#center_crop/3"},{"type":"function","title":"Image.center_crop!/3","doc":"Crops the center from an image. Arguments image is any Vix.Vips.Image.t/0 . width is the width of area remaining as a positive integer or float in the range 0.0..1.0 . If width is an integer it is the absolute number of pixels. If width is a float it is the fraction of the original image width. height is the width of area remaining as a positive integer or float in the range 0.0..1.0 . If height is an integer it is the absolute number of pixels. If height is a float it is the fraction of the original image height. Notes An error will be returned if width and height are not equal to or smaller than the image dimensions. This function is a convenience function equivalent to calling Image.crop!(image, :center, :middle, width, height) . Returns cropped_image or raises an exception.","ref":"Image.html#center_crop!/3"},{"type":"function","title":"Image.chroma_color/1","doc":"Automatically determine the chroma key color of an image. The top left 10x10 pixels of the flattened image are averaged to produce a color sample that can then be used by Image.chroma_mask/2 , Image.chroma_key/2 and Image.trim/2 . Argument image is any Vix.Vips.Image.t/0 . Returns An RGB color as a three-element list of integers.","ref":"Image.html#chroma_color/1"},{"type":"function","title":"Image.chroma_key/2","doc":"Chroma key an image. Chroma keying is the process of removing a background color from an image resulting in a foreground image that may be composited over another image. If the image already has an alpha band then the image is flattened before adding the image mask as a new alpha band. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options There are two masking strategies available: the thresholding strategy (default) and the color range strategy. Threshold strategy :color is an RGB color which represents the the chroma key to be masked. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. The default is :auto in which the average of the top left 10x10 pixels of the image is used. :threshold is a positive integer to indicate the threshold around :color when calculating the mask. The default is 20 . Color range strategy :greater_than is an RGB color which represents the upper end of the color range to be masked. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. :less_than is an RGB color which represents the lower end of the color range to be masked. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name.","ref":"Image.html#chroma_key/2"},{"type":"function","title":"Image.chroma_key!/2","doc":"Chroma key an image and return an image or raise an exception. Chroma keying is the process of removing a background color from an image resulting in a foreground image that may be composited over another image. If the image already has an alpha band then the image is flattened before adding the image mask as a new alpha band. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options There are two masking strategies available: the thresholding strategy (default) and the color range strategy. Threshold strategy :color is an RGB color which represents the the chroma key to be masked. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. The default is :auto in which the average of the top left 10x10 pixels of the image is used. :threshold is a positive integer to indicate the threshold around :color when calculating the mask. The default is 20 . Color range strategy :greater_than is an RGB color which represents the upper end of the color range to be masked. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. :less_than is an RGB color which represents the lower end of the color range to be masked. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name.","ref":"Image.html#chroma_key!/2"},{"type":"function","title":"Image.chroma_mask/2","doc":"Return a chroma-based masked image. Chroma masking is the process of removing a background color from an image and returning the remaining content as an alpha mask. The masking is done in the LCh color space since it's perceptually more uniform. The returned mask in reverted to the interpretation of the original image. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options There are two masking strategies available: the thresholding strategy (default) and the color range strategy. Threshold strategy :color is an RGB color which represents the the chroma key to be masked. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. The default is :auto in which the average of the top left 10x10 pixels of the image is used. :threshold is a positive integer to indicate the threshold around :color when calculating the mask. The default is 20 . Color range strategy :greater_than is an RGB color which represents the upper end of the color range to be masked. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. :less_than is an RGB color which represents the lower end of the color range to be masked. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name.","ref":"Image.html#chroma_mask/2"},{"type":"function","title":"Image.chroma_mask!/2","doc":"Return a chroma-based masked image or raises an exception. Chroma masking is the process of removing a background color from an image and returning the remaining content as an alpha mask. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options There are two masking strategies available: the thresholding strategy (default) and the color range strategy. Threshold strategy :color is an RGB color which represents the the chroma key to be masked. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. The default is :auto in which the average of the top left 10x10 pixels of the image is used. :threshold is a positive integer to indicate the threshold around :color when calculating the mask. The default is 20 . Color range strategy :greater_than is an RGB color which represents the upper end of the color range to be masked. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. :less_than is an RGB color which represents the lower end of the color range to be masked. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name.","ref":"Image.html#chroma_mask!/2"},{"type":"function","title":"Image.circle/2","doc":"Apply a circular mask to an image. The returned image has an alpha band masking the circular image. As a result, it is best saved to a format, like .png that supports alpha transparency. Note that .jpg files do not support alpha transparency. Arguments image is any Vix.Vips.Image.t/0 . Returns {:ok, circular_image} or {:error, reason}","ref":"Image.html#circle/2"},{"type":"function","title":"Image.circle!/2","doc":"Apply a circular mask to an image returning an image or raising an exception. The returned image has an alpha band masking the circular image. As a result, it is best saved to a format, like .png that supports alpha transparency. Note that .jpg files do not support alpha transparency. Arguments image is any Vix.Vips.Image.t/0 . Returns circular_image or raises an exception.","ref":"Image.html#circle!/2"},{"type":"function","title":"Image.compare/3","doc":"Compare two images using a particular comparison metric returning a score indicating the similarity of the images. Arguments image_1 is any Vix.Vips.Image.t/0 . image_2 is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :metric indicates which comparison metric to use. The default is :ae . The valid metrics are: :ae which returns the absolute nuber of pixels that are different between the two images. The returned value is conformed to the range of the underlying image format. Therefore the returned value is between 0.0 (images appear to be the same) and 1.0 (meaning the images appear completely different). :rmse is the root mean square error. The returned value is conformed to the range of the underlying image format. Therefore the returned value is between 0.0 (images appear to be the same) and 1.0 (meaning the images appear completely different), :mse which is the mean squared error (default). The returned value is a float indicating how similar the images are. A value of 0.0 means the images are the same. The number itself it simply a measure of the error difference between images. A larger number means the two images are less similar but the number itself cannot be interpreted as a percentage value. :difference_color is the color to be used for the pixels that are different between the two images. This can be specified as a single integer which will be applied to all bands, or a list of integers representing he color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . It can also be supplied as a hex string of the form #rrggbb . The default is :red . :difference_boost is a float multiplier that is applied to the difference image. This has the effect of boosting the overall brightness of the difference pixels making them stand out more against the background image. The default is 1.5 . :saturation is a float between 0.0 and 1.0 that is applied to the base image when overlaying the difference image. This may help the difference pixels become more obvious. The default ia 1.0 meaning no change in saturation. :brightness is a float between 0.0 and 1.0 that is applied to the base image when overlaying the difference image. This may help the difference pixels become more obvious. The default ia 1.0 meaning no change in brightness. Notes The images are conformed to the band format of the first image before comparison and cast up to the smallest common format. If the images differ in size, the smaller image is enlarged to match the larger by adding zero pixels along the bottom and right. If the number of bands differs, one of the images must have one band. In this case, an n-band image is formed from the one-band image by joining n copies of the one-band image together, and then the two n-band images are operated upon. The two input images are cast up to the smallest common format. Returns {:ok, comparison_score} or {:error, reason}","ref":"Image.html#compare/3"},{"type":"function","title":"Image.compose/3","doc":"Compose two images together to form a new image. Arguments base_image is any Vix.Vips.Image.t/0 . overlay_image is any Vix.Vips.Image.t/0 that will be composed over the top of base_image . It can also be a list of composition/0 s that allow for multiple images to be composed in a single call. options is a keyword list of options. Options for a single overlay image :blend_mode is the manner in which the two images are composited. See Image.BlendMode.t/0 . The default is :over which is the most common blend mode. :x is the offset (0-based) which, if zero or positive, from the left of the base_image . If negative is is the offset from the right of the base_image . where the overlay_image will be placed. It may also be one of the keywords :left , :right or :center . The default is :center . :y is the offset (0-based) which, if zero or positive, from the top of the base_image . If negative is is the offset from the bottom of the base_image . where the overlay_image will be placed. It may also be one of the keywords :top , :bottom or :middle . The default is :middle . Composition list options When overlay_image is an image_list , each entry in the list is either a Vix.Vips.Image.t/0 or a Image.composition_list/0 . A composition supports the specification of how a particular image is composed onto the base image. :x describes the absolute x offset on the base image where this image will be placed. If this option is set to :left , :center or :right then the x position will be calculated relative to the base image. If :x is nil (the default) then the image will be placed according to the relative offset of the previously composed image using :dx . :y describes the absolute y offset on the base image where this image will be placed. If this option is set to :top , :middle or :bottom then the y position will be calculated relative to the base image. If :y is nil (the default) then the image will be placed according to the relative offset of the previously composed image using :dy . :dx describes the relative offset used to calculate the x value. :dx is an integer offset from the edge of the previously composed image. Which edge is determined by the :x_baseline option. If :x is also specified then :x is first calculated, then :dx is added to it. In this case, :x_baseline is ignored. :dy describes the relative offset used to calculate the y value. :dy is an integer offset from the edge of the previously composed image. Which edge is determined by the :y_baseline option. If :y is also specified then :y is first calculated, then :dy is added to it. In this case, :x_baseline is ignored. :blend_mode is the Image.BlendMode.t/0 used when composing this image over its base image. The default is :over which is appropriate for most use cases. :x_baseline establishes the baseline on the previously composed image from which :dx is calculated. The default is :right . :y_baseline establishes the baseline on the previously composed image from which :dy is calculated. The default is :bottom . Returns {:ok, composed_image} or {:error, reason} Examples # Compose images over a base image using # absolute coordinates from the base image # to place each overlay image. #=&gt; {:ok, image} = Image.compose(base_image, polygon, x: :middle, y: :top) #=&gt; {:ok, image} = Image.compose(image, explore_new, x: 260, y: 200) #=&gt; {:ok, image} = Image.compose(image, places, x: 260, y: 260) #=&gt; {:ok, image} = Image.compose(image, blowout, x: 260, y: 340) #=&gt; {:ok, image} = Image.compose(image, start_saving, x: 260, y: 400) # Compose images over a base image # using a composition list and coordinates # that are either absolute with respect to the # base image or relative to the previously # composed image. #=&gt; Image.compose(base_image, [ .. &gt; { polygon , x : :center , y : :top } , .. &gt; { explore_new , y_baseline : :top , x_baseline : :left , dx : 20 , dy : 200 } , .. &gt; { places , dy : 10 } , .. &gt; { blowout , dy : 20 } , .. &gt; { start_saving , dy : 50 } .. &gt; ] )","ref":"Image.html#compose/3"},{"type":"function","title":"Image.compose!/3","doc":"Compose two images together to form a new image or raise an exception. Arguments base_image is any Vix.Vips.Image.t/0 . overlay_image is any Vix.Vips.Image.t/0 that will be composed over the top of base_image . options is a keyword list of options. Options :blend_mode is the manner in which the two images are composited. See Image.BlendMode.t/0 . The default is :over which is the most common blend mode. :x is the offset (0-based) which, if zero or positive, from the left of the base_image . If negative is is the offset from the right of the base_image . where the overlay_image will be placed. It may also be one of the keywords :left , :right or :center . The default is :center . :y is the offset (0-based) which, if zero or positive, from the top of the base_image . If negative is is the offset from the bottom of the base_image . where the overlay_image will be placed. It may also be one of the keywords :top , :bottom or :middle . The default is :middle . Composition list options When overlay_image is an image_list , each entry in the list is either a Vix.Vips.Image.t/0 or a Image.composition_list/0 . A composition supports the specification of how a particular image is composed onto the base image. :x describes the absolute x offset on the base image where this image will be placed. If this option is set to :left , :center or :right then the x position will be calculated relative to the base image. If :x is nil (the default) then the image will be placed according to the relative offset of the previously composed image using :dx . :y describes the absolute y offset on the base image where this image will be placed. If this option is set to :top , :middle or :bottom then the y position will be calculated relative to the base image. If :y is nil (the default) then the image will be placed according to the relative offset of the previously composed image using :dy . :dx describes the relative offset used to calculate the x value. :dx is an integer offset from the edge of the previously composed image. Which edge is determined by the :x_baseline option. If :x is also specified then :x is first calculated, then :dx is added to it. In this case, :x_baseline is ignored. :dy describes the relative offset used to calculate the y value. :dy is an integer offset from the edge of the previously composed image. Which edge is determined by the :y_baseline option. If :y is also specified then :y is first calculated, then :dy is added to it. In this case, :x_baseline is ignored. :blend_mode is the Image.BlendMode.t/0 used when composing this image over its base image. The default is :over which is appropriate for most use cases. :x_baseline establishes the baseline on the previously composed image from which :dx is calculated. The default is :right . :y_baseline establishes the baseline on the previously composed image from which :dy is calculated. The default is :bottom . Returns composed_image or raises an exception Examples # Compose images over a base image using # absolute coordinates from the base image # to place each overlay image #=&gt; base_image .. &gt; |&gt; Image . compose! ( polygon , x : :middle , y : :top ) .. &gt; |&gt; Image . compose! ( explore_new , x : 260 , y : 200 ) .. &gt; |&gt; Image . compose! ( places , x : 260 , y : 260 ) .. &gt; |&gt; Image . compose! ( blowout , x : 260 , y : 340 ) .. &gt; |&gt; Image . compose! ( start_saving , x : 260 , y : 400 ) # Compose images over a base image # using a composition list and coordinates # that are either absolute with respect to the # base image or relative to the previously # composed image #=&gt; base_image .. &gt; |&gt; Image . compose! ( [ .. &gt; { polygon , x : :center , y : :top } , .. &gt; { explore_new , y_baseline : :top , x_baseline : :left , dx : 20 , dy : 200 } , .. &gt; { places , dy : 10 } , .. &gt; { blowout , dy : 20 } , .. &gt; { start_saving , dy : 50 } .. &gt; ] )","ref":"Image.html#compose!/3"},{"type":"function","title":"Image.contrast/2","doc":"Apply a percentage adjustment to an image's contrast. This is a simple implementation that applies a linear function to the image. In most cases, Image.apply_tone_curve/2 should be preferred for making constrast adjustments. Small increments can have a dramatic affect on the image; contrast in the range of approximately 0.5 to 1.5 are likely to meet most requirement. Arguments image is any Vix.Vips.Image.t/0 . contrast is any float greater than 0.0 . A number less than 1.0 means reduce contrast. A number greater than 1.0 means increase contrast. Returns {:ok, adjusted_image} or {:error, reason} .","ref":"Image.html#contrast/2"},{"type":"function","title":"Image.contrast!/2","doc":"Apply a percentage adjustment to an image's contrast or raises and exception. This is a simple implementation that applies a linear function to the image. In most cases, Image.apply_tone_curve/2 should be preferred for making constrast adjustments. Small increments can have a dramatic affect on the image; contrast in the range of approximately 0.5 to 1.5 are likely to meet most requirement. Arguments image is any Vix.Vips.Image.t/0 . contrast is any float greater than 0.0 . A number less than 1.0 means reduce contrast. A number greater than 1.0 means increase contrast. Returns adjusted_image or raises an exception.","ref":"Image.html#contrast!/2"},{"type":"function","title":"Image.convert_to_mask/1","doc":"Convert an image into a mask. Takes an image, extracts its alpha channel which holds the opacity information and inverts the content. Arguments image is any Vix.Vips.Image.t/0 . Returns {:ok, mask} or {:error, reason}","ref":"Image.html#convert_to_mask/1"},{"type":"function","title":"Image.convert_to_mask!/1","doc":"Convert an image into a mask returning an image or raising an exception. Takes an image, extracts its alpha channel which holds the opacity information and inverts the content. Arguments image is any Vix.Vips.Image.t/0 . Returns mask image or raises an exception","ref":"Image.html#convert_to_mask!/1"},{"type":"function","title":"Image.crop/2","doc":"Crop an image. Arguments image is any Vix.Vips.Image.t/0 . quadrilateral is a list of four 2-tuples representing the points of the bounding rectangle. The points must be ordered as [top_left, top_right, bottom_right, bottom_left] Each point is of the form {x, y} where x is the 0-based offset from the left of the image and y is the 0-based offset from the top of the image. Returns {:ok, cropped_image} or {:error, reason} Note The bounding box must be a rectangle, not an arbitrary quadrilateral. If required, use Image.warp_perspective/4 prior to cropping.","ref":"Image.html#crop/2"},{"type":"function","title":"Image.crop/5","doc":"Crop an image. Arguments image is any Vix.Vips.Image.t/0 . left is the top edge of crop area as an integer or a float in the range -1.0..1.0 . If left is an integer it is the absolute number of pixels. If left a float is fraction of the width of the image. If left is positive it is relative to the left edge of the image. If it is negative it is relative to the right edge of the image. left may also be one of :left , :center and :right indicating the crop is relative to the left, center or right of the image. top is the top edge of crop area as an integer or a float in the range -1.0..1.0 . If top is an integer it is the absolute number of pixels. If top is a float is fraction of the height of the image. If top is positive it is relative to the top edge of the image. If it is negative it is relative to the bottom edge of the image. top may also be one of :top , :middle and :bottom indicating the crop is relative to the top, middle or bottom of the image. width is the width of area remaining as a positive integer or float in the range 0.0..1.0 . If width is an integer it is the absolute number of pixels. If width is a float it is the fraction of the original image width. height is the width of area remaining as a positive integer or float in the range 0.0..1.0 . If height is an integer it is the absolute number of pixels. If height is a float it is the fraction of the original image height. Notes left is 0-indexed. That is, the leftmost edge of the image starts at 0 . top is 0-indexed. That is, the topmost edge of the image starts at 0 . Returns {:ok, cropped_image} or {:error, reason}","ref":"Image.html#crop/5"},{"type":"function","title":"Image.crop!/2","doc":"Crop an image or raises an exception. Arguments image is any Vix.Vips.Image.t/0 . quadrilateral is a list of four 2-tuples representing the points of the bounding rectangle. The points must be ordered as [top_left, top_right, bottom_right, bottom_left] Each point is of the form {x, y} where x is the 0-based offset from the left of the image and y is the 0-based offset from the top of the image. Returns cropped_image or raises an exception. Note The bounding box must be a rectangle, not an arbitrary quadrilateral. If required, use Image.warp_perspective/4 prior to cropping.","ref":"Image.html#crop!/2"},{"type":"function","title":"Image.crop!/5","doc":"Crop an image returning a cropped image or raising an exception. Arguments left is the top edge of crop area as an integer or a float in the range -1.0..1.0 . If left is an integer it is the absolute number of pixels. If left a float is fraction of the width of the image. If left is positive it is relative to the left edge of the image. If it is negative it is relative to the right edge of the image. left may also be one of :left , :center and :right indicating the crop is relative to the left, center or right of the image. top is the top edge of crop area as an integer or a float in the range -1.0..1.0 . If top is an integer it is the absolute number of pixels. If top is a float is fraction of the height of the image. If top is positive it is relative to the top edge of the image. If it is negative it is relative to the bottom edge of the image. top may also be one of :top , :middle and :bottom indicating the crop is relative to the top, middle or bottom of the image. width is the width of area remaining as a positive integer or float in the range 0.0..1.0 . If width is an integer it is the absolute number of pixels. If width is a float it is the fraction of the original image width. height is the width of area remaining as a positive integer or float in the range 0.0..1.0 . If height is an integer it is the absolute number of pixels. If height is a float it is the fraction of the original image height. Returns cropped_image or raises an exception.","ref":"Image.html#crop!/5"},{"type":"function","title":"Image.dhash/2","doc":"Returns a 64-bit (for a has size of the default 64) difference hash as a binary. Image hashes can be used to compare the similarity of images. See Image.hamming_distance/2 . dhash is generates a &quot;difference hash&quot; for a given image. This is a perceptual hash based on Neal Krawetz's dHash algorithm in a Hacker Factor blog entry. The code is adapted from the Ruby implementation in dhash-vips . Arguments image is any Vix.Vips.Image.t/0 . hash_size is the size in bits of the returned hash. The default is 64 . The returned binary is only guaranteed to be the provided size if sqrt(hash_size) is an integer. Returns {:ok, 64-bit binary} or {:error, reason}","ref":"Image.html#dhash/2"},{"type":"function","title":"Image.dhash_pixels/3","doc":"","ref":"Image.html#dhash_pixels/3"},{"type":"function","title":"Image.dilate/2","doc":"Dilate an image mask, adding a pixels to the edge of the mask. Mask is used in the sense of an image on a transparent background. The results on other image types is undefined. The added pixels are the same color as the edge pixels in the mask. Note Dilate works for any non-complex image type, with any number of bands. The input is expanded by copying edge pixels before performing the operation so that the output image has the same size as the input. Edge pixels in the output image are therefore only approximate. Arguments image is any Vix.Vips.Image.t/0 . pixels is a positive integer number of pixels to dilate. The default is 1 . Returns {:ok, dilated_mask} or {:error, reason}","ref":"Image.html#dilate/2"},{"type":"function","title":"Image.dilate!/2","doc":"Dilate an image mask, adding a pixels to the edge of the mask or raising an exception. Mask is used in the sense of an image on a transparent background. The results on other image types is undefined. The added pixels are the same color as the edge pixels in the mask. Note Dilate works for any non-complex image type, with any number of bands. The input is expanded by copying edge pixels before performing the operation so that the output image has the same size as the input. Edge pixels in the output image are therefore only approximate. Arguments image is any Vix.Vips.Image.t/0 . pixels is a positive integer number of pixels to dilate. The default is 1 . Returns dilated_mask or raises an exception","ref":"Image.html#dilate!/2"},{"type":"function","title":"Image.dominant_color/2","doc":"Returns the dominant color of an image as an RBG triplet value in an integer list. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. The default is [] . Options :bins is an integer number of color frequency bins the image is divided into. The default is 10 . Returns [r, g, b]","ref":"Image.html#dominant_color/2"},{"type":"function","title":"Image.embed/4","doc":"Embeds an image in a larger image canvas, generating addition border pixels if required. Arguments image is any Vix.Vips.Image.t/0 . width is the width in pixels of the canvas image. height is the height in pixels of the canvas image. options is a keyword list of options. Options :x is the x-offset into the canvas image where image will be embedded. The value may be a positive integer indicating a 0-based offset from the left of the canvas or a negative integer indicating a 1-based offset from the right side of the image. It may also be :center (the default) in which case the image will be centered horizontally within the canvas. :y is the y-offset into the canvas image where image will be embedded. The value may be a positive integer indicating a 0-based offset from the top of the canvas or a negative integer indicating a 1-based offset from the bottom of the image. It may also be :center (the default) in which case the image will be centered vertically within the canvas. :background defines the color of the generated background pixels. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . It can also be supplied as a hex string of the form #rrggbb . The default is :black . :background can also be set to :average in which case the background will be the average color of the base image. See also Image.Color.color_map/0 and Image.Color.rgb_color/1 . :extend_mode determines how any additional pixels are generated. The values are: :black (the default) meaning the generated pixels are black. :white meaning the generated pixels are white. :copy means the generated pixels take the value of the nearest edge pixel of the base image. :repeat means the generated pixels are tiles from the base image. :mirror means the generated pixels are a reflected tiles of the base image. :background means the generated pixels are the background color set in options . Returns {:ok, embedded_image} or {:error, reason}","ref":"Image.html#embed/4"},{"type":"function","title":"Image.embed!/4","doc":"Embeds an image in a larger image canvas, generating addition border pixels if required. Arguments image is any Vix.Vips.Image.t/0 . width is the width in pixels of the canvas image. height is the height in pixels of the canvas image. options is a keyword list of options. Options See Image.embed/4 . Returns embedded_image or raises an exception.","ref":"Image.html#embed!/4"},{"type":"function","title":"Image.equalize/2","doc":"Equalizes the histogram of an imaage. Equalization is the process of expanding the tone range of an image by stretching the darkest tones towards black and the lightest tones towards white. As a result, equalization affects overall image contrast. Arguments image is any Vix.Vips.Image.t/0 . bands determines which bands are equalized. The value may be one of: :all (defaalt) means that all bands are eqalized such that the darkest tones are expanded to black and the lightest tones are expanded to white. :each means that each band is equalized individually such that each band is expanded to fill the range between 5% and 95% of the available tone range. Since each band is equalized separately there may be some color shifts detected. :luminance means that only the luminance band is equqlized to fill between 1% and 99% of the tone range. The image is converted to the :lab color space, the l band is equalized and the image is converted back to its origianal color space. Returns {:ok, adjusted_image} or {:error, reason} .","ref":"Image.html#equalize/2"},{"type":"function","title":"Image.equalize!/2","doc":"Apply a global contrast adjustment to an image or raises an exception. Equalization is the process of expanding the tone range of an image by stretching the darkest tones towards black and the lightest tones towards white. As a result, equalization affects overall image contrast. Arguments image is any Vix.Vips.Image.t/0 . bands determines which bands are equalized. The value may be one of: :all (defaalt) means that all bands are eqalized such that the darkest tones are expanded to black and the lightest tones are expanded to white. :each means that each band is equalized individually such that each band is expanded to fill the range between 5% and 95% of the available tone range. Since each band is equalized separately there may be some color shifts detected. :luminance means that only the luminance band is equqlized to fill between 1% and 99% of the tone range. The image is converted to the :lab color space, the l band is equalized and the image is converted back to its origianal color space. Returns adjusted_image or raises an exception.","ref":"Image.html#equalize!/2"},{"type":"function","title":"Image.erode/2","doc":"Erode an image mask, removing pixels from the edge of the mask. Mask is used in the sense of an image on a transparent background. The results on other image types is undefined. Note Erode works for any non-complex image type, with any number of bands. The input is expanded by copying edge pixels before performing the operation so that the output image has the same size as the input. Edge pixels in the output image are therefore only approximate. Arguments image is any Vix.Vips.Image.t/0 . pixels is a positive integer number of pixels to dilate. The default is 1 . Returns {:ok, eroded_mask} or {:error, reason}","ref":"Image.html#erode/2"},{"type":"function","title":"Image.erode!/2","doc":"Erode an image mask, removing pixels from the edge of the mask or raising an exception. Mask is used in the sense of an image on a transparent background. The results on other image types is undefined. Note Erode works for any non-complex image type, with any number of bands. The input is expanded by copying edge pixels before performing the operation so that the output image has the same size as the input. Edge pixels in the output image are therefore only approximate. Arguments image is any Vix.Vips.Image.t/0 . pixels is a positive integer number of pixels to dilate. The default is 1 . Returns eroded_mask or raises an exception","ref":"Image.html#erode!/2"},{"type":"function","title":"Image.exif/1","doc":"Returns the EXIF data for an image as a map. Only a subset of EXIF data is returned but its a substantial subset. Arguments image is any Vix.Vips.Image.t/0 Returns {:ok, exif_map} where exif_map is a map of selected EXIF data. {:error, reason}","ref":"Image.html#exif/1"},{"type":"function","title":"Image.feather/2","doc":"Feather (blur the edges) of an image mask. Applies a gaussian blur to a one-band image or the alpha band of a multi-band image that can be used to smooth the blending of one image into another. Arguments image is any Vix.Vips.Image.t/0 that is either a single band image or an image with an alpha band. options is a keyword list of options. Options :sigma is the float size of the mask to use. A larger number makes the image more blurry. A range between 1.0 and 10.0 is normally appropriate. The default is 5 . :min_amplitude is a float that determines the accuracy of the mask. The default is 0.2 . A smaller number will generate a larger, more accurate mask, Returns {:ok, blurred_mask_image} or {:error, reason}","ref":"Image.html#feather/2"},{"type":"function","title":"Image.feather!/2","doc":"Feather (blur the edges) of an image mask returning an image or raising an exception. Applies a gaussian blur to a one-band image or the alpha band of a multi-band image that can be used to smooth the blending of one image into another. Arguments image is any Vix.Vips.Image.t/0 that is either a single band image or an image with an alpha band. options is a keyword list of options. Options :sigma is the float size of the mask to use. A larger number makes the image more blurry. A range between 1.0 and 10.0 is normally appropriate. The default is 5 . :min_amplitude is a float that determines the accuracy of the mask. The default is 0.2 . A smaller number will generate a larger, more accurate mask, Returns {:ok, blurred_mask_image} or {:error, reason}","ref":"Image.html#feather!/2"},{"type":"function","title":"Image.fft/1","doc":"Returns the fast fourier transform (fft) of the given image. Arguments image is any Vix.Vips.Image.t/0 . Returns {:ok, fft_image} or {:error, reason} Example Image . fft ( image )","ref":"Image.html#fft/1"},{"type":"function","title":"Image.fft!/1","doc":"Returns the fast fourier transform (fft) of the given image returning an image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 . Returns fft_image or raises an exception Example Image . fft! ( image )","ref":"Image.html#fft!/1"},{"type":"function","title":"Image.filename/1","doc":"Returns the filename for an image. Arguments image is any Vix.Vips.Image.t/0 . Returns The pathname from which the image was opened or nil if there is no associated path. This can happen in the case of a streamed image or an image created from a memory buffer.","ref":"Image.html#filename/1"},{"type":"function","title":"Image.flatten/1","doc":"Flatten an alpha layer out of an image. Arguments image is any Vix.Vips.Image.t/0 . Returns {:ok, flattened_image} or {:error, reason}","ref":"Image.html#flatten/1"},{"type":"function","title":"Image.flatten!/1","doc":"Flatten an alpha layer out of an image or raises an exception. Arguments image is any Vix.Vips.Image.t/0 . Returns flattened_image or raises an exception","ref":"Image.html#flatten!/1"},{"type":"function","title":"Image.flip/2","doc":"Flip an image horizontally or vertically. Arguments image is any Vix.Vips.Image.t/0 . direction is either :horizontal or :vertical . Returns {:ok, flipped_image} or {:error, reason}","ref":"Image.html#flip/2"},{"type":"function","title":"Image.flip!/2","doc":"Flip an image horizontally or vertically returning a flipped image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 . direction is either :horizontal or :vertical . Returns flipped_image or raises an exception.","ref":"Image.html#flip!/2"},{"type":"function","title":"Image.from_binary/2","doc":"Returns an image created from an in-memory binary representation of an image. The binary must be a complete formatted image such as that returned from File.read!/1 . Arguments binary is a binary representation of a formatted image including .jpg , .png , .webp and .svg binary data. options is a keyword list of options. See Image.open/2 for the list of applicable options. Returns {:ok, image} or {:error, reason}","ref":"Image.html#from_binary/2"},{"type":"function","title":"Image.from_binary!/2","doc":"Returns an image created from an in-memory binary representation of an image or raises an exception. binary is a binary representation of a formatted image including .jpg , .png , .webp and .svg binary data. Arguments binary is a binary representation of a formatted image options is a keyword list of options. See Image.open/2 for the list of applicable options. Returns image or raises an exception.","ref":"Image.html#from_binary!/2"},{"type":"function","title":"Image.from_evision/1","doc":"Converts to an Image image from an Evision.Mat image. Arguments evision_image is any Evision.Mat image. Returns {:ok, image} Notes Image images have the shape {width, height, bands} whereas Evision images have the shape {height, width, bands} so this function transposes the dimensions to match. Image data is arranged as rgb data elements whereas Evision requires the data to be in bgr order. This function also reorders the data appropriately.","ref":"Image.html#from_evision/1"},{"type":"function","title":"Image.from_kino/2","doc":"Returns an image from a Kino image input. Arguments image is a a map returned from Kino.Input.read(image) via a Kino.Input.image/1 input field. The data will have the following fields: :data which contains the raw binary of the image :width which is the width of the image in pixels :height which is the height of the image in pixels :format which is the image band format which must be :rgb options is a keyword list of options Options :bands indicates the integer number of bands (channels) in the image. The default is 3 . Notes The image is assumed to contain pixel data that is in unsigned 8-bit format which is common for most web-oriented images. Returns {:ok, image} or {:error, reason}","ref":"Image.html#from_kino/2"},{"type":"function","title":"Image.from_kino!/2","doc":"Returns an image from a Kino image input or raises an exception. Arguments image is a a map returned from Kino.Input.read(image) via a Kino.Input.image/1 input field. The data will have the following fields: :data which contains the raw binary of the image :width which is the width of the image in pixels :height which is the height of the image in pixels :format which is the image band format which must be :rgb options is a keyword list of options Options :bands indicates the integer number of bands (channels) in the image. The default is 3 . Notes The image is assumed to contain pixel data that is in unsigned 8-bit format which is common for most web-oriented images. Returns {:ok, image} or raises an exception.","ref":"Image.html#from_kino!/2"},{"type":"function","title":"Image.from_nx/1","doc":"Converts an Nx tensor into an image. Arguments tensor is any three dimensional Nx.Tensor.t/0 . options is a keyword list of options. For valid options see Nx.from_binary/2 . Returns {:ok, image} or {:error, reason} Notes In order to convert a tensor into an image it must satisfy these constraints: It must have three dimensions. It must have a tensor type that is compatible with libvips (most tensors will satisfy this requirement other than tensors whose type is complex). The names of the axes must be [:width, :height, any_other] or [:height, :width, any_other] . Example iex&gt; { :ok , image } = Vix.Vips.Operation . black ( 3 , 3 ) iex&gt; { :ok , tensor } = Image . to_nx ( image ) iex&gt; { :ok , _image_2 } = Image . from_nx ( tensor )","ref":"Image.html#from_nx/1"},{"type":"function","title":"Image.from_svg/2","doc":"Returns an image created from an SVG string. Arguments svg is an SVG string. options is a keyword list of options. Options :access is the file access mode, either :random or :sequential . The default is :random . When :sequential , Image (via Vix ) is able to support streaming transformations and optimise memory usage more effectively. However :sequential also means that some operations cannot be completed because they would require non-sequential access to the image. In these cases, :random access is required. :fail_on sets the error level at which image loading and decoding will stop. The default is :none . Each error state implies all the states before it such that :error implies also :truncated . :scale will scale the image on load. The value is a number greater than 0 and less than or equal to 1024 with a default of 1.0 meaning no scaling on load. Numbers less than 1.0 scale the image down so that a scale of 0.5 will halve the image size on load. Returns {:ok, image} or {:error, reason}","ref":"Image.html#from_svg/2"},{"type":"function","title":"Image.from_svg!/2","doc":"Returns an image created from an SVG string or raises an exception. Arguments svg is an SVG string. options is a keyword list of options. Options :access is the file access mode, either :random or :sequential . The default is :random . When :sequential , Image (via Vix ) is able to support streaming transformations and optimise memory usage more effectively. However :sequential also means that some operations cannot be completed because they would require non-sequential access to the image. In these cases, :random access is required. :fail_on sets the error level at which image loading and decoding will stop. The default is :none . Each error state implies all the states before it such that :error implies also :truncated . :scale will scale the image on load. The value is a number greater than 0 and less than or equal to 1024 with a default of 1.0 meaning no scaling on load. Numbers less than 1.0 scale the image down so that a scale of 0.5 will halve the image size on load. Returns image or raises an exception.","ref":"Image.html#from_svg!/2"},{"type":"function","title":"Image.get_concurrency/0","doc":"Returns the number of operating system threads available for use by libvips . By default the number of threads will be the number of cores in the system. Since image processing is CPU intensive it may be appropriate to reduce the number of threads to be available to reduce the risk of CPU starvation for other workloads. See Image.put_concurrency/1 .","ref":"Image.html#get_concurrency/0"},{"type":"function","title":"Image.get_pixel/3","doc":"Returns the pixel value at the given image location. The returned pixel is a list of numbers where the length of the list is equal to the number of bands in the image. Arguments image is any Vix.Vips.Image.t/0 . x is an integer offset from the top left of the image along the x (width) axis. The number must be in the range 0..width - 1 . y is an integer offset from the top left of the image along the y (height) axis. The number must be in the range 0..height - 1 . Returns {:ok, pixel_value} or {:error, reason}","ref":"Image.html#get_pixel/3"},{"type":"function","title":"Image.get_pixel!/3","doc":"Returns the pixel value at the given image location or raises an exception. The returned pixel is a list of numbers where the length of the list is equal to the number of bands in the image. Arguments image is any Vix.Vips.Image.t/0 . x is an integer offset from the top left of the image along the x (width) axis. The number must be in the range 0..width - 1 . y is an integer offset from the top left of the image along the y (height) axis. The number must be in the range 0..height - 1 . Returns pixel_value or raises an exception","ref":"Image.html#get_pixel!/3"},{"type":"function","title":"Image.hamming_distance/3","doc":"Returns the hamming distance of two images or two image hashes. A hamming distance gives an indication of the similarity of two images. In general, a hamming distance of less than 10 indicates that the images are very similar. A distance of less than 20 suggests the images are quite similar. Any other distance suggests the images have little in common. Arguments image_1 is any Vix.Vips.Image.t/0 . image_2 is any Vix.Vips.Image.t/0 . Alternatively, both arguments may be image hashes returned by Image.dhash/1 . Both arguments must be of the same type. Returns {:ok, hamming_distance} where hamming distance is a positive integer or {:error, reason} .","ref":"Image.html#hamming_distance/3"},{"type":"function","title":"Image.has_alpha?/1","doc":"Returns a boolean based upon whether a given image has an alpha band. The determination is a heuristic so certainty cannot be guaranteed. Arguments image is any Vix.Vips.Image.t/0 . Returns true or false","ref":"Image.html#has_alpha?/1"},{"type":"function","title":"Image.height/1","doc":"Returns the height of an image. Arguments image is any Vix.Vips.Image.t/0 . Returns The image height as an integer.","ref":"Image.html#height/1"},{"type":"function","title":"Image.histogram/1","doc":"Returns the histogram for an image. The histogram is returned as a t:Vimage.t/0 that is a 255 by 255 image the same numbers of bands as the source image. Argument image is any Vix.Vips.Image.t/0 . Returns {:ok, histogram_image} or {:error, reason} Notes The returned image is is organized as a 256x256 pixel image with the same number of bands as the original image. Each pixel on the image returns the count of pixels in the original image that are in that 1/256th part of the image.","ref":"Image.html#histogram/1"},{"type":"function","title":"Image.if_then_else/4","doc":"Scans the condition_image cond and uses it to select pixels from either the if_image or the else_image . Non-zero means copy a pixel from if_image , 0 means copy a pixel from else_image . Arguments condition_image is any image. Typically it is an image formed by the relation operations such as Image.Math.greater_than/2 . if_image_or_color is either an t:Vimage.t/0 or a Image.Color.t/0 . If a color is provided then an image is constructed with the same shape as condition_image filled with the provided color. else_image_or_color is either an t:Vimage.t/0 or a Image.Color.t/0 . If a color is provided then an image is constructed with the same shape as condition_image filled with the provided color. options is a keyword list of options. Options :blend is a boolean indicating if a the operation should blend smoothly between then and else images. The default is false . Returns {:ok, image} or {:error, reason} . Notes Any image can have either 1 band or n bands, where n is the same for all the non-1-band images. Single band images are then effectively copied to make n-band images. Images if_image and else_image are cast up to the smallest common format. The condition_image is cast to {:u, 8} . If the images differ in size, the smaller images are enlarged to match the largest by adding zero pixels along the bottom and right. The output image is calculated pixel by pixel as: ( condition_image / 255 ) * if_image + ( 1 - condition_image / 255 ) * else_image","ref":"Image.html#if_then_else/4"},{"type":"function","title":"Image.if_then_else!/3","doc":"Scans the condition image cond and uses it to select pixels from either the if_image or the else_image . Raise an exception on error. Non-zero means copy a pixel from if_image , 0 means copy a pixel from else_image . Arguments condition_image is any image. Typically it is an image formed by the relation operations such as Image.Math.greater_than/2 . if_image_or_color is either an t:Vimage.t/0 or a Image.Color.t/0 . If a color is provided then an image is constructed with the same shape as condition_image filled with the provided color. else_image_or_color is either an t:Vimage.t/0 or a Image.Color.t/0 . If a color is provided then an image is constructed with the same shape as condition_image filled with the provided color. Returns image or raises an exception. Notes Any image can have either 1 band or n bands, where n is the same for all the non-1-band images. Single band images are then effectively copied to make n-band images. Images if_image and else_image are cast up to the smallest common format. The condition_image is cast to {:u, 8} . If the images differ in size, the smaller images are enlarged to match the largest by adding zero pixels along the bottom and right. The output image is calculated pixel by pixel as: ( condition_image / 255 ) * if_image + ( 1 - condition_image / 255 ) * ` else_image `","ref":"Image.html#if_then_else!/3"},{"type":"function","title":"Image.interpretation/1","doc":"Returns the image interpretation. The interpretation is how Image understands the image date. For example, :srgb or :cmyk or :bw . For most common web applications, the interpretation will be :srgb . Arguments image is any Vix.Vips.Image.t/0 Returns The image interpretation as an atom. Notes See also Image.Interpretation.known_interpretations/0","ref":"Image.html#interpretation/1"},{"type":"macro","title":"Image.is_box/4","doc":"Guards whether the coordinates can be reasonably interpreted as a bounding box. left and top when positive are relative to the left and top of the image respectively. When negative they are relative to the right and bottom of the image.","ref":"Image.html#is_box/4"},{"type":"macro","title":"Image.is_image/1","doc":"Guards whether the given struct is an image type either Vix.Vips.Image or Vix.Vips.MutableImage .","ref":"Image.html#is_image/1"},{"type":"macro","title":"Image.is_multiplier/1","doc":"Guards whether a value is a multiplier as representeed by a float greater than 0.0 .","ref":"Image.html#is_multiplier/1"},{"type":"macro","title":"Image.is_percent/1","doc":"Guards whether a value is a percentage as representeed by a float between -1.0 and 1.0 .","ref":"Image.html#is_percent/1"},{"type":"macro","title":"Image.is_pixel/1","doc":"Guards whether a term might be reasonably interpreted as an image pixel.","ref":"Image.html#is_pixel/1"},{"type":"macro","title":"Image.is_positive_percent/1","doc":"Guards whether a value is a positive percentage as representeed by a float greater than 0.0 and less than or equal to 1.0 .","ref":"Image.html#is_positive_percent/1"},{"type":"macro","title":"Image.is_rectangle/4","doc":"Guards whether a parameter is a rectangular bounding box. A rectangular bounding box is a list of four 2-tuples that must represent a rectangle (not an arbitrary quadrilateral), The order of points is top_left -&gt; top right -&gt; bottom right -&gt; bottm left.","ref":"Image.html#is_rectangle/4"},{"type":"macro","title":"Image.is_size/1","doc":"Guards whether a number can be reasonably interpreted as a size (as in size of a crop or mask)","ref":"Image.html#is_size/1"},{"type":"function","title":"Image.linear_gradient/3","doc":"Create an image gradient of the same size as the given image. The gradient will interpolate from the start value to the finish value. The default start value is black with 100% transparency. The default finish value is black with 100% opacity. start and finish are given as an rgb triplet or quadruplet list of integers between 0 and 255 . Arguments image is any Vix.Vips.Image.t/0 :start is an rgb triplet or quadruplet list of numbers between 0 and 255 . * :finish is an rgb triplet or quadruplet list of numbers between 0 and 255 . Returns {:ok, gradient_image} or {:error, reason} Example # transparent_black and opaque_black are the default # start and finish values transparent_black = [ 0 , 0 , 0 , 0 ] opaque_black = [ 0 , 0 , 0 , 255 ] { :ok , gradient } = Image . linear_gradient ( image , transparent_black , opaque_black )","ref":"Image.html#linear_gradient/3"},{"type":"function","title":"Image.linear_gradient!/3","doc":"Create an image gradient of the same size as the given image. Returns the gradient image or raises and exception. The gradient will interpolate from the start value to the finish value. The default start value is black with 100% transparency. The default finish value is black with 100% opacity. start and finish are given as an rgb triplet or quadruplet list of integers between 0 and 255 . Arguments image is any Vix.Vips.Image.t/0 :start is an rgb triplet or quadruplet list of numbers between 0 and 255 . * :finish is an rgb triplet or quadruplet list of numbers between 0 and 255 . Returns gradient_image or raises an exception. Example # transparent_black and opaque_black are the default # start and finish values transparent_black = [ 0 , 0 , 0 , 0 ] opaque_black = [ 0 , 0 , 0 , 255 ] gradient = Image . linear_gradient! ( image , transparent_black , opaque_black )","ref":"Image.html#linear_gradient!/3"},{"type":"function","title":"Image.local_contrast/2","doc":"Apply a local contrast adjustment to an image. This function applies a Constrast Limited Adaptive histogram equalization (AHE) to improve contrast in images. It differs from ordinary histogram equalization in the respect that the adaptive method computes several histograms, each corresponding to a distinct section of the image, and uses them to redistribute the lightness values of the image. It is therefore suitable for improving the local contrast and enhancing the definitions of edges in each region of an image, hence the name of the function. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options : window_size is an integer indicating the size of the window (in pixels) into the image in which the contrast adjustment is calculated. The default is 3 . :max_slope is the integral level of brightening, between 0 and 100, where 0 (the default) disables contrast limiting. Returns {:ok, adjusted_image} or {:error, reason} .","ref":"Image.html#local_contrast/2"},{"type":"function","title":"Image.local_contrast!/2","doc":"Apply a local contrast adjustment to an image or raises an exception. This function applies a Constrast Limited Adaptive histogram equalization (AHE) to improve contrast in images. It differs from ordinary histogram equalization in the respect that the adaptive method computes several histograms, each corresponding to a distinct section of the image, and uses them to redistribute the lightness values of the image. It is therefore suitable for improving the local contrast and enhancing the definitions of edges in each region of an image, hence the name of the function. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options : window_size is an integer indicating the size of the window (in pixels) into the image in which the contrast adjustment is calculated. The default is 3 . :max_slope is the integral level of brightening, between 0 and 100, where 0 (the default) disables contrast limiting. Returns adjusted_image or raises an exception.","ref":"Image.html#local_contrast!/2"},{"type":"function","title":"Image.map/3","doc":"Applies a transformation matrix to an image. A transformation matrix is returned by Image.transform_matrix/3 . Image.warp_perspective/4 uses this function to apply a perspective transform to an image. Arguments image is any t:Vimage.t/0 transform_matrix is a matrix returned by Image.transform_matrix/3 . Returns {:ok, mapped_image} or {:error, reason}","ref":"Image.html#map/3"},{"type":"function","title":"Image.meme/3","doc":"Create a meme image from a base image and one or two lines of text. The size of the text is determined by the size of the base image. Arguments image is any Vix.Vips.Image.t/0 over which the meme text will be composed. headline is the top line of the meme text. options is a keyword list of options. Options :text is the second line of text at the bottom of the meme image. The default is &quot;&quot; . :text_size is the size of the bottom text in points. The default is calculated proportional to the size of the image. :headline_size is the size of the headline text in points. The default is calculated proportional to the size of the image. :font is the name of the font family to be applied. The default is Impact . :font_file is the path name to a font file that will be loaded. The default is :default which will load the included Impact font if the font family is Impact . If the font family is not Impact and the :font_file is :default then the font displayed is resolved by the underlying operating system. If :font_file is a string, then it is expected to be a valid font file. If :font_file is set to a path then the :font option should also be set to the correct font name. :weight is the font weight to be rendered. The options are :ultralight , :light , :normal , :bold , :ultrabold , and :heavy . The default :bold . :transform determines how the text is presented. The options are :upcase , :downcase , :capitalize and :none . The default is :upcase . :color is an RGB color of the text. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. The default is :white . :outline_color is an RGB color of the text outline. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. The default is :black . :margin is the width of the margin in pixels. The margin is applied to both the left and right sides of the image. The default is calculated proportional to the size of the image.","ref":"Image.html#meme/3"},{"type":"function","title":"Image.meme!/3","doc":"Return a meme image from a base image and one or two lines of text or raise an exception. The size of the text is determined by the size of the base image. Arguments image is any Vix.Vips.Image.t/0 over which the meme text will be composed. headline is the top line of the meme text. options is a keyword list of options. Options :text is the second line of text at the bottom of the meme image. The default is &quot;&quot; . :text_size is the size of the bottom text in points. The default is calculated proportional to the size of the image. :headline_size is the size of the headline text in points. The default is calculated proportional to the size of the image. :font is the name of the font family to be applied. The default is Impact . If the font family name is &quot;Impact&quot; then the included unicode.impact.ttf font file will also be loaded. This ensures that the Impact font is available on all systems. :font_file is the path name to a font file that will be loaded. The default is :default which will load the included Impact font if the font family is Impact . If the font family is not Impact and the :font_file is :default then the font displayed is resolved by the underlying operating system. If :font_file is a string, then it is expected to be a valid font file. If :font_file is set to a path then the :font option should also be set to the correct font name. :weight is the font weight to be rendered. The options are :ultralight , :light , :normal , :bold , :ultrabold , and :heavy . The default :bold . :justify is a boolean indicating if the headline and text are to be justified. If true then space is added between words so that both edges of each line are aligned with both margins. The default is false . :transform determines how the text is presented. The options are :upcase , :downcase , :capitalize and :none . The default is :upcase . :color is an RGB color of the text. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. The default is :white . :outline_color is an RGB color of the text outline. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. The default is :black . :margin is the width of the margin in pixels. The margin is applied to both the left and right sides of the image. The default is calculated proportional to the size of the image.","ref":"Image.html#meme!/3"},{"type":"function","title":"Image.minimize_metadata/1","doc":"Minimize metadata by keeping only the artist and copyright (if available). Removing metadata from an image can greatly reduce the overall size of an image. The proportional reduction is most noticeable with smaller images which are very common in web applications. Removing all metadata is a common option however with intellectual property concerns in mind this function will keep the artist and copyright fields if they exist in the original image. On a 1000x500px image exported from Adobe Lightroom with metadata intact, removing the metadata results in am approximately 50% saving in file size due to the removal of most EXIF and all IPTC and XMP metadata. Note that the minimized metadata is only materialized when the minimized image is saved to a file. Arguments image is any Vix.Vips.Image.t/0 Returns {:ok, image_with_minimal_metadata} or {:error, reason}","ref":"Image.html#minimize_metadata/1"},{"type":"function","title":"Image.minimize_metadata!/1","doc":"Minimize metadata by keeping only the artist and copyright (if available). See also Image.minimize_metadata/1 . Arguments image is any Vix.Vips.Image.t/0 Returns image_with_minimal_metadata or raises an exception.","ref":"Image.html#minimize_metadata!/1"},{"type":"function","title":"Image.modulate/2","doc":"Transforms an image using brightness, saturation, hue rotation, and lightness. Brightness and lightness both operate on luminance, with the difference being that brightness is multiplicative whereas lightness is additive. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :brightness is any float greater than 0.0 . A number less than 1.0 means reduce brightness. A number greater than 1.0 means increas brightness. The default is 1.0 meaning no brightness adjustment. :lightness is any float. This value is added to the luminance of an image. This is different to :brightness which is multuplied by the luminance. The default is 0.0 meaning no lightness adjustment. :saturation is any float greater than 0.0 . A number less than 1.0 means reduce saturation. A number greater than 1.0 means increas saturation. The default is 1.0 meaning no saturation adjustment. :hue is an integer angle in degrees added to the hue. This is often referred to as the hug angle and the operation as adjusting the hue rotation . The value should typically be in the range 0..360 . The default is 0 meaning no hue adjustment. Returns {:ok, modulated_image} or {:error, reason} .","ref":"Image.html#modulate/2"},{"type":"function","title":"Image.modulate!/2","doc":"Transforms an image using brightness, saturation, hue rotation, and lightness or raises an exception. Brightness and lightness both operate on luminance, with the difference being that brightness is multiplicative whereas lightness is additive. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :brightness is any float greater than 0.0 . A number less than 1.0 means reduce brightness. A number greater than 1.0 means increas brightness. The default is 1.0 meaning no brightness adjustment. :lightness is any float. This value is added to the luminance of an image. This is different to :brightness which is multuplied by the luminance. The default is 0.0 meaning no lightness adjustment. :saturation is any float greater than 0.0 . A number less than 1.0 means reduce saturation. A number greater than 1.0 means increas saturation. The default is 1.0 meaning no saturation adjustment. :hue is an integer angle in degrees added to the hue. This is often referred to as the hug angle and the operation as adjusting the hue rotation . The value should typically be in the range 0..360 . The default is 0 meaning no hue adjustment. Returns modulated_image or raises an exception.","ref":"Image.html#modulate!/2"},{"type":"function","title":"Image.mutate/2","doc":"Mutate an image with through the given function. Mutations, like those functions in the Image.Draw , module are operations on a copy of the base image and operations are serialized through a genserver in order to maintain thread safety. In order to perform multiple mutations without coopying for each each mutation, Image.mutate/2 takes a function argument fun that is passed a Vix.Vips.MutableImage.t/0 as a parameter. In that way several mutations can be safely applied withouout copying the image prior to each mutation. Although the image is not copied before each mutuation, each mutable operation is still serialized behind a genserver to ensure thread safety. The functions in Image.Draw all support either a Vix.Vips.Image.t/0 or a Vix.Vips.MutableImage.t/0 as the image parameter. When the parameter fun returns, the mutation process is ended and a normal Vix.Vips.Image.t/0 is returned. This function is a convenience wrapper around Vix.Vips.Image.mutate/2 . Arguments image is any Vix.Vips.Image.t/0 . fun is any 1-arity function that receives a Vix.Vips.MutableImage.t/0 parameter. Returns {:ok, mutated_image} or {:error, reason} Example # The image is copied and operations # are serialized behind a genserver. # Only one copy is made but all operations # will be serialized behind a genserver. # When the function returns the genserver # is broken down and the underlying # mutated `t:Vix.Vips.Image.t/0` is returned. Image . mutate image , fn mutable_image -&gt; mutable_image |&gt; Image.Draw . rect! ( 0 , 0 , 10 , 10 , color : :red ) |&gt; Image.Draw . rect! ( 10 , 10 , 20 , 20 , color : :green ) end","ref":"Image.html#mutate/2"},{"type":"function","title":"Image.new/1","doc":"Create a new image of the same shape as the provided image. The function creates a new image with the same width, height and bands as the image argument. Arguments image is any Vix.Vips.Image.t/0 from which the new images width and height and bands will be derived. options is a keyword list of options. Options :bands defines the number of bands (channels) to be created. The default is the number of bands in image . :color defines the color of the image. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The default is 0 , meaning black. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . :format defines the format of the image. The default is {:u, 8} . :interpretation defines the interpretation of the image. The default is :srgb . Returns {:ok, image} or {:error, reason}","ref":"Image.html#new/1"},{"type":"function","title":"Image.new/2","doc":"Create a new image of the given dimensions. Arguments Either width and height OR image should be provided. width is the image width as an integer. height is the image height as an integer. image is an image from which the width , height are derived. options is a keyword list of options. Options :color defines the color of the image. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The default is 0 , meaning black. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . :bands defines the number of bands (channels) to be created. The default is the number of bands of :color option or if :color is an integer then the default value is 3 . :format defines the format of the image. The default is {:u, 8} . :interpretation defines the interpretation of the image. The default is :srgb . Returns {:ok, image} or {:error, reason} Notes Either width and height OR image should be provided as arguments but NOT both. Examples # 100x100 pixel image of dark blue slate color iex&gt; { :ok , _image } = Image . new ( 100 , 100 , color : :dark_slate_blue ) # 100x100 pixel green image, fully transparent iex&gt; { :ok , _image } = Image . new ( 100 , 100 , color : [ 0 , 255 , 0 , 255 ] , bands : 4 )","ref":"Image.html#new/2"},{"type":"function","title":"Image.new/3","doc":"","ref":"Image.html#new/3"},{"type":"function","title":"Image.new!/1","doc":"Return a new image of the same shape as the provided image or raise an exception. The function creates a new image with the same width, height and bands as the image argument. Arguments image is any Vix.Vips.Image.t/0 from which the new images width and height and bands will be derived. options is a keyword list of options. Options :bands defines the number of bands (channels) to be created. The default is the number of bands in image . :color defines the color of the image. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The default is 0 , meaning black. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . :format defines the format of the image. The default is {:u, 8} . :interpretation defines the interpretation of the image. The default is :srgb . Returns {:ok, image} or {:error, reason}","ref":"Image.html#new!/1"},{"type":"function","title":"Image.new!/2","doc":"Return a new image of the given dimensions and background color or raise an exception. Arguments Either width and height OR image should be provided. width is the image width as an integer. height is the image height as an integer. image is an image from which the width , height re derived. options is a keyword list of options. Options :bands defines the number of bands (channels) to be created. The default is 3 . :color defines the color of the image. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The default is 0 , meaning black. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . :format defines the format of the image. The default is {:u, 8} . :interpretation defines the interpretation of the image. The default is :srgb . Returns {:ok, image} or {:error, reason} Notes Either width and height OR image should be provided as arguments but NOT both. Examples # 100x100 pixel image of dark blue slate color iex&gt; { :ok , _image } = Image . new ( 100 , 100 , color : :dark_slate_blue ) # 100x100 pixel green image, fully transparent iex&gt; { :ok , _image } = Image . new ( 100 , 100 , color : [ 0 , 255 , 0 , 1 ] , bands : 4 )","ref":"Image.html#new!/2"},{"type":"function","title":"Image.new!/3","doc":"","ref":"Image.html#new!/3"},{"type":"function","title":"Image.open/2","doc":"Opens an image file or stream for image processing. Arguments image_path_or_stream_or_binary is the file system path to an image file or a File.Stream.t/0 or any Enumerable.t/0 . It can also be any binary .jpg , .png , .webp or .svg image. options is a keyword list of options. The default is [access: :random] for all images except images derived from binary image data. Options The available options depend upon the image type. All image types :access is the file access mode, either :random or :sequential . The default is :random . When :sequential , Image (via Vix ) is able to support streaming transformations and optimise memory usage more effectively. However :sequential also means that some operations cannot be completed because they would require non-sequential access to the image. In these cases, :random access is required. :fail_on sets the error level at which image loading and decoding will stop. The default is :none . Each error state implies all the states before it such that :error implies also :truncated . JPEG image options :shrink is an integer factor in the range 1..16 by which the image is reduced upon loading. This is an optimization that can result in improved performance and reduced memory usage if the image is being loaded with the intent to resize it to smaller dimensions. The default value is 1 meaning no shrink-on-load. :autorotate is a boolean value indicating if the image should be rotated according to the orientation data stored in the image metadata. The default is false . WEBP options :scale will scale the image on load. The value is a number greater than 0 and less than or equal to 1024 with a default of 1 meaning no scaling on load. Numbers less than 1.0 scale the image down so that a scale of 0.5 will halve the image size on load. :page indicates the first page to be loaded. The value is in the range 0..100_000 with a default value of 0 . This parameter is useful on animated images. :pages indicates the number of pages to load. The value must be between -1 and 100_000 . The default value is 1 . A value of -1 would load all the available pages which is useful if you want to keep the animation of the input image. TIFF options :autorotate is a boolean value indicating if the image should be rotated according to the orientation data stored in the image metadata. The default is false . :page indicates the first page to be loaded. The value is in the range 0..100_000 with a default value of 0 . This parameter is useful on animated images. :pages indicates the number of pages to load. The value must be between -1 and 100_000 . The default value is 1 . A value of -1 would load all the available pages which is useful if you want to keep the animation of the input image. PNG options There are no PNG-specific image loading options. GIF options :page indicates the first page to be loaded. The value is in the range 0..100_000 with a default value of 0 . This parameter is useful on animated images. :pages indicates the number of pages to load. The value must be between -1 and 100_000 . The default value is 1 . A value of -1 would load all the available pages which is useful if you want to keep the animation of the input image. Returns {:ok, image} or {:error, message}","ref":"Image.html#open/2"},{"type":"function","title":"Image.open!/2","doc":"Opens an image file for image processing returning an image or raising an exception. Arguments image_path_or_stream_or_binary is the file system path to an image file or a File.Stream.t/0 or any Enumerable.t/0 . It can also be any binary .jpg , .png , .webp or .svg image. options is a keyword list of options. The default is [access: :random] for all images except images derived from binary image data. Returns image or raises an exception.","ref":"Image.html#open!/2"},{"type":"function","title":"Image.p/1","doc":"Outputs an inline preview of an image to an iTerm2 terminal. Only iTerm2 terminal windows are supported. Delegates to Image.preview/1 Arguments image is any Vix.Vips.Image.t/0 . Notes The function Image.p/1 is delegated to this function. The maximum width of the preview can be set by the environment variable IMAGE_PREVIEW_MAX_WIDTH . The default is 1_000 pixels wide. If the width of the image is greater than the maximum it will be resized to the maximum width for the preview. Intended to be used as shortcut in iex . It can be included in .iex.exs file: # .iex.exs import_if_available(Image, only: [p: 1])","ref":"Image.html#p/1"},{"type":"function","title":"Image.pixelate/2","doc":"Pixelates an image. Pixelation is the process of reducing the image resolution while retaining the image dimensions. Arguments image is any Vix.Vips.Image.t/0 . scale is the scale factor to apply to the image when it is pixelated. This means that one &quot;pixel&quot; is image width * scale . The default is 0.05 . Returns {:ok, pixelated_image} or {:error, reason}","ref":"Image.html#pixelate/2"},{"type":"function","title":"Image.pixelate!/2","doc":"Pixelates an image or raise an exception. Pixelation is the process of reducing the image resolution while retaining the image dimensions. Arguments image is any Vix.Vips.Image.t/0 . scale is the scale factor to apply to the image when it is pixelated. This means that one &quot;pixel&quot; is image width * scale . The default is 0.05 . Returns {:ok, pixelated_image} or {:error, reason}","ref":"Image.html#pixelate!/2"},{"type":"function","title":"Image.preview/1","doc":"Outputs an inline preview of an image to an iTerm2 terminal. Only iTerm2 terminal windows are supported. Arguments image is any Vix.Vips.Image.t/0 or a tuple of the form {:ok, image} . Returns The image parameter as provided with the side effect of emitting an image preview on an iTerm terminal. Notes The function Image.p/1 is delegated to this function. The maximum width of the preview can be set by the environment variable IMAGE_PREVIEW_MAX_WIDTH . The default is 1_000 pixels wide. If the width of the image is greater than the maximum it will be resized to the maximum width for the preview. Intended to be used as shortcut in iex . It can be included in an .iex.exs file: # .iex.exs import_if_available(Image, only: [preview: 1])","ref":"Image.html#preview/1"},{"type":"function","title":"Image.put_concurrency/1","doc":"Sets the number of available threads for use by libvips . By default this is the same as the number of cores in the system. Reducing this number may prevent CPU starvation for other workloads. Arguments concurrency is a positive integer denoting the maximum number of threads that libvips will use for concurrency. Returns {:ok, updated_concurrency}","ref":"Image.html#put_concurrency/1"},{"type":"function","title":"Image.radial_gradient/3","doc":"Returns a radial gradient as an image. This image might then be composited over another image. Arguments width is the width of the gradient in pixels. height is the height of the gradient in pixels. options is a keyword list of options. The default is [] . Options :start is the color from which the gradient starts in the center of the image. :finish is the color at which the gradient finishes at the end of the gradient. :feather is the slope of the gradient. That it, how quickly the gradient moves from the :start color to the :finish color. The valid range is 1..10 representing the smallest amount of feather (harshest transition) to the largest amount of feather (smoothest transition). Returns {:ok, gradient_image} or {:error, reason}","ref":"Image.html#radial_gradient/3"},{"type":"function","title":"Image.range/1","doc":"Returns the range of permissable values as a tuple for each pixel in an image. Arguments image is any Vix.Vips.Image.t/0 . Returns {min_value, max_value} where min_value and max_value are integers for unsigned images and floats for signed images. Examples iex&gt; image = Image . open! ( &quot;./test/support/images/Singapore-2016-09-5887.jpg&quot; ) iex&gt; Image . range ( image ) { 0 , 255 }","ref":"Image.html#range/1"},{"type":"function","title":"Image.reduce_noise/2","doc":"Reduces noise in an image by applying a median filter. The implementation uses a median rank filter based on ordering the pixel values under a convolution kernel of a given window size and extracting the median value. The result is appropriate for removing salt and pepper noise and may be useful for smoothing gaussian noise in some cases. Arguments image is any Vix.Vips.Image.t/0 . window_size is the integer size of the convolution kernel use in the median rank filter. The default is 3 . Returns {:ok, reduced_noise_image} or {:error, reason}","ref":"Image.html#reduce_noise/2"},{"type":"function","title":"Image.reduce_noise!/2","doc":"Reduces noise in an image by applying a median filter or raises an exception. The implementation uses a median rank filter based on ordering the pixel values under a convolution kernel of a given window size and extracting the median value. The result is appropriate for removing salt and pepper noise and may be useful for smoothing gaussian noise in some cases. Arguments image is any Vix.Vips.Image.t/0 . window_size is the integer size of the convolution kernel use in the median rank filter. The default is 3 . Returns reduced_noise_image or raises an exception.","ref":"Image.html#reduce_noise!/2"},{"type":"function","title":"Image.remove_metadata/2","doc":"Remove metadata from an image returning an updated image or raising an exception. This can significantly reduce the size of an image file. Arguments image is any Vix.Vips.Image.t/0 fields is a list of metadata field names as strings. The default is all known field names. There are some special field names interpreted by Image to simplify metadata removal these are: :exif which means remove all EXIF metadata :iptc which means remove all IPTC metadata :xmp which means remove all xmp data Notes The available field names (ie. metadata fields) in an image can be returned with a call to Vix.Vips.Image.header_field_names/1 . Errors removing metadata fields is not propagated into the return for this function. Errors might occur when attempting to remove metadata fields that do not exist in the image. Returns {:ok, image_without_metadata_fields} or {:error, reason}","ref":"Image.html#remove_metadata/2"},{"type":"function","title":"Image.remove_metadata!/2","doc":"Remove metadata from an image returning an image or raising an exception. This can significant;y reduce the size of an image file. Arguments image is any Vix.Vips.Image.t/0 fields is a list of metadata field names as strings. The default is all known field names. There are some special field names interpreted by Image to simplify metadata removal these are: :exif which means remove all EXIF metadata :iptc which means remove all IPTC metadata :xmp which means remove all xmp data Notes The available field names (ie. metadata fields) in an image can be returned with a call to Vix.Vips.Image.header_field_names/1 . Errors removing metadata fields is not propagated into the return for this function. Errors might occur when attempting to remove metadata fields that do not exist in the image. Returns image_without_metadata_fields or raises an exception.","ref":"Image.html#remove_metadata!/2"},{"type":"function","title":"Image.replace_color/2","doc":"Replace one color in an image with another. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options With the exception of the option :replace_with , the options for specifying the color or color range to be replaced are passed to Image.chroma_mask/2 . :blend is a boolean indicating if a the replacement should blend at the border of the color replacement. The default is false . :replace_with is the replacement color. This can be specified as a single integer which wil be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . It can also be supplied as a hex string of the form #rrggbb . The default is :black . See also Image.Color.color_map/0 and Image.Color.validate_color/1 . There are two strategies available for selecting the color or color range to be replaced: the thresholding strategy (default) and the color range strategy. Threshold strategy :color is an RGB color which represents the the chroma key to be selected. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. The default is :auto in which the average of the top left 10x10 pixels of the image is used. :threshold is a positive integer to indicate the threshold around :color when calculating the mask. The default is 20 . Color range strategy :greater_than is an RGB color which represents the upper end of the color range to be selected. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. :less_than is an RGB color which represents the lower end of the color range to be selected. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. Returns {:ok, image} or {:error, reason} .","ref":"Image.html#replace_color/2"},{"type":"function","title":"Image.replace_color!/2","doc":"Replace one color in an image with another or raises an exception. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options With the exception of the option :replace_with , the options for specifying the color or color range to be replaced are passed to Image.chroma_mask/2 . :replace_with is the replacement color. This can be specified as a single integer which wil be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . It can also be supplied as a hex string of the form #rrggbb . The default is :black . See also Image.Color.color_map/0 and Image.Color.validate_color/1 . There are two strategies available for selecting the color or color range to be replaced: the thresholding strategy (default) and the color range strategy. Threshold strategy :color is an RGB color which represents the the chroma key to be selected. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. The default is :auto in which the average of the top left 10x10 pixels of the image is used. :threshold is a positive integer to indicate the threshold around :color when calculating the mask. The default is 20 . Color range strategy :greater_than is an RGB color which represents the upper end of the color range to be selected. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. :less_than is an RGB color which represents the lower end of the color range to be selected. The color can be an integer between 0..255 , a three-element list of integers representing an RGB color or an atom representing a CSS color name. Returns image or raises an exception.","ref":"Image.html#replace_color!/2"},{"type":"function","title":"Image.resize/3","doc":"Resize an image. If the intent is to thumbnail an image then Image.thumbnail/3 is recommended since it applies a very efficient downsizing algorithm for that use case. Arguments image is any Vix.Vips.Image.t/0 . scale is a float scale factor. options is a keyword list of options. Options :centre is a boolean indicating whether to use the centre downsampling convention. The default is false . :interpolate defines which resampling kernel to apply. The options are :nearest , :linear , :cubic , :mitchell , :lanczos2 or :lanczos3 (the default). Returns {:ok, resized_image} or raises an exception","ref":"Image.html#resize/3"},{"type":"function","title":"Image.resize!/3","doc":"Resize an image or raise an exception. If the intent is to thumbnail an image then Image.thumbnail/3 is recommended since it applies a very efficient downsizing algorithm for that use case. Arguments image is any Vix.Vips.Image.t/0 . scale is a float scale factor. options is a keyword list of options. Options :centre is a boolean indicating whether to use the centre downsampling convention. The default is false . :interpolate defines which resampling kernel to apply. The options are :nearest , :linear , :cubic , :mitchell , :lanczos2 or :lanczos3 (the default). Returns resized_image or raises an exception","ref":"Image.html#resize!/3"},{"type":"function","title":"Image.ripple/1","doc":"Adds a concentric ripple effect to an image. Arguments image is any Vix.Vips.Image.t/0 . Returns {:ok, image_with_ripple} or {:error, reason}","ref":"Image.html#ripple/1"},{"type":"function","title":"Image.ripple!/1","doc":"Adds a concentric ripple effect to an image returning an image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 . Returns image_with_ripple or raises an exception.","ref":"Image.html#ripple!/1"},{"type":"function","title":"Image.rotate/3","doc":"Rotate an image clockwise (to the right) by a number of degrees. Arguments image is any Vix.Vips.Image.t/0 . angle is a float number of degrees to rotate in a clockwise direction. options is a keyword list of options. Options :idy is the vertical input displacement which defaults to 0.0 :idx is the horizontal input displacement which defaults to 0.0 :ody is the vertical output displacement which defaults to 0.0 :odx is the horizontal output displacement which defaults to 0.0 :background is the background color to be used for filling the blank areas of the image. The background is specified as a list of 3 or 4 float values depending on the image color space. Notes The displacement parameters cause the image canvas to be expanded and the image displaced, relative to the top left corner of the image, by the amount specified. The rules defining how the image canvas is expanded is not known to the author of Image . Experimentation will be required if you explore these options. Returns {:ok, rotated_image} or {:error, reason}","ref":"Image.html#rotate/3"},{"type":"function","title":"Image.rotate!/3","doc":"Rotate an image clockwise (to the right) by a number of degrees. Arguments image is any Vix.Vips.Image.t/0 . angle is a float number of degrees to rotate in a clockwise direction. options is a keyword list of options. See Image.rotate/3 . Notes The displacement parameters cause the image canvas to be expanded and the image displaced, relative to the top left corner of the image, by the amount specified. The rules defining how the image canvas is expanded is not known to the author of Image . Experimentation will be required if you explore these options. Returns rotated_image or raises an exception.","ref":"Image.html#rotate!/3"},{"type":"function","title":"Image.rounded/2","doc":"Apply rounded corners to an image. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :radius is the desired corner radius. The default is 50. Returns {:ok, rounded_corner_image} or {:error, reason}","ref":"Image.html#rounded/2"},{"type":"function","title":"Image.rounded!/2","doc":"Apply rounded corners to an image. Returns an image or raises an exception. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :radius is the desired corner radius. The default is 50. Returns rounded_corner_image or raises an exception.","ref":"Image.html#rounded!/2"},{"type":"function","title":"Image.saturation/2","doc":"Apply an adjustment to an image's saturation (chroma). The image is converted to the lch color space, multiplies the chroma band by the provided float and converts the image back to its original color space. Arguments image is any Vix.Vips.Image.t/0 . saturation is any float greater than 0.0 . A number less than 1.0 means reduce saturation. A number greater than 1.0 means increas saturation. Returns {:ok, adjusted_image} or {:error, reason} .","ref":"Image.html#saturation/2"},{"type":"function","title":"Image.saturation!/2","doc":"Apply an adjustment to an image's saturation (chroma) or raises an exception. The image is converted to the lch color space, multiplies the chroma band by the provided float and converts the image back to its original color space. Arguments image is any Vix.Vips.Image.t/0 . saturation is any float greater than 0.0 . A number less than 1.0 means reduce saturation. A number greater than 1.0 means increas saturation. Arguments image is any Vix.Vips.Image.t/0 . saturation is any float greater than 0.0 . A number less than 1.0 means reduce saturation. A number greater than 1.0 means increas saturation. Returns adjusted_image or raises an exception.","ref":"Image.html#saturation!/2"},{"type":"function","title":"Image.shape/1","doc":"Returns the shape of an image. Arguments image is any Vix.Vips.Image.t/0 . Returns The image shape as a tuple of {width, height, bands} .","ref":"Image.html#shape/1"},{"type":"function","title":"Image.sharpen/2","doc":"Sharpens an image. Selectively sharpens the L channel of a LAB image. image is converted to :labs for sharpening and the converted back to its original interpretation. The operation performs a gaussian blur and subtracts from image to generate a high-frequency signal. This signal is passed through a lookup table formed from the five parameters and then added back to image . The lookup table is formed like this: ^ y2 | -- -- -- -- -- - | / | / slope m2 | ... / - x1 | ... | -- -- -- -- -- -- -- -- -- - ... -- -- -- -- -- -- -- -- -- -- -- &gt; | ... | x1 | ... slope m1 / | / m2 | / | / | / | / | ______ / | - y3 | Where: m1 is :flat_amount m2 is :jagged_amount x1 is :threshold y2 is :max_brightening y3 is :max_darkening Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :jagged_amount is the primary means of specifing how much sharpening to apply. Shaprening is applied to the jagged areas of the image. It is a float greater or equal to 0.0 with a default of 3.0 . :flat_amount is the specifies how much sharpening to apply to flat areas of the image. It is a float greater or equal to 0.0 with a default of 0.0 . :threshold indicates where the transition from the flat part of the image to the jaggy part of the image is to be considered on the curve. It is a float amount greater than or equal to 0.0 with a default of 2.0 . :max_brightening specifies how much the image may be brightened as part of the sharpening process. It is a positive integer greater than or equal to 0 . The default is 10 . :max_darkening specifies how much the image may be darkened as part of the sharpening process. It is a positive integer greater than or equal to 0 . The default is 20 . :sigma changes the width of the sharpening fringe and can be adjusted according to the output printing resolution. As an approximate guideline, use 0.5 for 4 pixels/mm (display resolution), 1.0 for 12 pixels/mm and 1.5 for 16 pixels/mm (300 dpi == 12 pixels/mm). These figures refer to the image raster, not the half-tone resolution. The default is 0.5 . Returns {:ok, sharpened_image} or {:error reason} Output sharpening For screen output sharpening the default options are recommended. Adjust :sigma for other output devices as required.","ref":"Image.html#sharpen/2"},{"type":"function","title":"Image.sharpen!/2","doc":"Sharpens an image or raises an exception. Selectively sharpens the L channel of a LAB image. image is converted to :labs for sharpening and the converted back to its original interpretation. The operation performs a gaussian blur and subtracts from image to generate a high-frequency signal. This signal is passed through a lookup table formed from the five parameters and then added back to image . The lookup table is formed like this: ^ y2 | -- -- -- -- -- - | / | / slope m2 | ... / - x1 | ... | -- -- -- -- -- -- -- -- -- - ... -- -- -- -- -- -- -- -- -- -- -- &gt; | ... | x1 | ... slope m1 / | / m2 | / | / | / | / | ______ / | - y3 | Where: m1 is :flat_amount m2 is :jagged_amount x1 is :threshold y2 is :max_brightening y3 is :max_darkening Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :jagged_amount is the primary means of specifing how much sharpening to apply. Shaprening is applied to the jagged areas of the image. It is a float greater or equal to 0.0 with a default of 3.0 . :flat_amount is the specifies how much sharpening to apply to flat areas of the image. It is a float greater or equal to 0.0 with a default of 0.0 . :threshold indicates where the transition from the flat part of the image to the jaggy part of the image is to be considered on the curve. It is a float amount greater than or equal to 0.0 with a default of 2.0 . :max_brightening specifies how much the image may be brightened as part of the sharpening process. It is a positive integer greater than or equal to 0 . The default is 10 . :max_darkening specifies how much the image may be darkened as part of the sharpening process. It is a positive integer greater than or equal to 0 . The default is 20 . :sigma changes the width of the sharpening fringe and can be adjusted according to the output printing resolution. As an approximate guideline, use 0.5 for 4 pixels/mm (display resolution), 1.0 for 12 pixels/mm and 1.5 for 16 pixels/mm (300 dpi == 12 pixels/mm). These figures refer to the image raster, not the half-tone resolution. The default is 0.5 . Returns sharpened_image or raises an exception. Output sharpening For screen output sharpening the default options are recommended. Adjust :sigma for other output devices as required.","ref":"Image.html#sharpen!/2"},{"type":"function","title":"Image.skew_angle/1","doc":"Attempts top determine the distance from the perpendicular for a given image. The principle is that rotating the image by the skew angle should return an image in the upright position. The results are very image sensitive and perfect results are not guaranteed. The algorithm is an implementation of this stackoverflow post . Arguments image is any Vix.Vips.Image.t/0 . Returns skew_angle which is a float number of degrees the image is tilted from the upright. Example skew_angle = skew_angle ( image ) Image . rotate ( image , skew_angle )","ref":"Image.html#skew_angle/1"},{"type":"function","title":"Image.split_alpha/1","doc":"Split an image to separate the alpha band from the other image bands. Arguments image is any Vix.Vips.Image.t/0 . Returns {image_bands_without_alpha, alpha_band} or {:image_bands, nil} if there is not alpha band detected.","ref":"Image.html#split_alpha/1"},{"type":"function","title":"Image.split_bands/1","doc":"Split the image into a list of its component bands. Arguments image is any Vix.Vips.Image.t/0 . Returns a list of single band images extracted from image .","ref":"Image.html#split_bands/1"},{"type":"function","title":"Image.straighten_perspective/3","doc":"Performs a warp perspective transformation on an image to straighten its perspective. Requires Nx to be configured as a dependency. Arguments image is any t:Vimage.t/0 source is a list of four 2-tuples representing the four corners of the subject-of-interest in image . options is a keyword list of options. The default is [] . Options :background defines the color of any generated background pixels. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . It can also be supplied as a hex string of the form #rrggbb . The default is :black . :background can also be set to :average in which case the background will be the average color of the base image. See also Image.Color.color_map/0 and Image.Color.rgb_color/1 . :extend_mode determines how any additional pixels are generated. The values are: :black (the default) meaning the generated pixels are black. :white meaning the generated pixels are white. :copy means the generated pixels take the value of the nearest edge pixel of the base image. :repeat means the generated pixels are tiles from the base image. :mirror means the generated pixels are a reflected tiles of the base image. :background means the generated pixels are the background color setin options . Returns {:ok, destination, straightened_image} or {:error, reason} Notes The image is flattened before warping and therefore any alpha band will be multiplied into to the image data and removed. The returned destination is a four element list of 2-tuples representing the four points to which the source points were transformed. destination can be passed as a parameter to Image.crop/2 to crop the transformed image to the subject-of-interest that was warped.","ref":"Image.html#straighten_perspective/3"},{"type":"function","title":"Image.straighten_perspective!/3","doc":"Performs a warp perspective transformation on an image to straighten its perspective or raises an exception. Requires Nx to be configured as a dependency. Arguments image is any t:Vimage.t/0 source is a list of four 2-tuples representing the four corners of the subject-of-interest in image . options is a keyword list of options. The default is [] . Options :background defines the color of any generated background pixels. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . It can also be supplied as a hex string of the form #rrggbb . The default is :black . :background can also be set to :average in which case the background will be the average color of the base image. See also Image.Color.color_map/0 and Image.Color.rgb_color/1 . :extend_mode determines how any additional pixels are generated. The values are: :black (the default) meaning the generated pixels are black. :white meaning the generated pixels are white. :copy means the generated pixels take the value of the nearest edge pixel of the base image. :repeat means the generated pixels are tiles from the base image. :mirror means the generated pixels are a reflected tiles of the base image. :background means the generated pixels are the background color setin options . Returns straightened_image or {:error, reason} Notes The image is flattened before warping and therefore any alpha band will be multiplied into to the image data and removed. The returned destination is a four element list of 2-tuples representing the four points to which the source points were transformed. destination can be passed as a parameter to Image.crop/2 to crop the transformed image to the subject-of-interest that was warped.","ref":"Image.html#straighten_perspective!/3"},{"type":"function","title":"Image.stream!/2","doc":"Convert an image into an enumerable stream. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :buffer_size is the size in bytes for each chunk in the stream being written. Some services, like AWS S3, require a minimum 5 MiB per chunk to be delivered and this option can be used to satisfy that requirement. For additional options see Image.write/3 . Returns An Enumerable.t/0 suitable for streaming to an external service such as S3, Minio or any other enumerable consumer. S3 and Buffer Size You may get an error from S3 if you do not specify a buffer size. EntityTooSmall: Your proposed upload is smaller than the minimum allowed object size. Since AWS S3 requires multipart uploads to be 5MiB per chunk, we specify the :buffer_size option to Image.stream!/2 . Example In this example an image is opened, resized and then streamed into AWS S3: &quot;some/image.jpg&quot; |&gt; Image . open! ( ) |&gt; Image . resize! ( 200 ) |&gt; Image . stream! ( suffix : &quot;.jpg&quot; , buffer_size : 5_242_880 ) |&gt; ExAws.S3 . upload ( &quot;images&quot; , &quot;some_object_name.jpg&quot; ) |&gt; ExAws . request ( )","ref":"Image.html#stream!/2"},{"type":"function","title":"Image.thumbnail/3","doc":"Thumbnail an image to fit or fill a bounding box. Arguments image is any Vix.Vips.Image.t/0 or a pathname to an image file. length is the integer length of the longest side of the resulting image after resizing. It can also be of the form &quot;&lt;width&gt;x&lt;height&gt;&quot;. That is, a string with the width and height separated by an x . The &lt;height&gt; may be omitted in which case it is the same as providing an integer length. options is a keyword list of options. Options :crop determines if the strategy is &quot;resize to fit&quot; (crop is :none ) or &quot;resize to fill&quot; (when the crop option is not :none ). The value may be one of :none , :center , :entropy , :attention , :low or :high . The default is :none . See also Image.Options.Crop.crop_focus/0 . :height - Size to this height. Default is to maintain the image aspect ratio unless resize: :force is set. If resize; :force is set then the default :height is the height of image . :fit sets the :crop and :resize options to align with the CSS object-fit property. Note that using the :fit option overwrites the options :crop and :resize . Since options are processed in the order in which they are presented, :crop and :resize may still be force set if they are after the :fit option. :fit takes one of the following values: :fill - the image is resized to fill the given dimension. If necessary, the image will be stretched or squished to fit. This is the same as setting resize: :force . Note that is :height is not specified it will be the same height as image . :contain - the image keeps its aspect ratio, but is resized to fit within the given dimension. This is the same as setting crop: :none and resize: :both . :cover - the image keeps its aspect ratio and fills the given dimensions. The image will be clipped to fit. Clipping will default to :center unless :crop is already set to a value other than :none . This is the same as setting crop: :center (if :crop is not already set) and resize: :both . :autorotate is a boolean indicating if the image should be autorotated based upon the image metadata. The default is true . :intent indicates the rendering intent. The default is :relative . See also Image.render_intent/0 . :export_icc_profile indicates the icc profile to be attached to the resized image. The value may be an inbuilt profile ( :srgb , :p3 or :cmyk ), the name of an icc profile in the systems profile directory or a full path to an icc profile file. The default is to export the icc profile of the resized image if there is one. :import_icc_profile indicates the icc profile to be attached to the input image. The value may be an inbuilt profile ( :srgb , :p3 or :cmyk ), the name of an icc profile in the systems profile directory or a full path to an icc profile file. The default is to use the icc profile of the input image if there is one. :linear is a boolean indicating of the image should be resized in linear space. The default false . Shrinking is normally done in sRGB colourspace. Set linear to shrink in linear light colourspace instead. This can give better results, but can also be far slower, since tricks like JPEG shrink-on-load cannot be used in linear space. :resize determines if an image may be only upsized, only downsized, both or a forced aspect ratio is applied. The value may be one of :up , :down , :both or :force . The default is :both . Returns {:ok, thumbnailed_image} or {:error, reason}","ref":"Image.html#thumbnail/3"},{"type":"function","title":"Image.thumbnail!/3","doc":"Thumbnail an image to fit or fill a bounding box returning an image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 or a pathname to an image file. length is the integer length of the longest side of the resulting image after resizing. It c an also be of the form &quot;&lt;width&gt;x&lt;height&gt;&quot;. That is, a string with the width and height separated by an x . The &lt;height&gt; may be omitted in which case it is the same as providing an integer length. options is a keyword list of options. See Image.thumbnail/3 . Returns image or raises an exception.","ref":"Image.html#thumbnail!/3"},{"type":"function","title":"Image.to_colorspace/2","doc":"Converts an image to the given colorspace. Available colorspaces are returned from Image.Interpretation.known_interpretations/0 . Arguments image is any Vix.Vips.Image.t/0 colorspace is any known colorspace. See Image.Interpretation.known_interpretations/0 for a list of the known colorspaces. Returns {;ok, image_in_new_colorspace} or {:error, reason} Example Image . to_colorspace ( image , :bw )","ref":"Image.html#to_colorspace/2"},{"type":"function","title":"Image.to_colorspace!/2","doc":"Converts an impage to the given colorspace returning an image or raising an exception. Available colorspaces are returned from Image.Interpretation.known_interpretations/0 . Arguments image is any Vix.Vips.Image.t/0 colorspace is any known colorspace. See Image.Interpretation.known_interpretations/0 for a list of the known colorspaces. Returns image_in_new_colorspace or raises an exception Example Image . to_colorspace! ( image , :bw )","ref":"Image.html#to_colorspace!/2"},{"type":"function","title":"Image.to_evision/2","doc":"Converts an Image image to an Evision image. Note that only images with 3 bands can be transferred to eVision . Arguments image is any t:Vimage.t/0 convert_to_bgr is a boolean indicating if the color order should be converted from RGB to BGR which is the normal channel layout for OpenCV. The default is true . Returns {:ok, evision_image} Notes Image images have the shape {width, height, bands} whereas Evision images have the shape {height, width, bands} so this function transposes the dimensions to match. Image data is arranged as rgb data elements whereas Evision requires the data to be in bgr order. This function also reorders the data appropriately.","ref":"Image.html#to_evision/2"},{"type":"function","title":"Image.to_nx/2","doc":"Converts an image into an Nx tensor. Arguments image is any t:Vimage.t/0 options is a keyword list of options Options :shape determines how the tensor is shaped. The valid values are: :whb or :whc which leaves the tensor unchanged with the underlying data in width, height, bands shape. This is the default action. :hwc or :hwb which reshapes the tensor to height, width, channels which is commonly used for machine learning models. Returns {:ok, tensor) where tensor is an Nx.Tensor.t/0 tensor suitable for use in the Nx library or {:error, reason} . Example iex&gt; { :ok , image } = Vix.Vips.Operation . black ( 3 , 3 ) iex&gt; Image . to_nx ( image , backend : Nx.BinaryBackend ) { :ok , Nx . tensor ( [ [ [ 0 ] , [ 0 ] , [ 0 ] ] , [ [ 0 ] , [ 0 ] , [ 0 ] ] , [ [ 0 ] , [ 0 ] , [ 0 ] ] ] , type : { :u , 8 } , names : [ :width , :height , :bands ] , backend : Nx.BinaryBackend ) }","ref":"Image.html#to_nx/2"},{"type":"function","title":"Image.to_nx!/2","doc":"Converts an image into an Nx tensor. Arguments image is any t:Vimage.t/0 options is a keyword list of options Options :shape determines how the tensor is shaped. The valid values are: :whb or :whc which leaves the tensor unchanged with the underlying data in width, height, bands shape. This is the default action. :hwc or :hwb which reshapes the tensor to height, width, channels which is commonly used for machine learning models. Returns tensor where tensor is an Nx.Tensor.t/0 tensor suitable for use in the Nx library or raises an exception. Example iex&gt; { :ok , image } = Vix.Vips.Operation . black ( 3 , 3 ) iex&gt; Image . to_nx! ( image , backend : Nx.BinaryBackend ) Nx . tensor ( [ [ [ 0 ] , [ 0 ] , [ 0 ] ] , [ [ 0 ] , [ 0 ] , [ 0 ] ] , [ [ 0 ] , [ 0 ] , [ 0 ] ] ] , type : { :u , 8 } , names : [ :width , :height , :bands ] , backend : Nx.BinaryBackend )","ref":"Image.html#to_nx!/2"},{"type":"function","title":"Image.to_polar_coordinates/1","doc":"Convert image to polar coordinates. Arguments image is any Vix.Vips.Image.t/0 . Returns {:ok, image_in_polar_coordinates} or {:error, reason}","ref":"Image.html#to_polar_coordinates/1"},{"type":"function","title":"Image.to_polar_coordinates!/1","doc":"Convert image to polar coordinates returning an image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 . Returns image_in_polar_coordinates or raises an exception.","ref":"Image.html#to_polar_coordinates!/1"},{"type":"function","title":"Image.to_rectangular_coordinates/1","doc":"Convert image to rectangular coordinates. Arguments image is any Vix.Vips.Image.t/0 . Notes Roundtrip to polar and back to rectangular coordinates displays some image distortion, likely due to rounding errors in float arithmetic. Further study is required. Returns {:ok, image_in_rectangular_coordinates} or {:error, reason}","ref":"Image.html#to_rectangular_coordinates/1"},{"type":"function","title":"Image.to_rectangular_coordinates!/1","doc":"Convert image to rectangular coordinates returning an image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 . Notes Roundtrip to polar and back to rectangular coordinates displays some image distortion, likely due to rounding errors in float arithmetic. Further study is required. Returns image_in_rectangular_coordinates or raises an exception.","ref":"Image.html#to_rectangular_coordinates!/1"},{"type":"function","title":"Image.transform_matrix/3","doc":"Returns a transformation matrix for a given image, source quadrilateral and desintation quadrilateral. A transformation matrix when applied to an image (using, for example, Image.map/2 ) maps pixels from the source persecptive to the destination perspective. Requires Nx to be configured as a dependency. Arguments image is any t:Vimage.t/0 source is a list of four 2-tuples representing the four corners of the subject-of-interest in image . destination is a list of four 2-tuples representing the four corners of the destination image into which the subject-of-interest is transformed. Returns {:ok, transform_matrix} or {:error, reason} .","ref":"Image.html#transform_matrix/3"},{"type":"function","title":"Image.trim/2","doc":"Trims an image to the bounding box of the non-background area. Any alpha is flattened out, then the image is median-filtered, all the row and column sums of the absolute difference from background are calculated in a single pass. Then the first row or column in each of the four directions where the sum is greater than threshold gives the bounding box that is used to define the crop area. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :background is the color to be considered the background color. The default is automatically detected by averaging the pixels at the top left of the image. :threshold is the integer threshold (or color similarity) that is applied when determining the bounds of the non-background area. The default is 10 . The default value means only a small color background color range is considered. Increasing the threshold value maybe required. Returns {:ok, cropped_image} which is the image cropped to the bounding box of the non-background area. {:error, reason} . Reason may be :uncropped which means the image was considered to be only the background color.","ref":"Image.html#trim/2"},{"type":"function","title":"Image.trim!/2","doc":"Trims an image to the bounding box of the non-background area. Any alpha is flattened out, then the image is median-filtered, all the row and column sums of the absolute difference from background are calculated in a single pass. Then the first row or column in each of the four directions where the sum is greater than threshold gives the bounding box that is used to define the crop area. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :background is the color to be considered the background color. The default is automatically detected by averaging the pixels at the top left of the image. :threshold is the integer threshold (or color similarity) that is applied when determining the bounds of the non-background area. The default is 10 . The default value means only a small color background color range is considered. Increasing the threshold value maybe required. Returns cropped_image which is the image cropped to the bounding box of the non-background area or raises an exception.","ref":"Image.html#trim!/2"},{"type":"function","title":"Image.type/1","doc":"Returns the data type of the image pixels. Arguments image is any Vix.Vips.Image.t/0 Returns The image type as a tuple in the same format as Nx.Type.t/0 . For example {:u, 8} for a common :srgb image.","ref":"Image.html#type/1"},{"type":"function","title":"Image.vips_version/0","doc":"Returns the version of libvips in operation.","ref":"Image.html#vips_version/0"},{"type":"function","title":"Image.warp_perspective/4","doc":"Performs a warp perspective transformation on an image. Requires Nx to be configured as a dependency. Arguments image is any t:Vimage.t/0 source is a list of four 2-tuples representing the four corners of the subject-of-interest in image . destination is a list of four 2-tuples representing the four corners of the destination image into which the subject-of-interest is transformed. options is a keyword list of options. The default is [] . Options :background defines the color of any generated background pixels. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . It can also be supplied as a hex string of the form #rrggbb . The default is :black . :background can also be set to :average in which case the background will be the average color of the base image. See also Image.Color.color_map/0 and Image.Color.rgb_color/1 . :extend_mode determines how any additional pixels are generated. The values are: :black (the default) meaning the generated pixels are black. :white meaning the generated pixels are white. :copy means the generated pixels take the value of the nearest edge pixel of the base image. :repeat means the generated pixels are tiles from the base image. :mirror means the generated pixels are a reflected tiles of the base image. :background means the generated pixels are the background color setin options . Notes The image is flattened before warping and therefore any alpha band will be multiplied into to the image data and removed. Returns {:ok, warped_image} or {:error, reason}","ref":"Image.html#warp_perspective/4"},{"type":"function","title":"Image.warp_perspective!/4","doc":"Performs a warp perspective transformation on an image or raises an exception. Requires Nx to be configured as a dependency. Arguments image is any t:Vimage.t/0 source is a list of four 2-tuples representing the four corners of the subject-of-interest in image . destination is a list of four 2-tuples representing the four corners of the destination image into which the subject-of-interest is transformed. options is a keyword list of options. The default is [] . Options :background defines the color of any generated background pixels. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . It can also be supplied as a hex string of the form #rrggbb . The default is :black . :background can also be set to :average in which case the background will be the average color of the base image. See also Image.Color.color_map/0 and Image.Color.rgb_color/1 . :extend_mode determines how any additional pixels are generated. The values are: :black (the default) meaning the generated pixels are black. :white meaning the generated pixels are white. :copy means the generated pixels take the value of the nearest edge pixel of the base image. :repeat means the generated pixels are tiles from the base image. :mirror means the generated pixels are a reflected tiles of the base image. :background means the generated pixels are the background color setin options . Returns warped_image or raises an exception. Notes The image is flattened before warping and therefore any alpha band will be multiplied into to the image data and removed.","ref":"Image.html#warp_perspective!/4"},{"type":"function","title":"Image.width/1","doc":"Returns the width of an image. Arguments image is any Vix.Vips.Image.t/0 . Returns The image width as an integer.","ref":"Image.html#width/1"},{"type":"function","title":"Image.with_band_format/3","doc":"Execute a function over the image casting it first to a different band format and ensuring the band format reverted when the function returns. Arguments image is any Vix.Vips.Image.t/0 . band_format is any valid band format. See Image.BandFormat.known_band_formats/0 . fun is any 1-arity function that is required to return {:ok, image} or {:error, reason} . Returns {:ok, image} or {:error, reason} . Example iex&gt; image = Image . open! ( &quot;./test/support/images/Singapore-2016-09-5887.jpg&quot; ) iex&gt; { :ok , updated_image } = Image . with_band_format ( image , { :s , 16 } , fn i -&gt; { :ok , i } end ) iex&gt; Image . band_format ( updated_image ) { :u , 8 }","ref":"Image.html#with_band_format/3"},{"type":"function","title":"Image.with_colorspace/3","doc":"Execute a function over the image casting it first to a color space and ensuring the color space conversion is reverted when the function returns. Arguments image is any Vix.Vips.Image.t/0 . colorspace is any valid color space. See Image.Interpretation.known_interpretations/0 . fun is any 1-arity function that is required to return {:ok, image} or {:error, reason} . Returns {:ok, image} or {:error, reason} .","ref":"Image.html#with_colorspace/3"},{"type":"function","title":"Image.without_alpha_band/2","doc":"Execute a function over the image without its alpha band (if any) ensuring the alpha band is replaced when the function returns. Arguments image is any Vix.Vips.Image.t/0 . fun is any 1-arity function that is required to return {:ok, image} or {:error, reason} . Returns {:ok, image} or {:error, reason} .","ref":"Image.html#without_alpha_band/2"},{"type":"function","title":"Image.write/3","doc":"Write an image to a file, a stream, an enumerable or to memory. Arguments image is any Vix.Vips.Image.t/0 . image_path is the file system path to an image file. It may also be a stream created with File.stream!/3 or with Stream.resource/3 , a Plug.Conn.t/0 if Plug is configured or lastly, it can also be :memory in which case the image is written to a binary. options is a keyword list of options. The default is [] . Options The available options depends on the type of image file being opened. All image types :strip_metadata is a boolean indicating if all metadata is to be stripped from the image. The default is false . :background is the background value to be used for any transparent areas of the image. Jpeg does not support alpha bands so a color value must be assigned. :quality which influences image compression and is a integer in the range 1..100 . The default for most image formats is 75 . For HEIF files the default is 50 .For PNG files the :quality option is ignored. Streaming images and :memory images :suffix must be specified so that the image is written in the correct format. For example: suffix: &quot;.jpg&quot; . JPEG images :progressive is a boolean indicating if the image should be interleaved rather than baseline. Progressive has the advantage of perceived time for the initial image load and the cost of multiple decoding passes on the client. For many applications :progressive is to be preferred but validation of this assumption for specific use cases is required. :minimize_file_size is a boolean indicating whether to apply a number of techniques to minimise the file size of the jpeg file at the cost of additional time to save the image. All metadata will also be removed. :icc_profile indicates the icc profile to be attached to the output image. The value may be an inbuilt profile ( :none , :srgb , :cmyk , :p3 ), the name of an icc profile in the systems profile directory or a full path to an icc profile file. The default is to use the icc profile of the input image if there is one. PNG images :progressive which has the same meaning and values as for JPEG images. :minimize_file_size is a boolean indicating whether to apply a number of techniques to minimise the file size of the png file at the cost of additional time to save the image. All metadata will also be removed. :compression is the compression factor which is an integer in the range 1..9 . The default is 6 . :effort is an integer to adjust the level of CPU effort to reduce the file size. The value must be in the range 1..10 , the default is 7 . :icc_profile indicates the icc profile to be attached to the output image. The value may be an inbuilt profile ( :none , :srgb , :cmyk , :p3 ), the name of an icc profile in the systems profile directory or a full path to an icc profile file. The default is to use the icc profile of the input image if there is one. WEBP images :minimize_file_size is a boolean which is most useful on animated WebP . It enables mixed encoding and optimise the file for minimum size at the cost of additional time to save the image. All metadata will also be removed. Using this parameter on a non-animated webp file will only remove the metadata as :strip_metadata would do. :effort is an integer to adjust the level of CPU effort to reduce the file size. The value must be in the range 1..10 , the default is 7 . :icc_profile indicates the icc profile to be attached to the output image. The value may be an inbuilt profile ( :none , :srgb , :cmyk , :p3 ), the name of an icc profile in the systems profile directory or a full path to an icc profile file. The default is to use the icc profile of the input image if there is one. GIF options :interframe_maxerror Maximum inter-frame error for transparency. The value must be in the range 0..32 . The default is 0 . By increasing this value, the encoder will try to take advantage from temporal redundancy between neighboring frames by enabling higher compression rates. :effort is an integer to adjust the level of CPU effort to reduce the file size. The value must be in the range 1..10 , the default is 7 . HEIF images :compression is the compression strategy to be applied. The allowable values are :hevc , :avc , :jpeg and :av1 . The default is :hevc . :effort is an integer to adjust the level of CPU effort to reduce the file size. The value can be in the range 1..10 , the default is 5 . :minimize_file_size is a boolean indicating whether to apply a number of techniques to minimise the file size of the heif file at the cost of additional time to save the image. All metadata will also be removed. Returns {:ok, image} (or {:ok, binary} is the destination is :memory ) or {:error, reason}","ref":"Image.html#write/3"},{"type":"function","title":"Image.write!/3","doc":"Write an image to a file, a stream, an enumerable or to memory returning the image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 . image_path is the file system path to an image file. It may also be a stream created with File.stream!/3 or with Stream.resource/3 . Lastly, it can also be :memory in which case the image is written to a memory buffer. options is a keyword list of options. See Image.write/2 . Returns image (or a binary is the destination is :memory ) or raises an exception.","ref":"Image.html#write!/3"},{"type":"function","title":"Image.xmp/1","doc":"Returns the XMP data for an image as a keyword list. Only a selected set of XMP data is returned. Arguments image is any Vix.Vips.Image.t/0 Returns {:ok, xmp_map} where xmp_map is a map of selected XMP data.","ref":"Image.html#xmp/1"},{"type":"type","title":"Image.aspect/0","doc":"Image orientation.","ref":"Image.html#t:aspect/0"},{"type":"type","title":"Image.composition/0","doc":"A composition can be a simple image, or an image with associated composition options.","ref":"Image.html#t:composition/0"},{"type":"type","title":"Image.composition_list/0","doc":"A list of images or images with placement options used in Image.compose/2.","ref":"Image.html#t:composition_list/0"},{"type":"type","title":"Image.error_message/0","doc":"Error messages returned by libvips Typically a string.","ref":"Image.html#t:error_message/0"},{"type":"type","title":"Image.format/0","doc":"The data type of the image, using the same type definitions as Nx.Type.t/0 .","ref":"Image.html#t:format/0"},{"type":"type","title":"Image.image_data/0","doc":"The valid sources of image data when opening an image.","ref":"Image.html#t:image_data/0"},{"type":"type","title":"Image.image_hash/0","doc":"A 512 bit binary hash of an image. Useful for comparing the similarity of two images. See Image.dhash/1 and Image.hamming_distance/2 .","ref":"Image.html#t:image_hash/0"},{"type":"type","title":"Image.image_or_color/0","doc":"Represents either in image, or a color that is used to fill a new image","ref":"Image.html#t:image_or_color/0"},{"type":"type","title":"Image.kino_image/0","doc":"THe structure of an image returned from Kino.Input.read/1 when the input field is a Kino.Input.image/1 type.","ref":"Image.html#t:kino_image/0"},{"type":"type","title":"Image.pixel/0","doc":"A pixel is represented as a list of number values or a single number (which is then assumed to be the value for all bands). The number of list elements is determined by the colorspace interpretations. For example: RGB colorspace would be represented by a list of three floats like [0.0, 0,0, 0.0] for black. CMYK colorspace would be represented by a list of four floats. A PNG image can be in any appropriate colorspace but may also have an alpha band and therefore have three, four or five floats in a list to represent the pixel.","ref":"Image.html#t:pixel/0"},{"type":"type","title":"Image.quadrilateral/0","doc":"An image bounding box being a four element list of 2-tuples representing the points of a rectangle in the order top left -&gt; top right -&gt; bottom right -&gt; bottom left.","ref":"Image.html#t:quadrilateral/0"},{"type":"type","title":"Image.render_intent/0","doc":"The valid rendering intent values. For all functions that take an optional intent parameter the default is :perceptual . Perceptual Intent Perceptual rendering is used to process photographic type images. This intent processes the colors so that the output reproduction is pleasing. This process tends to change the color from the original, so no guarantee the reproduction will be accurate against the original. Relative Intent Relative colorimetric changes all the colours out of gamut to the nearest colour in gamut, so many colours change to the same one. It DOES NOT change colours in gamut. Perceptual changes ALL the colours in the image in a proportional way so that they lie in the output device gamut. Saturation Intent Saturation moves in-gamut colors toward the edge of the destination gamut for maximum saturation and impact. This intent will make an image more colorful by using the full gamut of the destination device. This intent cares not for the genuine representation of color. Absolute Intent Absolute rendering attempts to reproduce all colors numerically (destination = source). This can cause unexpected results if the source gamut is larger than the destination.","ref":"Image.html#t:render_intent/0"},{"type":"type","title":"Image.transparency/0","doc":"The level of transparency for an alpha band where 0 means fully opaque and 255 means fully transparent.","ref":"Image.html#t:transparency/0"},{"type":"type","title":"Image.x_location/0","doc":"The x location on an image which is either a non_negative 0-based integer relative to the image left or a negative -1-based integer relative to the image right or the symbolic references :left , :center and :right .","ref":"Image.html#t:x_location/0"},{"type":"type","title":"Image.y_location/0","doc":"The y location on an image which is either a non_negative 0-based integer relative to the image top or a negative -1-based integer relative to the image right or the symbolic references :top , :middle and :bottom .","ref":"Image.html#t:y_location/0"},{"type":"module","title":"Image.Classification","doc":"Implements image classification functions using Axon machine learning models managed by Bumblebee . Image classification refers to the task of extracting information from an image. In this module, the information extracted is one or more labels desribing the image. Typically something like &quot;sports car&quot; or &quot;Blenheim spaniel&quot;. The labels returns depend on the machine learning model used. Configuration The machine learning model to be used is configurable. The :model and :featurizer may be any model supported by Bumblebee. The :name is the name given to the classification service process. The default configuration is: # runtime.exs config :image , :classifier , model : { :hf , &quot;microsoft/resnet-50&quot; } , featurizer : { :hf , &quot;microsoft/resnet-50&quot; } , name : Image.Classification.Server , autostart : true Autostart If autostart: true is configured (the default) then a process is started under a supervisor to execute the classification requests. If running the process under an application supervision tree is desired, set autostart: false . In that case the function classifer/1 can be used to return a Supervisor.child_spec/0 . Adding a classification server to an application supervision tree To add image classification to an application supervision tree, use Image.Classification.classifier/1 to return a child spec: For example: # Application.ex def start ( _type , _args ) do children = [ # default classifier configuration Image.Classification . classifier ( ) # custom classifier configuration Image.Classification . classifier ( model : { :hf , &quot;google/vit-base-patch16-224&quot; } , featurizer : { :hf , &quot;google/vit-base-patch16-224&quot; } ) ] Supervisor . start_link ( children , strategy : :one_for_one ) end Note This module is only available if the optional dependency Bumblebee is configured in mix.exs .","ref":"Image.Classification.html"},{"type":"function","title":"Image.Classification.classifier/1","doc":"Returns a child spec suitable for starting an image classification process as part of a supervision tree. Arguments configuration is a keyword list.The default is Application.get_env(:image, :classifier, []) . Configuration keys :model is any supported machine learning model for image classification supported by Bumblebee. :featurizer is any supported machine learning model for image featurization supported by Bumblebee. :name is the name given to the classification process when it is started. Default configuration The default configuration is: [ model : { :hf , &quot;microsoft/resnet-50&quot; } , featurizer : { :hf , &quot;microsoft/resnet-50&quot; } , name : Image.Classification.Server ]","ref":"Image.Classification.html#classifier/1"},{"type":"function","title":"Image.Classification.classify/2","doc":"Classify an image using a machine learning model. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options Options :backend is any valid Nx backend. The default is Nx.default_backend/0 . :server is the name of the process performing the classification service. The default is Image.Classification.Server . Returns A map containing the predictions of the image classification. Example iex&gt; puppy = Image . open! ( &quot;./test/support/images/puppy.webp&quot; ) iex&gt; %{ predictions : [ %{ label : &quot;Blenheim spaniel&quot; , score : _ } | _rest ] } = ...&gt; Image.Classification . classify ( puppy )","ref":"Image.Classification.html#classify/2"},{"type":"function","title":"Image.Classification.labels/2","doc":"Classify an image using a machine learning model and return the labels that meet a minimum score. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :backend is any valid Nx backend. The default is Nx.default_backend/0 . :min_score is the minimum score, a float between 0 and 1 , which a label must match in order to be returned. Returns A list of labels. The list may be empty if there are no predictions that exceed the :min_score . {:error, reason} Example iex&gt; { :ok , image } = Image . open ( &quot;./test/support/images/lamborghini-forsennato-concept.jpg&quot; ) iex&gt; Image.Classification . labels ( image ) [ &quot;sports car&quot; , &quot;sport car&quot; ]","ref":"Image.Classification.html#labels/2"},{"type":"module","title":"Image.Color","doc":"Functions to manage image color and color conversion.","ref":"Image.Color.html"},{"type":"function","title":"Image.Color.color_map/0","doc":"Returns a mapping from CSS color names to CSS hex values and RGB triplets as a list.","ref":"Image.Color.html#color_map/0"},{"type":"function","title":"Image.Color.hex_to_rgb/1","doc":"Converts a hex color string to an RGB list. Arguments color is a hex string representing an RGB color. It has the form #RRGGBB . Returns {:ok, [r, g, b]} or {:error, reason} . Examples iex&gt; Image.Color . validate_color &quot;#0000FF&quot; { :ok , [ 0 , 0 , 255 ] }","ref":"Image.Color.html#hex_to_rgb/1"},{"type":"function","title":"Image.Color.inbuilt_profiles/0","doc":"Returns the list of color profiles built into libvips .","ref":"Image.Color.html#inbuilt_profiles/0"},{"type":"macro","title":"Image.Color.is_color/1","doc":"Guards whether a given value can be interpreted as a color value.","ref":"Image.Color.html#is_color/1"},{"type":"macro","title":"Image.Color.is_inbuilt_profile/1","doc":"Guards whether a given profile is one of the inbuilt profiles.","ref":"Image.Color.html#is_inbuilt_profile/1"},{"type":"function","title":"Image.Color.known_icc_profile?/1","doc":"Returns a boolean indicating if the given profile is known and can be used for image operations.","ref":"Image.Color.html#known_icc_profile?/1"},{"type":"function","title":"Image.Color.rgb_color/1","doc":"","ref":"Image.Color.html#rgb_color/1"},{"type":"function","title":"Image.Color.rgb_color!/1","doc":"","ref":"Image.Color.html#rgb_color!/1"},{"type":"function","title":"Image.Color.rgb_to_hex/1","doc":"Converts a color name or RGB value to a hex string. Arguments color which can be specified as a single integer which or a list of integers representing the color. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns {:ok, #RRGGBB} string or {:error, reason} . Examples iex&gt; Image.Color . rgb_to_hex ( :green ) { :ok , &quot;#008000&quot; } iex&gt; Image.Color . rgb_to_hex ( [ 10 , 20 , 30 ] ) { :ok , &quot;#A141E&quot; }","ref":"Image.Color.html#rgb_to_hex/1"},{"type":"function","title":"Image.Color.validate_color/1","doc":"Validates a color returning an [r, g, b] triplet or error. Arguments color which can be specified as a single integer which or a list of integers representing the color. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns {:ok, [r, g, b]} or {:error, reason}","ref":"Image.Color.html#validate_color/1"},{"type":"type","title":"Image.Color.icc_profile/0","doc":"Reference to an ICC color profile :none means no profile :cmyk , :srgb and :p3 refer to the built-in color profiles Path.t() means any file system path. If the path is a relative path then is will be loaded from the systems profile directory.","ref":"Image.Color.html#t:icc_profile/0"},{"type":"type","title":"Image.Color.rgb_color/0","doc":"An rbg color expressed as a list of numbers. The number of list elements and the type varies depending on the image format, colorspace and dimensions. For a common sRGB image it will be a list of three of four images. If the fourth number is provided it will be considered as an alpha transparency band.","ref":"Image.Color.html#t:rgb_color/0"},{"type":"type","title":"Image.Color.t/0","doc":"A color can be expressed as a list of numbers or as a CSS color name in atom or string format.","ref":"Image.Color.html#t:t/0"},{"type":"module","title":"Image.Draw","doc":"Functions to draw directly on a mutable image. Note that while the functions in this module mutate an image, the mutations are performed on a copy of the image so no harm will come to other functions maintaining a reference to the original image.","ref":"Image.Draw.html"},{"type":"function","title":"Image.Draw.circle/5","doc":"Draw a circle on a mutable image. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. If image is a t:MutableImage.t/0 it will be mutated directly. If image is a t:Vimage.t/0 it will be copied to a t:MutableImage.t/0 and then mutated. cx is the 0-based offset from the left edge of the image indicating where the center of the circle will be localed. cy is the 0-based offset from the top edge of the image indicating where the center of the circle will be localed. radius is the radius of the drawn circle. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . Lastly, it can also be supplied as a hex string of the form #rrggbb . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . :fill is a boolean indicating whether the rectangle is to be filled with :color . The default is true . :stroke_width indicates the width in pixels of the stroke that forms the rectangle. The default is 1 . Values greater than 1 will have a negative performance impact since the rectangle will be draw as 4 filled rectangles forming each of the four sides. If fill: true is set then this options is ignored. Returns {:ok, image} where image is the same type as that passed as an argument to the function. or {:error, reason}","ref":"Image.Draw.html#circle/5"},{"type":"function","title":"Image.Draw.circle!/5","doc":"Draw a circle on a mutable image returning the mutated image or raises an exception. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. If image is a t:MutableImage.t/0 it will be mutated directly. If image is a t:Vimage.t/0 it will be copied to a t:MutableImage.t/0 and then mutated. cx is the 0-based offset from the left edge of the image indicating where the center of the circle will be localed. cy is the 0-based offset from the top edge of the image indicating where the center of the circle will be localed. radius is the radius of the drawn circle. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . Lastly, it can also be supplied as a hex string of the form #rrggbb . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . :fill is a boolean indicating whether the rectangle is to be filled with :color . The default is true . Returns image where image is the same type as that passed as an argument to the function or raises an exception.","ref":"Image.Draw.html#circle!/5"},{"type":"function","title":"Image.Draw.flood/4","doc":"Flood-fill image with color, starting at position top , left . The filled area is bounded by pixels that are equal to the :colour . That is, it searches for pixels enclosed by an edge of :color . If :equal is true , it instead searches for pixels which are equal to the start point and fills them with :color . Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. If image is a t:MutableImage.t/0 it will be mutated directly. If image is a t:Vimage.t/0 it will be copied to a t:MutableImage.t/0 and then mutated. left is the 0-based offset from the left edge of the image where the flood will be drawn. top is the 0-based offset from the top edge of the image where the flood will drawn. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . Lastly, it can also be supplied as a hex string of the form #rrggbb . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns {:ok, {image, height, width, top, left} where image is the same type as that passed as an argument to the function. height and width represent the dimensions of the flood fill in pixels. top and left are the 0-based offsets from the top and left location respectively of the flood area. or {:error, reason}","ref":"Image.Draw.html#flood/4"},{"type":"function","title":"Image.Draw.flood!/4","doc":"Flood-fill image with color, starting at position top , left or raise an exception. The filled area is bounded by pixels that are equal to the :colour . That is, it searches for pixels enclosed by an edge of :color . If :equal is true , it instead searches for pixels which are equal to the start point and fills them with :color . Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. If image is a t:MutableImage.t/0 it will be mutated directly. If image is a t:Vimage.t/0 it will be copied to a t:MutableImage.t/0 and then mutated. left is the 0-based offset from the left edge of the image where the flood will be drawn. top is the 0-based offset from the top edge of the image where the flood will drawn. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . Lastly, it can also be supplied as a hex string of the form #rrggbb . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns image where image is the same type as that passed as an argument to the function or raises an exception.","ref":"Image.Draw.html#flood!/4"},{"type":"function","title":"Image.Draw.image/5","doc":"Draw one image over the top of a mutable image. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. If image is a t:MutableImage.t/0 it will be mutated directly. If image is a t:Vimage.t/0 it will be copied to a t:MutableImage.t/0 and then mutated. sub_image is any t:Vimage.t/0 that is drawn on top of image . left is the 0-based offset from the left edge of the image where the sub-image will be drawn. top is the 0-based offset from the top edge of the image where the sub-image will be drawn. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . Lastly, it can also be supplied as a hex string of the form #rrggbb . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns {:ok, image} where image is the same type as that passed as an argument to the function. or {:error, reason}","ref":"Image.Draw.html#image/5"},{"type":"function","title":"Image.Draw.image!/5","doc":"Draw one image over the top of a mutable image or raises an exception. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. If image is a t:MutableImage.t/0 it will be mutated directly. If image is a t:Vimage.t/0 it will be copied to a t:MutableImage.t/0 and then mutated. sub_image is any t:Vimage.t/0 that is drawn on top of image . left is the 0-based offset from the left edge of the image where the sub-image will be drawn. top is the 0-based offset from the top edge of the image where the sub-image will be drawn. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . Lastly, it can also be supplied as a hex string of the form #rrggbb . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns image where image is the same type as that passed as an argument to the function. raises an exception.","ref":"Image.Draw.html#image!/5"},{"type":"macro","title":"Image.Draw.is_circle/3","doc":"Validates acceptable circle dimensions","ref":"Image.Draw.html#is_circle/3"},{"type":"macro","title":"Image.Draw.is_point/2","doc":"Validate a point location on an image","ref":"Image.Draw.html#is_point/2"},{"type":"function","title":"Image.Draw.line/6","doc":"Draw a line on a mutable image. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. If image is a t:MutableImage.t/0 it will be mutated directly. If image is a t:Vimage.t/0 it will be copied to a t:MutableImage.t/0 and then mutated. x1 , y1 are the 0-based offsets from the left and top accordingly indicating the point at the start of the line. x2 , y2 are the 0-based offsets from the left and top accordingly indicating the point at the end of the line. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . Lastly, it can also be supplied as a hex string of the form #rrggbb . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns {:ok, image} where image is the same type as that passed as an argument to the function. or {:error, reason}","ref":"Image.Draw.html#line/6"},{"type":"function","title":"Image.Draw.line!/6","doc":"Draw a line on a mutable image returning the mutated image or raising an exception. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. If image is a t:MutableImage.t/0 it will be mutated directly. If image is a t:Vimage.t/0 it will be copied to a t:MutableImage.t/0 and then mutated. x1 , y1 are the 0-based offsets from the left and top accordingly indicating the point at the start of the line. x2 , y2 are the 0-based offsets from the left and top accordingly indicating the point at the end of the line. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . Lastly, it can also be supplied as a hex string of the form #rrggbb . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns image where image is the same type as that passed as an argument to the function or raises an exception.","ref":"Image.Draw.html#line!/6"},{"type":"function","title":"Image.Draw.mask/5","doc":"Draw mask on the image. Mask is a monochrome 8-bit image with the values of 0 or 255 for transparent and any other value as a color to be blended into the base image.","ref":"Image.Draw.html#mask/5"},{"type":"function","title":"Image.Draw.point/4","doc":"Draw a point on a mutable image. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. If image is a t:MutableImage.t/0 it will be mutated directly. If image is a t:Vimage.t/0 it will be copied to a t:MutableImage.t/0 and then mutated. left is the 0-based offset from the left edge of the image where the point will be drawn. top is the 0-based offset from the top edge of the image where the point will be drawn. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . Lastly, it can also be supplied as a hex string of the form #rrggbb . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns {:ok, image} where image is the same type as that passed as an argument to the function. or {:error, reason}","ref":"Image.Draw.html#point/4"},{"type":"function","title":"Image.Draw.point!/4","doc":"Draw a point on a mutable image returning the mutated image or raising an exception. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. If image is a t:MutableImage.t/0 it will be mutated directly. If image is a t:Vimage.t/0 it will be copied to a t:MutableImage.t/0 and then mutated. left is the 0-based offset from the left edge of the image where the point will be drawn. top is the 0-based offset from the top edge of the image where the point will be drawn. options is a keyword list of options. The default is color: :black . See the options for Image.Draw.point/4 . Returns image where image is the same type as that passed as an argument to the function or raises an exception.","ref":"Image.Draw.html#point!/4"},{"type":"function","title":"Image.Draw.rect/6","doc":"Draw a rectangle on a mutable image. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. If image is a t:MutableImage.t/0 it will be mutated directly. If image is a t:Vimage.t/0 it will be copied to a t:MutableImage.t/0 and then mutated. left is the 0-based offset from the left edge of the image where the rectangle will be drawn. top is the 0-based offset from the top edge of the image where the rectangle will be drawn. width is the width of the rectangle height is the height of the rectangle options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . Lastly, it can also be supplied as a hex string of the form #rrggbb . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . :fill is a boolean indicating whether the rectangle is to be filled with :color . The default is true . :stroke_width indicates the width in pixels of the stroke that forms the rectangle. The default is 1 . Values greater than 1 will have a negative performance impact since the rectangle will be draw as 4 filled rectangles forming each of the four sides. If fill: true is set then this options is ignored. Returns {:ok, image} where image is the same type as that passed as an argument to the function or {:error, reason} .","ref":"Image.Draw.html#rect/6"},{"type":"function","title":"Image.Draw.rect!/6","doc":"Draw a rectangle on a mutable image and returns the mutated image or raises an exception. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. If image is a t:MutableImage.t/0 it will be mutated directly. If image is a t:Vimage.t/0 it will be copied to a t:MutableImage.t/0 and then mutated. left is the 0-based offset from the left edge of the image where the rectangle will be drawn. top is the 0-based offset from the top edge of the image where the rectangle will be drawn. width is the width of the rectangle height is the height of the rectangle options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . Lastly, it can also be supplied as a hex string of the form #rrggbb . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . :fill is a boolean indicating whether the rectangle is to be filled with :color . The default is true . :stroke_width indicates the width in pixels of the stroke that forms the rectangle. The default is 1 . Values greater than 1 will have a negative performance impact since the rectangle will be draw as 4 filled rectangles forming each of the four sides. If fill: true is set then this options is ignored. Returns image where image is the same type as that passed as an argument to the function or raises an exception.","ref":"Image.Draw.html#rect!/6"},{"type":"function","title":"Image.Draw.smudge/6","doc":"Smudge a section of image . Each pixel in the area left , top , width , height is replaced by the average of the surrounding 3x3 pixels.","ref":"Image.Draw.html#smudge/6"},{"type":"module","title":"Image.Generation","doc":"Implements image generation functions using Axon machine learning models managed by Bumblebee . Configuration The machine learning model to be used is configurable however only Stable Diffusion is currently supported. The default configuration is: # runtime.exs config :image , :generator , repository_id : &quot;CompVis/stable-diffusion-v1-4&quot; , scheduler : { :hf , &quot;CompVis/stable-diffusion-v1-4&quot; , subdir : &quot;scheduler&quot; } , featurizer : { :hf , &quot;CompVis/stable-diffusion-v1-4&quot; , subdir : &quot;feature_extractor&quot; } , safety_checker : { :hf , &quot;CompVis/stable-diffusion-v1-4&quot; , subdir : &quot;safety_checker&quot; } , autostart : false Autostart If autostart: true is configured (the default is false ) then a process is started under a supervisor to execute the generation requests. If running the process under an application supervision tree is desired, set autostart: false . In that case the function Image.Generation.generator/2 can be used to return a Supervisor.child_spec/0 . Adding a image generation server to an application supervision tree To add image generation to an application supervision tree, use Image.Generation.generator/2 to return a child spec: For example: # Application.ex def start ( _type , _args ) do children = [ # default classifier configuration Image.Generation . generator ( ) ] Supervisor . start_link ( children , strategy : :one_for_one ) end Starting a supervised image generation process If a dynamically started image generation process is required one can be started under a supervisor with: iex&gt; Supervisor . start_link ( [ Image.Generation . generator ( ) ] , strategy : :one_for_one )","ref":"Image.Generation.html"},{"type":"function","title":"Image.Generation.generator/2","doc":"Returns a child spec for service that generates images from text using Stable Diffusion implemented in Bumblebee. Arguments generator is a keyword list of configuration options for an image generator or :default . options is a keyword list of options. Options :num_steps determines the number of steps to execute in the generation model. The default is 20 . Changing this to 40 may increase image quality. :num_images_per_prompt determines how many image alternatives are returned. The default is 1 . :name is the name given to the child process. THe default is Image.Generation.Server . Default configuration If generator is set to :default the following configuration is used: [ repository_id : &quot;CompVis/stable-diffusion-v1-4&quot; , scheduler : { :hf , &quot;CompVis/stable-diffusion-v1-4&quot; , subdir : &quot;scheduler&quot; } , featurizer : { :hf , &quot;CompVis/stable-diffusion-v1-4&quot; , subdir : &quot;feature_extractor&quot; } , safety_checker : { :hf , &quot;CompVis/stable-diffusion-v1-4&quot; , subdir : &quot;safety_checker&quot; } , autostart : false ] If no generator is specified (or it is set to :default then the configuration is derived from runtime.exs which is then merged into the default configuration. In runtime.exs the configuration would be specified as follows: config :image , :generator , repository_id : &quot;CompVis/stable-diffusion-v1-4&quot; , scheduler : { :hf , &quot;CompVis/stable-diffusion-v1-4&quot; , subdir : &quot;scheduler&quot; } , featurizer : { :hf , &quot;CompVis/stable-diffusion-v1-4&quot; , subdir : &quot;feature_extractor&quot; } , safety_checker : { :hf , &quot;CompVis/stable-diffusion-v1-4&quot; , subdir : &quot;safety_checker&quot; } , autostart : false Automatically starting the service The :autostart configuration option determines if the image generation service is started when the :image application is started. The default is false . To cause the service to be started at application start, add the following to your runtime.exs : config :image , :generator , autostart : true","ref":"Image.Generation.html#generator/2"},{"type":"function","title":"Image.Generation.text_to_image/2","doc":"Generates an image from a textual description using Bumblebee's suport of the Stable Diffusion model. Arguments prompt is a String.t/0 description of the scene to be generated. options is a keyword list of options. The default is negative_prompt: &quot;&quot; . Options :negative_prompt is a String.t/0 that tells Stable Diffusion what you don't want to see in the generated images. When specified, it guides the generation process not to include things in the image according to a given text. Example iex&gt; Image.Generation . text_to_image &quot;impressionist purple numbat in the style of monet&quot; [ % Vix.Vips.Image { ref : # Reference &lt; 0.1281915998 . 296878104.76045 &gt; } ]","ref":"Image.Generation.html#text_to_image/2"},{"type":"module","title":"Image.Histogram","doc":"A histogram is a graphical representation of the tonal distribution in a digital image. It plots the number of pixels for each tonal value. By looking at the histogram for a specific image a viewer will be able to judge the entire tonal distribution at a glance. The horizontal axis of the graph represents the tonal variations, while the vertical axis represents the total number of pixels in that particular tone. The left side of the horizontal axis represents the dark areas, the middle represents mid-tone values and the right hand side represents light areas. The vertical axis represents the size of the area (total number of pixels) that is captured in each one of these zones. Thus, the histogram for a very dark image will have most of its data points on the left side and center of the graph. Conversely, the histogram for a very bright image with few dark areas and/or shadows will have most of its data points on the right side and center of the graph. The histograms generated in this module have red, green, blue and luminance layers and can be returned as either an svg string or as an t:Vimage.t/0 . The current implementation does not applying any scale compression or expansion and therefore where the image has very wide tonality differences the differences may be difficult to distinguish if :height is small.","ref":"Image.Histogram.html"},{"type":"function","title":"Image.Histogram.as_image/2","doc":"Returns an image representing a red, green, blue and luminance histogram for an image. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :width is the integer width of the SVG image. The default is :auto which means the image is sized to its parent container. :height is the integer height of the SVG image. The default is :auto which means the image is sized to its parent container. Returns {:ok, histogram_image} or {:error, reason} . Histogram image sizing With Image.Histogram.as_image/2 it is recommended that the :width and/or :height options be provided (in pixels) to ensure the image is generated at the desired size. The default of :auto will generate an image the size of the underlying SVG viewbox which is 255 pixels wide and 255 pixels high.","ref":"Image.Histogram.html#as_image/2"},{"type":"function","title":"Image.Histogram.as_image!/2","doc":"Returns an image representing a red, green, blue and luminance histogram for an image or raises an exception. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :width is the integer width of the SVG image. The default is :auto which means the image is sized to its parent container. :height is the integer height of the SVG image. The default is :auto which means the image is sized to its parent container. Returns histogram_image or raises an exception. Histogram image sizing With Image.Histogram.as_image/2 it is recommended that the :width and/or :height options be provided (in pixels) to ensure the image is generated at the desired size. The default of :auto will generate an image the size of the underlying SVG viewbox which is 255 pixels wide and 255 pixels high.","ref":"Image.Histogram.html#as_image!/2"},{"type":"function","title":"Image.Histogram.as_svg/2","doc":"Returns an svg string representing a red, green, blue and luminance histogram for an image. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :width is the integer width of the SVG image. The default is :auto which means the image is sized to its parent container. :height is the integer height of the SVG image. The default is :auto which means the image is sized to its parent container. Returns {:ok, svg_string} or {:error, reason} . Histogram image sizing SVG will, by default, resize to fit its parent container in an HTMl page. Image.Histogram.as_svg/2 will generate SVG with a default width and height of auto the reflects this intent. In some cases, such as generating images with Image.Histogram.as_image/2 , :width and :height options should be provided (in pixels) to ensure the image is generated at the desired size. Attribution Thanks to Alex Plescan for the inspiration for the SVG design.","ref":"Image.Histogram.html#as_svg/2"},{"type":"function","title":"Image.Histogram.as_svg!/2","doc":"Returns an svg string representing a red, green, blue and luminance histogram for an image or raises an exception. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :width is the integer width of the SVG image. The default is :auto which means the image is sized to its parent container. :height is the integer height of the SVG image. The default is :auto which means the image is sized to its parent container. Returns svg_string or raises an exception. Histogram image sizing SVG will, by default, resize to fit its parent container in an HTMl page. Image.Histogram.as_svg/2 will generate SVG with a default width and height of auto the reflects this intent. In some cases, such as generating images with Image.Histogram.as_image/2 , :width and :height options should be provided (in pixels) to ensure the image is generated at the desired size. Attribution Thanks to Alex Plescan for the inspiration for the SVG design.","ref":"Image.Histogram.html#as_svg!/2"},{"type":"module","title":"Image.Math","doc":"Implements math operators for images, delegating to the Kernel functions in the cases where the parameters do not include Vix.Vips.Image.t/0 . To override the standard operations in a function or module, add use Image.Math . To maximise readability and clarity it is recommended that use Image.Math be added to only those functions that require it. Example defmodule MyModule do # Not recommended use Image.Math def my_function ( % Vix.Vips.Image { } = image ) do # Recommended use Image.Math # Increase the all bands by 20% brigher = image * 1.2 # Or adjust only green by 20% bright_green = image * [ 1 , 1.2 , 1 ] end end","ref":"Image.Math.html"},{"type":"function","title":"Image.Math.&&&/2","doc":"Matrix bitwise 'and' of two images.","ref":"Image.Math.html#&&&/2"},{"type":"function","title":"Image.Math.**/2","doc":"Matrix exponent of two images or one image and a constant or vector. Delegates to Kernel.**/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#**/2"},{"type":"function","title":"Image.Math.*/2","doc":"Matrix multiplation of two images or one image and a constant or vector. Delegates to Kernel.*/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#*/2"},{"type":"function","title":"Image.Math.+/2","doc":"Matrix addition of two images or one image and a constant or vector. Delegates to Kernel.+/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#+/2"},{"type":"function","title":"Image.Math.-/2","doc":"Matrix subtraction of two images or one image and a constant or vector. Delegates to Kernel.-/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#-/2"},{"type":"function","title":"Image.Math.//2","doc":"Matrix division of two images or one image and a constant or vector. Delegates to Kernel.//2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#//2"},{"type":"function","title":"Image.Math.!=/2","doc":"Matrix inequality of two images or one image and a constant or vector. Delegates to Kernel.!=/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#!=/2"},{"type":"function","title":"Image.Math.</2","doc":"Matrix less than of two images or one image and a constant or vector. Delegates to Kernel.&lt;/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#%3C/2"},{"type":"function","title":"Image.Math.<<</2","doc":"Matrix bitwise 'left shift' of two images.","ref":"Image.Math.html#%3C%3C%3C/2"},{"type":"function","title":"Image.Math.<=/2","doc":"Matrix less than or equal of two images or one image and a constant or vector. Delegates to Kernel.&lt;=/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#%3C=/2"},{"type":"function","title":"Image.Math.==/2","doc":"Matrix equality of two images or one image and a constant or vector. Delegates to Kernel.==/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#==/2"},{"type":"function","title":"Image.Math.>/2","doc":"Matrix greater than of two images or one image and a constant or vector. Delegates to Kernel.&gt;/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#%3E/2"},{"type":"function","title":"Image.Math.>=/2","doc":"Matrix greater than or equal of two images or one image and a constant or vector. Delegates to Kernel.&gt;=/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#%3E=/2"},{"type":"function","title":"Image.Math.>>>/2","doc":"Matrix bitwise 'right shift' of two images.","ref":"Image.Math.html#%3E%3E%3E/2"},{"type":"function","title":"Image.Math.add/2","doc":"","ref":"Image.Math.html#add/2"},{"type":"function","title":"Image.Math.add!/2","doc":"","ref":"Image.Math.html#add!/2"},{"type":"function","title":"Image.Math.boolean_and/2","doc":"","ref":"Image.Math.html#boolean_and/2"},{"type":"function","title":"Image.Math.boolean_and!/2","doc":"","ref":"Image.Math.html#boolean_and!/2"},{"type":"function","title":"Image.Math.boolean_lshift/2","doc":"","ref":"Image.Math.html#boolean_lshift/2"},{"type":"function","title":"Image.Math.boolean_lshift!/2","doc":"","ref":"Image.Math.html#boolean_lshift!/2"},{"type":"function","title":"Image.Math.boolean_or/2","doc":"","ref":"Image.Math.html#boolean_or/2"},{"type":"function","title":"Image.Math.boolean_or!/2","doc":"","ref":"Image.Math.html#boolean_or!/2"},{"type":"function","title":"Image.Math.boolean_rshift/2","doc":"","ref":"Image.Math.html#boolean_rshift/2"},{"type":"function","title":"Image.Math.boolean_rshift!/2","doc":"","ref":"Image.Math.html#boolean_rshift!/2"},{"type":"function","title":"Image.Math.boolean_xor/2","doc":"","ref":"Image.Math.html#boolean_xor/2"},{"type":"function","title":"Image.Math.boolean_xor!/2","doc":"","ref":"Image.Math.html#boolean_xor!/2"},{"type":"function","title":"Image.Math.cos/1","doc":"","ref":"Image.Math.html#cos/1"},{"type":"function","title":"Image.Math.cos!/1","doc":"","ref":"Image.Math.html#cos!/1"},{"type":"function","title":"Image.Math.divide/2","doc":"","ref":"Image.Math.html#divide/2"},{"type":"function","title":"Image.Math.divide!/2","doc":"","ref":"Image.Math.html#divide!/2"},{"type":"function","title":"Image.Math.equal/2","doc":"","ref":"Image.Math.html#equal/2"},{"type":"function","title":"Image.Math.equal!/2","doc":"","ref":"Image.Math.html#equal!/2"},{"type":"function","title":"Image.Math.greater_than/2","doc":"","ref":"Image.Math.html#greater_than/2"},{"type":"function","title":"Image.Math.greater_than!/2","doc":"","ref":"Image.Math.html#greater_than!/2"},{"type":"function","title":"Image.Math.greater_than_or_equal/2","doc":"","ref":"Image.Math.html#greater_than_or_equal/2"},{"type":"function","title":"Image.Math.greater_than_or_equal!/2","doc":"","ref":"Image.Math.html#greater_than_or_equal!/2"},{"type":"macro","title":"Image.Math.is_pixel/1","doc":"Guards if a given value might be reasonably interpreted as a pixel.","ref":"Image.Math.html#is_pixel/1"},{"type":"function","title":"Image.Math.less_than/2","doc":"","ref":"Image.Math.html#less_than/2"},{"type":"function","title":"Image.Math.less_than!/2","doc":"","ref":"Image.Math.html#less_than!/2"},{"type":"function","title":"Image.Math.less_than_or_equal/2","doc":"","ref":"Image.Math.html#less_than_or_equal/2"},{"type":"function","title":"Image.Math.less_than_or_equal!/2","doc":"","ref":"Image.Math.html#less_than_or_equal!/2"},{"type":"function","title":"Image.Math.maxpos/2","doc":"Return the image maximum. Arguments image is any Vix.Vips.Image.t/0 options is a keyword list of options Options :size is the number of maximums to find. The default is 10 . Returns {:ok, maximum, x_position, y_position}","ref":"Image.Math.html#maxpos/2"},{"type":"function","title":"Image.Math.minpos/2","doc":"Return the image minimum. Arguments image is any Vix.Vips.Image.t/0 options is a keyword list of options Options :size is the number of minimums to find. The default is 10 . Returns {:ok, minimum, x_position, y_position}","ref":"Image.Math.html#minpos/2"},{"type":"function","title":"Image.Math.multiply/2","doc":"","ref":"Image.Math.html#multiply/2"},{"type":"function","title":"Image.Math.multiply!/2","doc":"","ref":"Image.Math.html#multiply!/2"},{"type":"function","title":"Image.Math.not_equal/2","doc":"","ref":"Image.Math.html#not_equal/2"},{"type":"function","title":"Image.Math.not_equal!/2","doc":"","ref":"Image.Math.html#not_equal!/2"},{"type":"function","title":"Image.Math.pow/2","doc":"","ref":"Image.Math.html#pow/2"},{"type":"function","title":"Image.Math.pow!/2","doc":"","ref":"Image.Math.html#pow!/2"},{"type":"function","title":"Image.Math.sin/1","doc":"","ref":"Image.Math.html#sin/1"},{"type":"function","title":"Image.Math.sin!/1","doc":"","ref":"Image.Math.html#sin!/1"},{"type":"function","title":"Image.Math.subtract/2","doc":"","ref":"Image.Math.html#subtract/2"},{"type":"function","title":"Image.Math.subtract!/2","doc":"","ref":"Image.Math.html#subtract!/2"},{"type":"function","title":"Image.Math.|||/2","doc":"Matrix bitwise 'or' of two images.","ref":"Image.Math.html#%7C%7C%7C/2"},{"type":"module","title":"Image.Nx","doc":"","ref":"Image.Nx.html"},{"type":"module","title":"Image.QRcode","doc":"Detects and decodes QRcodes. Note that the implementation, which is based upon eVision requires that the image be a 3-channel image in order to support detection. Images that are in different formats must be converted first. Note This module is only available if the optional dependency eVision is configured in mix.exs .","ref":"Image.QRcode.html"},{"type":"function","title":"Image.QRcode.decode/1","doc":"Detects and decodes a QR code in an image. Arguments image is any Vix.Vips.Image.t/0 that has three bands (for example, a typical srgb image). Returns {:ok, string} or {:error, reason} Note Only images with three bands (channels) are supported. This restriction may be lifted in a future release.","ref":"Image.QRcode.html#decode/1"},{"type":"function","title":"Image.QRcode.encode/2","doc":"Encodes a string as a QRCode. Arguments string is any string to be encoded, options is a keyword list of options. The default is size: :auto . Options :size is the size in pixels of the QRcode dimensions. The default is :auto in which the generated QRcode will be the minimum dimensions necessary to encode the string . Returns {:ok, image} or {:error, reason}","ref":"Image.QRcode.html#encode/2"},{"type":"module","title":"Image.Shape","doc":"Functions to render a shape as an image. The supported shapes match those defined in Scalable Vector Graphics including: Rectangle Polygon Circle Ellipse Line","ref":"Image.Shape.html"},{"type":"function","title":"Image.Shape.polygon/2","doc":"Creates an image of a polygon. Arguments points defines the points of the polygon. The origin is the top left of the image with a positive x value moving from right to left and a positive y value moving from top to bottom. The points can be an SVG point string or a &quot;list of lists&quot; of the form [[x1, y1], [x2, y2], ...] where x1 and y1 are integers. points can also be a positive integer &gt;= 3 which indicates that an n sided polygon will be generated. In this case the options :rotation and :radius are also applicable. options is a Keyword.t/0 list of options. Options :width is the width of the canvas onto which the polygon is drawn. The default is 500 pixels. :height is the height of the canvas onto which the polygon is drawn. The default is 500 pixels. :fill_color is the color used to fill in the polygon. The default is :none . :stroke_width is the width of the line used to draw the polygon. The default is 1px . :stroke_color is the color used for the outline of the polygon. The default is :black :opacity is the opacity as a float between 0.0 and 1.0 where 0.0 is completely transparent and 1.0 is completely opaque. The default is 0.7 . :rotation is the number of degrees to rotate the axis of a generated n-sided polygon. This option is only valid if points is an integer &gt;= 3. The default is 180 . :radius indicates the radius in pixels of a generated n-sided polygon. The default is 100 . Notes The polygon points are scaled to fit the canvas size defined by :width and :height This means that the resulting image will fill the canvas. This is useful for composing images. Define the canvas to be the size intended to be composed into a base image and the polygon will be scaled to fit. Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;. Returns {:ok, image} or {:error, reason} Examples","ref":"Image.Shape.html#polygon/2"},{"type":"function","title":"Image.Shape.polygon!/2","doc":"Creates an image of a polygon as a single band image on a transparent background. Arguments points defines the points of the polygon. The origin is the top left of the image with a positive x value moving from right to left and a positive y value moving from top to bottom. The points can be an SVG point string or a &quot;list of lists&quot; of the form [[x1, y1], [x2, y2], ...] where x1 and y1 are integers. options is a Keyword.t/0 list of options. Options :width is the width of the canvas onto which the polygon is drawn. The default is 500 pixels. :height is the width of the canvas onto which the polygon is drawn. The default is 500 pixels. :fill_color is the color used to fill in the polygon. The default is :none . :stroke_width is the width of the line used to draw the polygon. The default is 1px . :stroke_color is the color used for the outline of the polygon. The default is :black :opacity is the opacity as a float between 0.0 and 1.0 where 0.0 is completely transparent and 1.0 is completely opaque. The default is 0.7 . Notes The polygon points are scaled to fit the canvas size defined by :width and :height This means that the resulting image will fill the canvas. This is useful for composing images. Define the canvas to be the size intended to be composed into a base image and the polygon will be scaled to fit. Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;. Returns image or raises an exception Examples","ref":"Image.Shape.html#polygon!/2"},{"type":"function","title":"Image.Shape.rect/3","doc":"Creates a image of a rectangle. width is the number of pixels wide. height is the number of pixels high. options is a Keyword.t/0 list of options. Options :fill_color is the color used to fill in the polygon. The default is :none . :stroke_width is the width of the line used to draw the rectangle. The default is 1px . :stroke_color is the color used for the outline of the polygon. The default is :black :opacity is the opacity as a float between 0.0 and 1.0 where 0.0 is completely transparent and 1.0 is completely opaque. The default is 0.7 . :rotation is the number of degrees to rotate the axis of a generated rectangle. Returns {:ok, rectangle_image} or {:error, reason} Examples","ref":"Image.Shape.html#rect/3"},{"type":"function","title":"Image.Shape.rect!/3","doc":"Creates a image of a rectangle or raises and exception. width is the number of pixels wide. height is the number of pixels high. options is a Keyword.t/0 list of options. Options :fill_color is the color used to fill in the polygon. The default is :none . :stroke_width is the width of the line used to draw the rectangle. The default is 1px . :stroke_color is the color used for the outline of the polygon. The default is :black . :opacity is the opacity as a float between 0.0 and 1.0 where 0.0 is completely transparent and 1.0 is completely opaque. The default is 0.7 . :rotation is the number of degrees to rotate the axis of a generated rectangle. Returns rectangle_image or raises an exception. Examples","ref":"Image.Shape.html#rect!/3"},{"type":"function","title":"Image.Shape.star/2","doc":"Returns an image of an n-pointed star that can be composed over other images. Arguments points is an integer number of points on the star. points must be &gt;= 3. The default is 5 . options is a Keyword.t/0 list of options. Options :inner_radius is the size of the inner radius. The default is 60 . :outer_radius is the size of the outer radius. The default is 150 . :rotation is the angle in degrees of rotation applied to the points. The default is 0 . Any remaining options are passed to Image.Shape.polygon/2 . Returns {:ok, image} or {:error, reason} Examples #=&gt; {:ok, star} = Image.Shape.star #=&gt; {:ok, star} = Image.Shape.star 5, rotation: 90, fill_color: :red, stroke_color: :green","ref":"Image.Shape.html#star/2"},{"type":"function","title":"Image.Shape.star!/2","doc":"Returns an image of an n-pointed star that can be composed over other images. Arguments points is an integer number of points on the star. points must be &gt;= 3. The default is 5 . options is a Keyword.t/0 list of options. Options :inner_radius is the size of the inner radius. The default is 60 . :outer_radius is the size of the outer radius. The default is 150 . :rotation is the angle in degrees of rotation applied to the points. The default is 0 . Any remaining options are passed to Image.Shape.polygon/2 . Returns image or raises an exception Examples #=&gt; star = Image.Shape.star! #=&gt; star = Image.Shape.star! 5, rotation: 90, fill_color: :red, stroke_color: :green","ref":"Image.Shape.html#star!/2"},{"type":"type","title":"Image.Shape.path/0","doc":"A path is a list of points representing a path, open polygon or closed polygon.","ref":"Image.Shape.html#t:path/0"},{"type":"type","title":"Image.Shape.point/0","doc":"A point is a list of two integers representing the x and y coordinates","ref":"Image.Shape.html#t:point/0"},{"type":"module","title":"Image.Social","doc":"Functions to introspect standard image sizes for various social media platforms.","ref":"Image.Social.html"},{"type":"function","title":"Image.Social.default_image_usage/1","doc":"Returns the default image type that an image is resized to for a given platform is no :type parameter is provided. Arguments platform is any known social platform. See Image.Social.known_platforms/0 . Returns The default image type for the platform. Example","ref":"Image.Social.html#default_image_usage/1"},{"type":"function","title":"Image.Social.image_usages/1","doc":"Returns the image types for the given social platform. Arguments platform is any known social platform. See Image.Social.known_platforms/0 . Returns A list of images uses available for the platform. Example","ref":"Image.Social.html#image_usages/1"},{"type":"function","title":"Image.Social.known_platforms/0","doc":"Returns a list of known social platforms. Example","ref":"Image.Social.html#known_platforms/0"},{"type":"function","title":"Image.Social.media_sizes/0","doc":"Return the map of social media image sizes. The returned map of maps is of a standard form: The first key is the platform name (ie :twitter ) The second key is the image type for the platform (ie :profile ) The third level is optional. But if it exists it must have three keys: :landscape , :portrait and :square The values are all of the form &quot;WxH&quot; where W is the width in pixels and H is the height in pixels.","ref":"Image.Social.html#media_sizes/0"},{"type":"function","title":"Image.Social.resize/3","doc":"Resize an image for a particular social platform and usage. This function: Resizes an image to the correct dimensions, including being image aspect aware Converts to the sRGB color space Minimises metadata (retains only Artist and Copyright) Arguments image is any Vix.Vips.Image.t/0 platform is the name of a known social media platform. See Image.Social.known_platforms/0 . options is a keyword list of options. Options :type is the image type within the social platform for which the image should be resized. See Image.Social.image_usages/1 All other options are passed to Image.thumbnail!/3 . Returns {:ok, resized_image} or {:error, reason}","ref":"Image.Social.html#resize/3"},{"type":"function","title":"Image.Social.resize!/3","doc":"Resize an image for a particular social platform and usage. This function: Resizes an image to the correct dimensions, including being image orientation aware Converts to the sRGB color space Minimises metadata (retains only Artist and Copyright) Arguments image is any Vix.Vips.Image.t/0 platform is the name of a known social media platform. See Image.Social.known_platforms/0 . options is a keyword list of options. Options :type is the image type within the social platform for which the image should be resized. See Image.Social.image_usages/1 All other options are passed to Image.thumbnail!/3 . Returns resized_image or Raises an exception.","ref":"Image.Social.html#resize!/3"},{"type":"type","title":"Image.Social.image_usage/0","doc":"The social media platform image usage.","ref":"Image.Social.html#t:image_usage/0"},{"type":"type","title":"Image.Social.platform/0","doc":"The known social media platforms.","ref":"Image.Social.html#t:platform/0"},{"type":"module","title":"Image.Text","doc":"Functions for the creation of images from text.","ref":"Image.Text.html"},{"type":"function","title":"Image.Text.add_background/2","doc":"Adds a background to an image generated from text. Arguments image is any t:Vimage.t/0 but is expected to be an image generated by Image.Text.text/2 . options is a Keyword.t/0 list of options Options :background_fill_color is the background fill color behind the text. The default is :none which indicates no background. Note that if :background_fill_opacity is the opacity of the background. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . Returns {:ok, image} or {:error, reason} Notes Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#add_background/2"},{"type":"function","title":"Image.Text.add_background!/2","doc":"Adds a background to an image generated from text returning and image or raising an exception. Arguments image is any t:Vimage.t/0 but is expected to be an image generated by Image.Text.text/2 . options is a Keyword.t/0 list of options Options :background_fill_color is the background fill color behind the text. The default is :none which indicates no background. Note that if :background_fill_opacity is the opacity of the background. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . Returns image or raises an exception Notes Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#add_background!/2"},{"type":"function","title":"Image.Text.add_background_border/2","doc":"Adds a border on an image, typically an image generated from a string. Arguments image is any t:Vimage.t/0 options is a Keyword.t/0 list of options Options :background_stroke_color is the colour of the outline of the background. The default is &quot;none&quot;, :background_stroke_width is the integer size in pixels of the background border. The default is 1 . :background_stroke_opacity is the opacity of the background string. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . Returns {:ok, image} or {:error, reason} Notes Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#add_background_border/2"},{"type":"function","title":"Image.Text.add_background_border!/2","doc":"Adds a border on an image, typically an image generated from a string. Returns an image or raises an exception. Arguments image is any t:Vimage.t/0 options is a Keyword.t/0 list of options Options :background_stroke_color is the colour of the outline of the background. The default is &quot;none&quot;, :background_stroke_width is the integer size in pixels of the background border. The default is 1 . :background_stroke_opacity is the opacity of the background string. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . Returns image or raises an exception Notes Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#add_background_border!/2"},{"type":"function","title":"Image.Text.add_background_padding/2","doc":"Adds padding to a background to an image generated from text. Arguments image is any t:Vimage.t/0 but is expected to be an image generated by Image.Text.add_background/2 . options is a Keyword.t/0 list of options Options :background_fill_color is the background fill color behind the text. The default is :none which indicates no background. Note that if :background_fill_opacity is the opacity of the background. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . :padding is the padding in pixels between the text and the edge of the background. It can be expressed as a single integer integer in which case the same padding is applied to all four sides of the image. It can also be expressed as a list of two integers like [0, 0] . The first integer will be used as the padding for the left and right of the image. The second integer will be used for the top and bottom of the image. Another alternative is to pass a t:Vimage.t/0 in which case the padding will be derived from the image dimensions such that the background covers the whole of the impage. THe default is [0, 0] . Returns {:ok, image} or {:error, reason} Notes Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#add_background_padding/2"},{"type":"function","title":"Image.Text.add_background_padding!/2","doc":"Adds padding to a background to an image generated from text returning an image or raising an exception. Arguments image is any t:Vimage.t/0 but is expected to be an image generated by Image.Text.add_background/2 . options is a Keyword.t/0 list of options Options :background_fill_color is the background fill color behind the text. The default is :none which indicates no background. Note that if :background_fill_opacity is the opacity of the background. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . :padding is the padding in pixels between the text and the edge of the background. It can be expressed as a single integer integer in which case the same padding is applied to all four sides of the image. It can also be expressed as a list of two integers like [0, 0] . The first integer will be used as the padding for the left and right of the image. The second integer will be used for the top and bottom of the image. Another alternative is to pass a t:Vimage.t/0 in which case the padding will be derived from the image dimensions such that the background covers the whole of the impage. THe default is [0, 0] . Returns image or raises an exception Notes Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#add_background_padding!/2"},{"type":"function","title":"Image.Text.simple_text/2","doc":"Creates an image from the provided text. This function creates an image from the text but does not apply a background or padding. Arguments string is any string. The string will be HTML-escaped to avoid malicious code injection. If you are completely confident that the text is safe then you can pass it by calling with Phoenix.HTML.raw/1 on the string first. options is a Keyword.t/0 list of options Options The applicable options vary slightly depending on whether :autofit is set to true or false . When false (the default), the text is rendered using svg and therefore separate text stroke color, text fill colour, text stroke width and font weight can be specified. However the size of the text box will be determined by the combination of the font size and text length - there is no line wrapping. If true the text is formatted to fit within the options :width and :height and the text is sized to fit within the box. :height can be ommitted and it will expand to fit the text of the specified size. Options for when autofit: false :text_fill_color is the fill color of the text. The default is &quot;white&quot;. If set to :transparent then the text will be rendered transparently against a background. A black background will be forced if a :background_fill_color is not provided :text_stroke_color is the color of the outline of each character in the string. The default is &quot;none&quot;. :text_stroke_width is the integer width in pixels of the outline of each character in the string. The default is 1 :font_size is an integer font size in pixels. The default is 50 . Options for when autofit: true :width is the width of the generated text image. :height is the height of the generated text image. :font_size is an integer font size in pixels. The default is 50 . If set to 0 , the font size will be calculated to fit the text within the specified :width and :height . :justify is a boolean indicating whether to justify text. The default is false . :align indicates how multiple lines of text are aligned. The options are :left , :right and :center . The default is :left . :letter_spacing is the amount of space in pixels between each letter. Default is :normal . Options applicable in all cases :font is any font recognised on the host system. The default is &quot;Helvetica&quot;. :font_weight is the font weight . The alternatives are :normal , :bold , :lighter , :bolder , or an integer between 1 and 1_000 . The default is :normal which is equivalent to 400 . Returns {:ok, image} or {:error, reason} Notes There is no text wrapping, justification or kerning applied. This means this function is not a general purpose text layout function and is suitable mostly for overlaying text for emphasis over another image. Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#simple_text/2"},{"type":"function","title":"Image.Text.simple_text!/2","doc":"Creates an image from the provided text and returns an image or raises an exception. This function creates an image from the text but does not apply a background or padding. Arguments string is any string. The string will be HTML-escaped to avoid malicious code injection. If you are completely confident that the text is safe then you can pass it by calling with Phoenix.HTML.raw/1 on the string first. options is a Keyword.t/0 list of options Options The applicable options vary slightly depending on whether :autofit is set to true or false . When false (the default), the text is rendered using svg and therefore separate text stroke color, text fill colour, text stroke width cand font weight an be specified. However the size of the text box will be determined by the combination of the font size and text length - there is no line wrapping. If true the text is formatted to fit within the options :width and :height and the text is sized to fit within the box. :height can be ommitted and it will expand to fit the text of the specified size. Options for when autofit: false :text_fill_color is the fill color of the text. The default is &quot;white&quot;. If set to :transparent then the text will be rendered transparently against a background. A black background will be forced if a :background_fill_color is not provided :text_stroke_color is the color of the outline of each character in the string. The default is &quot;none&quot;. :text_stroke_width is the integer width in pixels of the outline of each character in the string. The default is 1 :font_size is an integer font size in pixels. The default is 50 . Options for when autofit: true :width is the width of the generated text image. :height is the height of the generated text image. :font_size is an integer font size in pixels. The default is 50 . If set to 0 , the font size will be calculated to fit the text within the specified :width and :height . :justify is a boolean indicating whether to justify text. The default is false . :align indicates how multiple lines of text are aligned. The options are :left , :right and :center . The default is :left . :letter_spacing is the amount of space in pixels between each letter. Default is :normal . Options applicable in all cases :font is any font recognised on the host system. The default is&quot;Helvetica&quot;. :font_weight is the font weight . The alternatives are :normal , :bold , :lighter , :bolder , or an integer between 1 and 1_000 . The default is :normal which is equivalent to 400 . Returns image or raises an exception Notes There is no text wrapping, justification or kerning applied. This means this function is not a general purpose text layout function and is suitable mostly for overlaying text for emphasis over another image. Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#simple_text!/2"},{"type":"function","title":"Image.Text.text/2","doc":"Create a new image from the provided string and formatting options. text/2 creates an image with the following steps: Render the text Add an optional background color Expand the background according to the required padding The text can be rendered as a positive (the default) in which an image of the provided string is rendered in the provided font, weight, size, fill color and stroke color. It can also be rendered transparently in which case a background color is required against which the transparent text can be composed. If not provided, the background color will be black. After rendering the text and composing it against the (optional) background, the background can be expanded to provide some padding between the text and any base image onto which it is later composed. The default no padding. Arguments string is any string. The string will be HTML-escaped to avoid malicious code injection. If you are completely confident that the text is safe then you can pass it by calling with Phoenix.HTML.raw/1 on the string first. options is a Keyword.t/0 list of options Options :font is any font recognised on the host system. The default is&quot;Helvetica&quot;. :font_size is an integer font size in pixels. The default is 50 . :font_weight is the font weight . The alternatives :normal , :bold , :lighter , :bolder , or an integer between 1 and 1_000 . The default is :normal which is equivalent to 400 . :text_fill_color is the fill color of the text. The default is &quot;white&quot;. If set to :transparent then the text will be rendered transparently against a background. A black background will be forced if a :background_fill_color is not provided :text_stroke_color is the color of the outline of each character in the string. The default is &quot;none&quot;. :text_stroke_width is the integer width in pixels of the outline of each character in the string. The default is 1 . :background_fill_opacity is the opacity of the background fill. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . :padding is the padding in pixels between the text and the edge of the background. It can be expressed as a single integer integer in which case the same padding is applied to all four sides of the image. It can also be expressed as a list of two integers like [0, 0] . The first integer will be used as the padding for the left and right of the image. The second integer will be used for the top and bottom of the image. Another alternative is to pass a t:Vimage.t/0 in which case the padding will be derived from the image dimensions such that the background covers the whole of the impage. THe default is [0, 0] . :letter_spacing is the amount of space in pixels between each letter. Default is :normal . :background_fill_color is the background fill color behind the text. The default is :none which indicates no background. Note that if :background_stroke_color is the colour of the outline of the background. The default is &quot;none&quot;, :background_stroke_width is the integer size in pixels of the background border. The default is 1 . :background_stroke_opacity is the opacity of the background string. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . :x is the horizontal location of the text on its background. The value is either a non-negative integer or one of :left , :right or :center . The default is :center . :y is the vertical location of the text on its background. The value is either a non-negative integer or one of :top , :middle or :bottom . The default is :middle . Returns {:ok, image} or {:error, reason} Notes There is no text wrapping, justification or kerning applied. This means this function is not a general purpose text layout function and is suitable mostly for overlaying text for emphasis over another image. Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#text/2"},{"type":"function","title":"Image.Text.text!/2","doc":"Create a new image from the provided string and formatting options returning an image or raising an exception. text!/2 creates an image with the following steps: Render the text Add an optional background color Expand the background according to the required padding The text can be rendered as a positive (the default) in which an image of the provided string is rendered in the provided font, weight, size, fill color and stroke color. It can also be rendered transparently in which case a background color is required against which the transparent text can be composed. If not provided, the background color will be black. After rendering the text and composing it against the (optional) background, the background can be expanded to provide some padding between the text and any base image onto which it is later composed. The default no padding. Arguments string is any string. The string will be HTML-escaped to avoid malicious code injection. If you are completely confident that the text is safe then you can pass it by calling with Phoenix.HTML.raw/1 on the string first. options is a Keyword.t/0 list of options Options :font is any font recognised on the host system. The default is&quot;Helvetica&quot;. :font_size is an integer font size in pixels. The default is 50 . :font_weight is the font weight . The alternatives :normal , :bold , :lighter , :bolder , or an integer between 1 and 1_000 . The default is :normal which is equivalent to 400 . :text_fill_color is the fill color of the text. The default is &quot;white&quot;. If set to :transparent then the text will be rendered transparently against a background. A black background will be forced if a :background_fill_color is not provided :text_stroke_color is the color of the outline of each character in the string. The default is &quot;none&quot;. :text_stroke_width is the integer width in pixels of the outline of each character in the string. The default is 1 . :background_fill_opacity is the opacity of the background fill. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . :padding is the padding in pixels between the text and the edge of the background. It can be expressed as a single integer integer in which case the same padding is applied to all four sides of the image. It can also be expressed as a list of two integers like [0, 0] . The first integer will be used as the padding for the left and right of the image. The second integer will be used for the top and bottom of the image. Another alternative is to pass a t:Vimage.t/0 in which case the padding will be derived from the image dimensions such that the background covers the whole of the impage. THe default is [0, 0] . :letter_spacing is the amount of space in pixels between each letter. Default is :normal . :background_fill_color is the background fill color behind the text. The default is :none which indicates no background. Note that if :background_stroke_color is the colour of the outline of the background. The default is &quot;none&quot;, :background_stroke_width is the integer size in pixels of the background border. The default is 1 . :background_stroke_opacity is the opacity of the background string. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . :x is the horizontal location of the text on its background. The value is either a non-negative integer or one of :left , :right or :center . The default is :center . :y is the vertical location of the text on its background. The value is either a non-negative integer or one of :top , :middle or :bottom . The default is :middle . Returns image or raises an exception Notes There is no text wrapping, justification or kerning applied. This means this function is not a general purpose text layout function and is suitable mostly for overlaying text for emphasis over another image. Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#text!/2"},{"type":"module","title":"Image.Video","doc":"Implements functions to extract frames froma video file as images using eVision . The implementation is based upon OpenCV Video Capture . Images can be extracted by frame number of number of milliseconds with Image.Video.image_from_video/2 . In order to extract images the video file must first be opened with Image.Video.open/1 . At the end of processing the video file should be closed with Image.Video.close/1 . This process can be wrapped by Image.Video.with_video/2 which will open a video file, execute a function (passing it the video reference) and closing the video file at the end of the function. Note This module is only available if the optional dependency eVision is configured in mix.exs .","ref":"Image.Video.html"},{"type":"function","title":"Image.Video.available_backend?/1","doc":"Returns a boolean indicating if the specified backend is available (configured and available for use).","ref":"Image.Video.html#available_backend?/1"},{"type":"function","title":"Image.Video.available_backends/0","doc":"Returns a list of available (configured and available for use) backend video processors. See the OpenCV documentation for more information on video processor backends.","ref":"Image.Video.html#available_backends/0"},{"type":"function","title":"Image.Video.close/1","doc":"Closes a video. Arguments video is any t:VideoCapture.t/0 . Returns {:ok, closed_video} or {:error, reason} . Example iex&gt; { :ok , video } = Image.Video . open &quot;./test/support/video/video_sample.mp4&quot; iex&gt; Image.Video . close ( video )","ref":"Image.Video.html#close/1"},{"type":"function","title":"Image.Video.close!/1","doc":"Closes a video or raises an exception. Arguments video is any t:VideoCapture.t/0 . Returns closed_video or raises an exception. Example iex&gt; { :ok , video } = Image.Video . open &quot;./test/support/video/video_sample.mp4&quot; iex&gt; Image.Video . close! ( video )","ref":"Image.Video.html#close!/1"},{"type":"function","title":"Image.Video.image_from_video/2","doc":"Extracts a frame from a video and returns an image. After the image is extracted the play head in the video file is advanced one frame. That is, successive calls to Image.Video.image_from_video/2 will return successive frames - not the same frame. Arguments video is any t:VideoCapture.t/0 options is a keyword list of options. The defalt Options unit is either :frame or :millisecond with a non-negative integer offset. For example frame: 3 . The default is [] which means that no seek is performed and the extracted image is taken from the current position in the file or video stream. Note that seeking is not guaranteed to be accurate. If frame accuracy is required the recommended process is: Open the video file with Image.Video.open/1 Scrub forward to the required freame with Image.Video.scrub/2 Then capture the frame with Image.Video.image_from_video/1 Returns {:ok, image} or {:error, reason} . Notes Seeking cannot be performed on image streams such as webcams. Therefore no options may be provided when extracting images from an image stream. Examples iex&gt; { :ok , video } = Image.Video . open ( &quot;./test/support/video/video_sample.mp4&quot; ) iex&gt; { :ok , _image } = Image.Video . image_from_video ( video ) iex&gt; { :ok , _image } = Image.Video . image_from_video ( video , frame : 0 ) iex&gt; { :ok , _image } = Image.Video . image_from_video ( video , millisecond : 1_000 ) iex&gt; Image.Video . image_from_video ( video , frame : - 1 ) { :error , &quot;Offset for :frame must be a non-negative integer. Found -1&quot; } iex&gt; Image.Video . image_from_video ( video , frame : 500 ) { :error , &quot;Offset for :frame is too large&quot; }","ref":"Image.Video.html#image_from_video/2"},{"type":"function","title":"Image.Video.image_from_video!/2","doc":"Extracts a frame from a video and returns an image or raises an exception. After the image is extracted the play head in the video file is advanced one frame. That is, successive calls to Image.Video.image_from_video/2 will return successive frames - not the same frame. Arguments video is any t:VideoCapture.t/0 . options is a keyword list of options. Options unit is either :frame or :millisecond with a non-negative integer offset. For example frame: 3 . The default is [] which means that no seek is performed and the extracted image is taken from the current position in the file or video stream. Note that seeking is not guaranteed to be accurate. If frame accuracy is required the recommended process is: Open the video file with Image.Video.open/1 Scrub forward to the required freame with Image.Video.scrub/2 Then capture the frame with Image.Video.image_from_video/1 Returns image or raises an exception. Notes Seeking cannot be performed on image streams such as webcams. Therefore no options may be provided when extracting images from an image stream.","ref":"Image.Video.html#image_from_video!/2"},{"type":"macro","title":"Image.Video.is_frame/2","doc":"Guards that a frame offset is valid for a video","ref":"Image.Video.html#is_frame/2"},{"type":"macro","title":"Image.Video.is_stream/1","doc":"Guards that a stream id is valid for a video stream","ref":"Image.Video.html#is_stream/1"},{"type":"macro","title":"Image.Video.is_valid_millis/3","doc":"Guards that a millisecond count is valid for a video","ref":"Image.Video.html#is_valid_millis/3"},{"type":"function","title":"Image.Video.known_backend?/1","doc":"Returns a boolean indicating if the specified backend is known (valid but not necessarily available for use in the current OpenCV configuration). Examples iex&gt; Image.Video . known_backend? ( :avfoundation ) true iex&gt; Image.Video . known_backend? ( :invalid ) false iex&gt; Image.Video . known_backend? ( 1200 ) true iex&gt; Image.Video . known_backend? ( - 1 ) false","ref":"Image.Video.html#known_backend?/1"},{"type":"function","title":"Image.Video.known_backends/0","doc":"Returns a list of known (valid but not necessarily available for use in the current OpenCV configuration) backend video processors. See the OpenCV documentation for more information on video processor backends. Example iex&gt; Image.Video . known_backends ( ) |&gt; Enum . sort ( ) [ :android , :any , :aravis , :avfoundation , :cmu1394 , :dc1394 , :dshow , :ffmpeg , :fireware , :firewire , :giganetix , :gphoto2 , :gstreamer , :ieee1394 , :images , :intel_mfx , :intelperc , :msmf , :obsensor , :opencv_mjpeg , :openni , :openni2 , :openni2_astra , :openni2_asus , :openni_asus , :pvapi , :qt , :realsense , :ueye , :unicap , :v4l , :v4l2 , :vfw , :winrt , :xiapi , :xine ]","ref":"Image.Video.html#known_backends/0"},{"type":"function","title":"Image.Video.open/2","doc":"Opens a video file or video stream for frame extraction. Arguments filename_or_stream is the filename of a video file or the OpenCV representation of a video stream as an integer. It may also be :default_camera to open the default camera if there is one. options is a keyword list of options. The default is [] . Options :backend specifies the backend video processing system to be used. The default is :any which means that the first available backend in the current OpenCV configuration will be used. The available backends can be returned by Image.Video.available_backends/0 . Returns {:ok, video} or {:error, reason} . Note The video t:VideoCapture.t/0 struct that is returned includes metadata fields for frame rate (:fps), frame width (:frame_width), frame height (:frame_height) and frame count (:frame_count). Note that frame count is an approximation due to issues in the underlying OpenCV . Example iex&gt; Image.Video . open &quot;./test/support/video/video_sample.mp4&quot; iex&gt; { :ok , camera_video } = Image.Video . open ( :default_camera ) iex&gt; Image.Video . close ( camera_video )","ref":"Image.Video.html#open/2"},{"type":"function","title":"Image.Video.open!/1","doc":"Opens a video file for frame extraction or raises an exception. Arguments filename is the filename of a video file. options is a keyword list of options. The default is [] . Options :backend specifies the backend video processing system to be used. The default is :any which means that the first available backend in the current OpenCV configuration will be used. The available backends can be returned by Image.Video.available_backends/0 . Returns video or raises an exception. Example iex&gt; Image.Video . open! &quot;./test/support/video/video_sample.mp4&quot;","ref":"Image.Video.html#open!/1"},{"type":"function","title":"Image.Video.scrub/2","doc":"Scrubs a video forward by a number of frames. In OpenCV (the underlying video library used by Image.Video ), seeking to a specified frame is not frame accurate. This function moves the video play head forward frame by frame and is therefore a frame accurate way of moving the the video head forward. Arguements video is any t:VideoCapture.t/0 . frames is a positive integer number of frames to scrub forward. Returns {:ok, frames_scrubbed} . frames_scrubbed may be less than the number of requested frames. This may happen of the end of the video stream is reached, or {:error, reason} . Examples iex&gt; { :ok , video } = Image.Video . open &quot;./test/support/video/video_sample.mp4&quot; iex&gt; { :ok , 10 } = Image.Video . scrub ( video , 10 ) iex&gt; Image.Video . scrub ( video , 100_000_000 ) { :ok , 161 }","ref":"Image.Video.html#scrub/2"},{"type":"function","title":"Image.Video.seek/2","doc":"Seeks the video head to a specified frame offset or millisecond offset. Note that seeking a video format is supported, seeking a live video stream (such as from a webcam) is not supported and will return an error. Arguments video is any t:VideoCapture.t/0 . options is a keyword list of options. Options unit is either :frame or :millisecond with a non-negative integer offset. For example frame: 3 . Returns {:ok, video} or {:error, reason} Notes Seeking cannot be performed on image streams such as webcams. Therefore no options may be provided when extracting images from an image stream. Warning Seeking is not frame accurate ! Examples iex&gt; { :ok , video } = Image.Video . open ( &quot;./test/support/video/video_sample.mp4&quot; ) iex&gt; { :ok , _image } = Image.Video . seek ( video , frame : 0 ) iex&gt; { :ok , _image } = Image.Video . seek ( video , millisecond : 1_000 ) iex&gt; Image.Video . seek ( video , frame : - 1 ) { :error , &quot;Offset for :frame must be a non-negative integer. Found -1&quot; }","ref":"Image.Video.html#seek/2"},{"type":"function","title":"Image.Video.seek!/2","doc":"Seeks the video head to a specified frame offset or millisecond offset. Note that seeking a video format is supported, seeking a live video stream (such as from a webcam) is not supported and will return an error. Arguments video is any t:VideoCapture.t/0 . options is a keyword list of options. Options unit is either :frame or :millisecond with a non-negative integer offset. For example frame: 3 . Returns {:ok, video} or {:error, reason} . Notes Seeking cannot be performed on image streams such as webcams. Therefore no options may be provided when extracting images from an image stream.","ref":"Image.Video.html#seek!/2"},{"type":"function","title":"Image.Video.stream!/2","doc":"Returns video file or live video as a Enumerable.t/0 stream. This allows a video file or live video to be streamed for processing like any other enumerable. Arguments filename_or_stream is either a pathname on the current system, a non-negative integer representing a video stream or :default_camera representing the stream for the default system camera. It can also be a t:VideoCapture.t/0 representing a video file or stream that is already opened (this is the preferred approach). options is a keyword list of options. Options Only one of the following options can be provided. No options means the entire video will be streamed frame by frame. :frame is a Range.t/0 representing the range of frames to be extracted. :frames can only be specified for video files, not for video streams. For example, frames: 10..100/2 will produce a stream of images that are every second image between the frame offsets 10 and 100 . :millisecond is a Range.t/0 representing the range of milliseconds to be extracted. :millisecond can only be specified for video files, not for video streams. For example, millisecond: 1000..100000/2 will produce a stream of images that are every second image between the millisecond offsets of 1_000 and 100_000 . Returns A Enumerable.t/0 that can be used with functions in the Stream and Enum modules to lazily enumerate images extracted from a video stream. Example # Extract every second frame starting at the # first frame and ending at the last frame. iex&gt; &quot;./test/support/video/video_sample.mp4&quot; ...&gt; |&gt; Image.Video . stream! ( frame : 0 .. - 1 // 2 ) ...&gt; |&gt; Enum . to_list ( ) ...&gt; |&gt; Enum . count ( ) 86","ref":"Image.Video.html#stream!/2"},{"type":"function","title":"Image.Video.with_video/2","doc":"Opens a video file, calls the given function with the video reference and closes the video after the function returns. Arguments filename is the filename of a video file Returns {:ok, video} or {:error, reason} Example iex&gt; Image.Video . with_video &quot;./test/support/video/video_sample.mp4&quot; , fn video -&gt; ...&gt; Image.Video . image_from_video ( video , 1 ) ...&gt; end","ref":"Image.Video.html#with_video/2"},{"type":"type","title":"Image.Video.seek_options/0","doc":"The valid options for Image.Video.seek/2, Image.Video.image_from_video/2","ref":"Image.Video.html#t:seek_options/0"},{"type":"type","title":"Image.Video.stream_id/0","doc":"The representation of a video stream","ref":"Image.Video.html#t:stream_id/0"},{"type":"module","title":"Image.Exif","doc":"Functions to extract and interpret image EXIF data.","ref":"Image.Exif.html"},{"type":"function","title":"Image.Exif.extract_exif/1","doc":"Extract EXIF data from a binary blob.","ref":"Image.Exif.html#extract_exif/1"},{"type":"function","title":"Image.Exif.field/1","doc":"","ref":"Image.Exif.html#field/1"},{"type":"function","title":"Image.Exif.read_exif/2","doc":"","ref":"Image.Exif.html#read_exif/2"},{"type":"type","title":"Image.Exif.context/0","doc":"","ref":"Image.Exif.html#t:context/0"},{"type":"type","title":"Image.Exif.t/0","doc":"","ref":"Image.Exif.html#t:t/0"},{"type":"type","title":"Image.Exif.value/0","doc":"","ref":"Image.Exif.html#t:value/0"},{"type":"module","title":"Image.Xmp","doc":"Functions to extract and interpret image XMP data.","ref":"Image.Xmp.html"},{"type":"function","title":"Image.Xmp.extract_xmp/1","doc":"","ref":"Image.Xmp.html#extract_xmp/1"},{"type":"module","title":"Image.Kino","doc":"Helper functions to simplify rendering images in Kino.","ref":"Image.Kino.html"},{"type":"function","title":"Image.Kino.show/2","doc":"Renders an image in Kino , Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :max_height determines the maximum height for the rendered image. The aspect ratio of the rendered image is unchanged. The default is 200 . Returns maybe_resized_image of type Kino.Image.t/0 .","ref":"Image.Kino.html#show/2"},{"type":"module","title":"Image.Options.Avatar","doc":"Options and option validation for Image.avatar/2 .","ref":"Image.Options.Avatar.html"},{"type":"function","title":"Image.Options.Avatar.validate_options/1","doc":"","ref":"Image.Options.Avatar.html#validate_options/1"},{"type":"type","title":"Image.Options.Avatar.avatar_options/0","doc":"","ref":"Image.Options.Avatar.html#t:avatar_options/0"},{"type":"module","title":"Image.Options.Blur","doc":"Options and option validation for Image.blur/2 .","ref":"Image.Options.Blur.html"},{"type":"function","title":"Image.Options.Blur.validate_options/1","doc":"Validate the options for Image.blur/2 . See Image.Options.Blur.blur_options/0 .","ref":"Image.Options.Blur.html#validate_options/1"},{"type":"type","title":"Image.Options.Blur.blur_option/0","doc":"Options applicable to Image.blur/2","ref":"Image.Options.Blur.html#t:blur_option/0"},{"type":"type","title":"Image.Options.Blur.blur_options/0","doc":"Options list for Image.blur/2","ref":"Image.Options.Blur.html#t:blur_options/0"},{"type":"module","title":"Image.Options.ChromaKey","doc":"Options and option validation for Image.chroma_key/2 .","ref":"Image.Options.ChromaKey.html"},{"type":"function","title":"Image.Options.ChromaKey.validate_options/1","doc":"Validate the options for Image.chroma_key/2 .","ref":"Image.Options.ChromaKey.html#validate_options/1"},{"type":"type","title":"Image.Options.ChromaKey.chroma_key_options/0","doc":"Options applicable to Image.chroma_key/2","ref":"Image.Options.ChromaKey.html#t:chroma_key_options/0"},{"type":"module","title":"Image.Options.Compare","doc":"Options and option validation for Image.compare/3 .","ref":"Image.Options.Compare.html"},{"type":"function","title":"Image.Options.Compare.validate_options/1","doc":"Validate the options for Image.compare/3 .","ref":"Image.Options.Compare.html#validate_options/1"},{"type":"type","title":"Image.Options.Compare.compare_option/0","doc":"Options applicable to Image.compare/3 .","ref":"Image.Options.Compare.html#t:compare_option/0"},{"type":"type","title":"Image.Options.Compare.compare_options/0","doc":"","ref":"Image.Options.Compare.html#t:compare_options/0"},{"type":"module","title":"Image.Options.Compose","doc":"This module processes the options for Image.compose/3 . Since x,y can be relative or absolution, can be symbolic or numeric and can even by a function this becomes more complex that it might initially seem","ref":"Image.Options.Compose.html"},{"type":"function","title":"Image.Options.Compose.default_composit_options/0","doc":"","ref":"Image.Options.Compose.html#default_composit_options/0"},{"type":"type","title":"Image.Options.Compose.composition_option/0","doc":"When composing an image on a base image, these options drive how the composition proceeds. :x describes the absolute x offset on the base image where this image will be placed. If this option is set to :left , :center or :right then the x position will be calculated relative to the base image. If :x is nil (the default) then the image will be placed according to the relative offset of the previously composed image using :dx . :y describes the absolute y offset on the base image where this image will be placed. If this option is set to :top , :middle or :bottom then the y position will be calculated relative to the base image. If :y is nil (the default) then the image will be placed according to the relative offset of the previously composed image using :dy . :dx describes the relative offset used to calculate the x value. :dx is an integer offset from the edge of the previously composed image. Which edge is determined by the :x_baseline option. If :x is also specified then :x is first calculated, then :dx is added to it. In this case, :x_baseline is ignored. :dy describes the relative offset used to calculate the y value. :dy is an integer offset from the edge of the previously composed image. Which edge is determined by the :y_baseline option. If :y is also specified then :y is first calculated, then :dy is added to it. In this case, :x_baseline is ignored. :blend_mode is the Image.BlendMode.t/0 used when composing this image over its base image. The default is :over which is appropriate for most use cases. :x_baseline establishes the baseline on the previously composed image from which :dx is calculated. The default is :right . :y_baseline establishes the baseline on the previously composed image from which :dy is calculated. The default is :bottom .","ref":"Image.Options.Compose.html#t:composition_option/0"},{"type":"type","title":"Image.Options.Compose.t/0","doc":"Image compoositions options","ref":"Image.Options.Compose.html#t:t/0"},{"type":"module","title":"Image.Options.Crop","doc":"Options and option validation for Image.crop/5 .","ref":"Image.Options.Crop.html"},{"type":"function","title":"Image.Options.Crop.validate_options/1","doc":"Validates options to Iamge.crop/5 .","ref":"Image.Options.Crop.html#validate_options/1"},{"type":"type","title":"Image.Options.Crop.crop_focus/0","doc":"Indicates how to determine where to crop an image to fill a target area. :none means the image will be reduced to fit the required bounding box and no cropping will occur. :center means crop from the center of the image. The central part of the image will be returned, cropped to fill the bounding box. :entropy uses an entropy measure. :attention means crop the image by looking for features likely to draw human attention. :low means position the crop towards the low coordinate. This means the bottom part of the image remains after the crop. :high means position the crop towards the high coordinate. This means the top part of the image remains after the crop.","ref":"Image.Options.Crop.html#t:crop_focus/0"},{"type":"type","title":"Image.Options.Crop.crop_options/0","doc":"Options applicable to cropping an image. Currently there are no options.","ref":"Image.Options.Crop.html#t:crop_options/0"},{"type":"module","title":"Image.Options.Draw","doc":"Options and options validation for the drawing functionss.","ref":"Image.Options.Draw.html"},{"type":"function","title":"Image.Options.Draw.validate_options/2","doc":"Validate the options for Image.Draw .","ref":"Image.Options.Draw.html#validate_options/2"},{"type":"type","title":"Image.Options.Draw.circle/0","doc":"","ref":"Image.Options.Draw.html#t:circle/0"},{"type":"type","title":"Image.Options.Draw.flood/0","doc":"","ref":"Image.Options.Draw.html#t:flood/0"},{"type":"type","title":"Image.Options.Draw.image/0","doc":"","ref":"Image.Options.Draw.html#t:image/0"},{"type":"type","title":"Image.Options.Draw.line/0","doc":"","ref":"Image.Options.Draw.html#t:line/0"},{"type":"type","title":"Image.Options.Draw.mask/0","doc":"","ref":"Image.Options.Draw.html#t:mask/0"},{"type":"type","title":"Image.Options.Draw.point/0","doc":"","ref":"Image.Options.Draw.html#t:point/0"},{"type":"type","title":"Image.Options.Draw.rect/0","doc":"","ref":"Image.Options.Draw.html#t:rect/0"},{"type":"type","title":"Image.Options.Draw.smudge/0","doc":"","ref":"Image.Options.Draw.html#t:smudge/0"},{"type":"module","title":"Image.Options.Embed","doc":"Options and option validation for Image.embed/4 .","ref":"Image.Options.Embed.html"},{"type":"function","title":"Image.Options.Embed.validate_options/4","doc":"Validate the options for Image.embed/4 .","ref":"Image.Options.Embed.html#validate_options/4"},{"type":"type","title":"Image.Options.Embed.embed_options/0","doc":"Options applicable to Image.embed/4 .","ref":"Image.Options.Embed.html#t:embed_options/0"},{"type":"type","title":"Image.Options.Embed.extend_mode/0","doc":"When extending the canvas the generated pixels are determined by this option.","ref":"Image.Options.Embed.html#t:extend_mode/0"},{"type":"module","title":"Image.Options.Equalize","doc":"Options and option validation for Image.equalize/2 .","ref":"Image.Options.Equalize.html"},{"type":"function","title":"Image.Options.Equalize.validate_options/1","doc":"Validate the options for Image.equalize/2 .","ref":"Image.Options.Equalize.html#validate_options/1"},{"type":"type","title":"Image.Options.Equalize.equalize_option/0","doc":"Options applicable to Image.equalize/2 .","ref":"Image.Options.Equalize.html#t:equalize_option/0"},{"type":"module","title":"Image.Options.Histogram","doc":"Options and option validation for Image.Histogram.as_svg/2 .","ref":"Image.Options.Histogram.html"},{"type":"function","title":"Image.Options.Histogram.validate_options/1","doc":"Validate the options for Image.Histogram.as_svg/2 .","ref":"Image.Options.Histogram.html#validate_options/1"},{"type":"type","title":"Image.Options.Histogram.histogram_option/0","doc":"Options applicable to Image.Histogram.as_svg/2 .","ref":"Image.Options.Histogram.html#t:histogram_option/0"},{"type":"type","title":"Image.Options.Histogram.histogram_options/0","doc":"Options list or map for Image.Histogram.as_svg/2 .","ref":"Image.Options.Histogram.html#t:histogram_options/0"},{"type":"module","title":"Image.Options.LocalContrast","doc":"Options and option validation for Image.local_contrast/2 .","ref":"Image.Options.LocalContrast.html"},{"type":"function","title":"Image.Options.LocalContrast.validate_options/1","doc":"Validate the options for Image.local_contrast/2 .","ref":"Image.Options.LocalContrast.html#validate_options/1"},{"type":"type","title":"Image.Options.LocalContrast.local_contrast_option/0","doc":"Options applicable to Image.local_contrast/2 .","ref":"Image.Options.LocalContrast.html#t:local_contrast_option/0"},{"type":"type","title":"Image.Options.LocalContrast.local_contrast_options/0","doc":"Options list or map for Image.local_contrast/2 .","ref":"Image.Options.LocalContrast.html#t:local_contrast_options/0"},{"type":"module","title":"Image.Options.Meme","doc":"Options and option validation for Image.meme/2 .","ref":"Image.Options.Meme.html"},{"type":"function","title":"Image.Options.Meme.default_margin/1","doc":"","ref":"Image.Options.Meme.html#default_margin/1"},{"type":"function","title":"Image.Options.Meme.no_such_font_file/1","doc":"","ref":"Image.Options.Meme.html#no_such_font_file/1"},{"type":"function","title":"Image.Options.Meme.validate_options/1","doc":"","ref":"Image.Options.Meme.html#validate_options/1"},{"type":"function","title":"Image.Options.Meme.validate_options/2","doc":"Validate the options for Image.meme/3 . See Image.Options.Meme.meme_options/0 .","ref":"Image.Options.Meme.html#validate_options/2"},{"type":"type","title":"Image.Options.Meme.font_weight/0","doc":"Valid font weights","ref":"Image.Options.Meme.html#t:font_weight/0"},{"type":"type","title":"Image.Options.Meme.meme_options/0","doc":"Options applicable to Image.meme/3","ref":"Image.Options.Meme.html#t:meme_options/0"},{"type":"type","title":"Image.Options.Meme.text_transform/0","doc":"Valid type transforms","ref":"Image.Options.Meme.html#t:text_transform/0"},{"type":"module","title":"Image.Options.Modulate","doc":"Options and option validation for Image.modulate/2 .","ref":"Image.Options.Modulate.html"},{"type":"function","title":"Image.Options.Modulate.validate_options/1","doc":"Validate the options for Image.modulate/2 . See Image.Options.Modulate.modulate_options/0 .","ref":"Image.Options.Modulate.html#validate_options/1"},{"type":"type","title":"Image.Options.Modulate.modulate_option/0","doc":"Valid options for Image.modulate/2 .","ref":"Image.Options.Modulate.html#t:modulate_option/0"},{"type":"type","title":"Image.Options.Modulate.modulate_options/0","doc":"Options applicable to Image.modulate/2","ref":"Image.Options.Modulate.html#t:modulate_options/0"},{"type":"module","title":"Image.Options.New","doc":"Options for new images.","ref":"Image.Options.New.html"},{"type":"function","title":"Image.Options.New.default_options/0","doc":"","ref":"Image.Options.New.html#default_options/0"},{"type":"function","title":"Image.Options.New.set_default_bands/1","doc":"","ref":"Image.Options.New.html#set_default_bands/1"},{"type":"function","title":"Image.Options.New.validate_options/1","doc":"Validate the options for Image.new/2 .","ref":"Image.Options.New.html#validate_options/1"},{"type":"type","title":"Image.Options.New.t/0","doc":"","ref":"Image.Options.New.html#t:t/0"},{"type":"module","title":"Image.Options.Open","doc":"Options and option validation for Image.open/2 .","ref":"Image.Options.Open.html"},{"type":"function","title":"Image.Options.Open.validate_option/2","doc":"","ref":"Image.Options.Open.html#validate_option/2"},{"type":"function","title":"Image.Options.Open.validate_options/1","doc":"","ref":"Image.Options.Open.html#validate_options/1"},{"type":"type","title":"Image.Options.Open.fail_on/0","doc":"Stop attempting to load an image file when a level of error is detected. The default is :none . Each error state implies all the states before it such that :error implies also :truncated .","ref":"Image.Options.Open.html#t:fail_on/0"},{"type":"type","title":"Image.Options.Open.file_access/0","doc":"The file access mode when opening image files. The default in :sequential .","ref":"Image.Options.Open.html#t:file_access/0"},{"type":"type","title":"Image.Options.Open.image_open_options/0","doc":"The options applicable to opening an image.","ref":"Image.Options.Open.html#t:image_open_options/0"},{"type":"type","title":"Image.Options.Open.jpeg_open_options/0","doc":"","ref":"Image.Options.Open.html#t:jpeg_open_options/0"},{"type":"type","title":"Image.Options.Open.other_open_options/0","doc":"","ref":"Image.Options.Open.html#t:other_open_options/0"},{"type":"type","title":"Image.Options.Open.png_open_options/0","doc":"","ref":"Image.Options.Open.html#t:png_open_options/0"},{"type":"type","title":"Image.Options.Open.tiff_open_options/0","doc":"","ref":"Image.Options.Open.html#t:tiff_open_options/0"},{"type":"type","title":"Image.Options.Open.webp_open_options/0","doc":"","ref":"Image.Options.Open.html#t:webp_open_options/0"},{"type":"module","title":"Image.Options.Resize","doc":"Options and option validation for Image.resize/3 .","ref":"Image.Options.Resize.html"},{"type":"function","title":"Image.Options.Resize.validate_options/1","doc":"Validate the options for Image.resize/2 . See Image.Options.Resize.resize_options/0 .","ref":"Image.Options.Resize.html#validate_options/1"},{"type":"type","title":"Image.Options.Resize.resize_options/0","doc":"Options applicable to Image.resize/3","ref":"Image.Options.Resize.html#t:resize_options/0"},{"type":"module","title":"Image.Options.Rotate","doc":"Options and option validation for Image.rotate/3 .","ref":"Image.Options.Rotate.html"},{"type":"function","title":"Image.Options.Rotate.validate_options/1","doc":"Validate the options for Image.rotate/3 . See Image.Options.Rotate.rotation_options/0 .","ref":"Image.Options.Rotate.html#validate_options/1"},{"type":"type","title":"Image.Options.Rotate.rotation_options/0","doc":"The options applicable to rotating an image.","ref":"Image.Options.Rotate.html#t:rotation_options/0"},{"type":"module","title":"Image.Options.Sharpen","doc":"Options and option validation for Image.sharpen/2 .","ref":"Image.Options.Sharpen.html"},{"type":"function","title":"Image.Options.Sharpen.validate_options/1","doc":"Validate the options for Image.sharpen/2 . See Image.Options.Sharpen.sharpen_options/0 .","ref":"Image.Options.Sharpen.html#validate_options/1"},{"type":"type","title":"Image.Options.Sharpen.sharpen_option/0","doc":"Valid options for Image.sharpen/2 .","ref":"Image.Options.Sharpen.html#t:sharpen_option/0"},{"type":"type","title":"Image.Options.Sharpen.sharpen_options/0","doc":"Options applicable to Image.sharpen/2","ref":"Image.Options.Sharpen.html#t:sharpen_options/0"},{"type":"module","title":"Image.Options.Text","doc":"Options for text drawing.","ref":"Image.Options.Text.html"},{"type":"function","title":"Image.Options.Text.default_options/0","doc":"","ref":"Image.Options.Text.html#default_options/0"},{"type":"function","title":"Image.Options.Text.validate_options/1","doc":"Validate the options for Image.Text.text/2 .","ref":"Image.Options.Text.html#validate_options/1"},{"type":"type","title":"Image.Options.Text.t/0","doc":"","ref":"Image.Options.Text.html#t:t/0"},{"type":"module","title":"Image.Options.Thumbnail","doc":"Options and option validation for Image.thumbnail/3 .","ref":"Image.Options.Thumbnail.html"},{"type":"function","title":"Image.Options.Thumbnail.validate_options/1","doc":"Validate the options for Image.resize/2 . See Image.Options.Resize.resize_options/0 .","ref":"Image.Options.Thumbnail.html#validate_options/1"},{"type":"type","title":"Image.Options.Thumbnail.resize_dimension/0","doc":"","ref":"Image.Options.Thumbnail.html#t:resize_dimension/0"},{"type":"type","title":"Image.Options.Thumbnail.thumbnail_options/0","doc":"Options applicable to Image.thumbnail/3","ref":"Image.Options.Thumbnail.html#t:thumbnail_options/0"},{"type":"module","title":"Image.Options.ToneCurve","doc":"Options and option validation for Image.apply_tone_curve/2 .","ref":"Image.Options.ToneCurve.html"},{"type":"macro","title":"Image.Options.ToneCurve.is_set_point/1","doc":"Valid range for setting the black point and white point.","ref":"Image.Options.ToneCurve.html#is_set_point/1"},{"type":"macro","title":"Image.Options.ToneCurve.is_tone_adjustment/1","doc":"The range in which the shadows, mids and highlights can be adjusted.","ref":"Image.Options.ToneCurve.html#is_tone_adjustment/1"},{"type":"function","title":"Image.Options.ToneCurve.validate_options/1","doc":"Validate the options for Image.apply_tone_curve/2 .","ref":"Image.Options.ToneCurve.html#validate_options/1"},{"type":"type","title":"Image.Options.ToneCurve.positive_percent/0","doc":"A percent expressed as a float in the range [0.0..1.0]","ref":"Image.Options.ToneCurve.html#t:positive_percent/0"},{"type":"type","title":"Image.Options.ToneCurve.set_point/0","doc":"Range for setting the black point and white point. The range is 0..100 reflecting the values of L* in the Lab colorspace.","ref":"Image.Options.ToneCurve.html#t:set_point/0"},{"type":"type","title":"Image.Options.ToneCurve.tone_adjustment/0","doc":"The adjustment range for the shadow, midpoint and highlights.","ref":"Image.Options.ToneCurve.html#t:tone_adjustment/0"},{"type":"type","title":"Image.Options.ToneCurve.tone_curve_option/0","doc":"Options applicable to Image.apply_tone_curve/2 .","ref":"Image.Options.ToneCurve.html#t:tone_curve_option/0"},{"type":"type","title":"Image.Options.ToneCurve.tone_curve_options/0","doc":"","ref":"Image.Options.ToneCurve.html#t:tone_curve_options/0"},{"type":"module","title":"Image.Options.Trim","doc":"Options and option validation for Image.trim/2 .","ref":"Image.Options.Trim.html"},{"type":"function","title":"Image.Options.Trim.validate_options/1","doc":"Validate the options for Image.trim/2 .","ref":"Image.Options.Trim.html#validate_options/1"},{"type":"type","title":"Image.Options.Trim.trim_options/0","doc":"Options applicable to Image.trim/2","ref":"Image.Options.Trim.html#t:trim_options/0"},{"type":"module","title":"Image.Options.Video","doc":"Options and option validation for Image.Video.stream!/2 .","ref":"Image.Options.Video.html"},{"type":"function","title":"Image.Options.Video.known_backends/0","doc":"","ref":"Image.Options.Video.html#known_backends/0"},{"type":"function","title":"Image.Options.Video.validate_open_options/1","doc":"","ref":"Image.Options.Video.html#validate_open_options/1"},{"type":"function","title":"Image.Options.Video.validate_stream_options/2","doc":"","ref":"Image.Options.Video.html#validate_stream_options/2"},{"type":"function","title":"Image.Options.Video.validate_stream_options!/2","doc":"","ref":"Image.Options.Video.html#validate_stream_options!/2"},{"type":"type","title":"Image.Options.Video.backend/0","doc":"","ref":"Image.Options.Video.html#t:backend/0"},{"type":"type","title":"Image.Options.Video.open_options/0","doc":"","ref":"Image.Options.Video.html#t:open_options/0"},{"type":"module","title":"Image.Options.WarpPerspective","doc":"Options and option validation for Image.warp_perspective/4 .","ref":"Image.Options.WarpPerspective.html"},{"type":"function","title":"Image.Options.WarpPerspective.validate_options/2","doc":"Validate the options for Image.warp_perspective/4 .","ref":"Image.Options.WarpPerspective.html#validate_options/2"},{"type":"type","title":"Image.Options.WarpPerspective.extend_mode/0","doc":"When extending the canvas the generated pixels are determined by this option.","ref":"Image.Options.WarpPerspective.html#t:extend_mode/0"},{"type":"type","title":"Image.Options.WarpPerspective.t/0","doc":"Options for Image.warp_perspective/4.","ref":"Image.Options.WarpPerspective.html#t:t/0"},{"type":"type","title":"Image.Options.WarpPerspective.warp_perspective_option/0","doc":"Options applicable to Image.embed/4 .","ref":"Image.Options.WarpPerspective.html#t:warp_perspective_option/0"},{"type":"module","title":"Image.Options.Write","doc":"Options and option validation for Image.write/3 .","ref":"Image.Options.Write.html"},{"type":"function","title":"Image.Options.Write.validate_options/2","doc":"","ref":"Image.Options.Write.html#validate_options/2"},{"type":"type","title":"Image.Options.Write.gif_write_option/0","doc":"Options for writing a gif file with Image.write/2 .","ref":"Image.Options.Write.html#t:gif_write_option/0"},{"type":"type","title":"Image.Options.Write.heif_compression/0","doc":"Allowable compression types for heif images.","ref":"Image.Options.Write.html#t:heif_compression/0"},{"type":"type","title":"Image.Options.Write.heif_write_option/0","doc":"Options for writing a heif file with Image.write/2 .","ref":"Image.Options.Write.html#t:heif_write_option/0"},{"type":"type","title":"Image.Options.Write.image_write_options/0","doc":"Options for writing an image to a file with Image.write/2 .","ref":"Image.Options.Write.html#t:image_write_options/0"},{"type":"type","title":"Image.Options.Write.jpeg_write_option/0","doc":"Options for writing a jpeg file with Image.write/2 .","ref":"Image.Options.Write.html#t:jpeg_write_option/0"},{"type":"type","title":"Image.Options.Write.png_write_option/0","doc":"Options for writing a png file with Image.write/2 .","ref":"Image.Options.Write.html#t:png_write_option/0"},{"type":"type","title":"Image.Options.Write.stream_write_option/0","doc":"Options for writing an image stream","ref":"Image.Options.Write.html#t:stream_write_option/0"},{"type":"type","title":"Image.Options.Write.tiff_write_option/0","doc":"Options for writing a tiff file with Image.write/2 .","ref":"Image.Options.Write.html#t:tiff_write_option/0"},{"type":"type","title":"Image.Options.Write.webp_write_option/0","doc":"Options for writing a webp file with Image.write/2 .","ref":"Image.Options.Write.html#t:webp_write_option/0"},{"type":"module","title":"Image.BandFormat","doc":"Functions to define and validate the band formats of an image.","ref":"Image.BandFormat.html"},{"type":"function","title":"Image.BandFormat.image_format_from_nx/1","doc":"Returns the Image format type for an Nx format type. Image uses the same type formats as Nx so this function is more a validation than a conversion. Arguments Any Nx type like {:u, 8} . Returns {:ok, band_format} or {:error, reason}","ref":"Image.BandFormat.html#image_format_from_nx/1"},{"type":"function","title":"Image.BandFormat.known_band_formats/0","doc":"Returns a list of the known band formats.","ref":"Image.BandFormat.html#known_band_formats/0"},{"type":"function","title":"Image.BandFormat.nx_format/1","doc":"Returns the Nx format type for an Image or image format type. Image uses the same type formats as Nx so this function is more a validation than a conversion. Arguments Any t:Vimage.t/0 of format in the list returned by Image.BandFormat.known_band_formats/0 . Returns {:ok, band_format} or {:error, reason}","ref":"Image.BandFormat.html#nx_format/1"},{"type":"function","title":"Image.BandFormat.nx_format!/1","doc":"Returns the Nx format type for an Image or image format type or raises an exception. Image uses the same type formats as Nx so this function is more a validation than a conversion. Arguments Any t:Vimage.t/0 of format in the list returned by Image.BandFormat.known_band_formats/0 . Returns band_format or raises an exception.","ref":"Image.BandFormat.html#nx_format!/1"},{"type":"function","title":"Image.BandFormat.validate/1","doc":"Validates a band format returning the band format value required in the underlying Vix code. Arguments format is any format returned by Image.BandFormat.known_band_formats/0 . Returns {:ok, validated_foramt} or {:error, reason} Examples iex&gt; Image.BandFormat . validate ( { :u , 8 } ) { :ok , :VIPS_FORMAT_UCHAR } iex&gt; Image.BandFormat . validate ( :u8 ) { :ok , :VIPS_FORMAT_UCHAR } iex&gt; Image.BandFormat . validate ( :VIPS_FORMAT_UCHAR ) { :ok , :VIPS_FORMAT_UCHAR }","ref":"Image.BandFormat.html#validate/1"},{"type":"type","title":"Image.BandFormat.t/0","doc":"","ref":"Image.BandFormat.html#t:t/0"},{"type":"module","title":"Image.BlendMode","doc":"Functions to define and validate the blending modes that can be applied when composing images.","ref":"Image.BlendMode.html"},{"type":"function","title":"Image.BlendMode.default_blend_mode/0","doc":"Returns the default blend mode Example iex&gt; Image.BlendMode . default_blend_mode :VIPS_BLEND_MODE_OVER","ref":"Image.BlendMode.html#default_blend_mode/0"},{"type":"function","title":"Image.BlendMode.known_blend_modes/0","doc":"Returns the known blending modes. See Image.BlendMode.t/0 for a description of each mode.","ref":"Image.BlendMode.html#known_blend_modes/0"},{"type":"function","title":"Image.BlendMode.validate_blend_mode/1","doc":"Normalizes and validates a blend mode. Argument blend_mode is one of Image.BlendMode.known_blend_modes/0 as either a String.t/0 or an atom . Returns {:ok, atom_blend_mode} where atom_blend_mode is a valid blend mode for libvips {:error, reason} Examples iex&gt; Image.BlendMode . validate_blend_mode :clear { :ok , :VIPS_BLEND_MODE_CLEAR } iex&gt; Image.BlendMode . validate_blend_mode &quot;Over&quot; { :ok , :VIPS_BLEND_MODE_OVER } iex&gt; Image.BlendMode . validate_blend_mode :VIPS_BLEND_MODE_XOR { :ok , :VIPS_BLEND_MODE_XOR } iex&gt; Image.BlendMode . validate_blend_mode :woops { :error , { :error , &quot;Unknown blend mode. Found :woops&quot; } }","ref":"Image.BlendMode.html#validate_blend_mode/1"},{"type":"type","title":"Image.BlendMode.t/0","doc":"Blend mode to use when compositing images. See Image.compose/3 . :over the image shows what you would expect if you held two semi-transparent slides on top of each other. This is the default when composing images :clear where the second image is drawn, the first is removed :source the second image is drawn as if nothing were below :in the first image is removed completely, the second is only drawn where the first was :out the second is drawn only where the first isn't :atop this leaves the first image mostly intact, but mixes both images in the overlapping area :dest leaves the first image untouched, the second is discarded completely :dest_over like :over , but swaps the arguments :dest_in like :in , but swaps the arguments :dest_out like :out , but swaps the arguments :dest_atop like :atop , but swaps the arguments :xor something like a difference operator :add a bit like adding the two images :saturate a bit like the darker of the two :multiply at least as dark as the darker of the two inputs :screen at least as light as the lighter of the inputs :overlay multiplies or screens colors, depending on the lightness :darken the darker of each component :lighten the lighter of each component :colour_dodge brighten first by a factor second :colour_burn darken first by a factor of second :hard_light multiply or screen, depending on lightness :soft_light darken or lighten, depending on lightness :difference difference of the two :exclusion somewhat like :difference, but lower-contrast","ref":"Image.BlendMode.html#t:t/0"},{"type":"module","title":"Image.CombineMode","doc":"Functions to define and validate the combine modes that can be applied when composing images.","ref":"Image.CombineMode.html"},{"type":"function","title":"Image.CombineMode.validate/1","doc":"","ref":"Image.CombineMode.html#validate/1"},{"type":"type","title":"Image.CombineMode.t/0","doc":"","ref":"Image.CombineMode.html#t:t/0"},{"type":"module","title":"Image.ExtendMode","doc":"Defines the known modes by which an image can be extended.","ref":"Image.ExtendMode.html"},{"type":"function","title":"Image.ExtendMode.known_extend_modes/0","doc":"Returns the known extend modes.","ref":"Image.ExtendMode.html#known_extend_modes/0"},{"type":"function","title":"Image.ExtendMode.validate_extend/1","doc":"Normalizes and validates an extend mode. Arguments extend is any atom or string value in Image.ExtendMode.known_extend_modes/0 . Returns {:error, normalized_extend_mode} or {:error, reason} . Examples iex&gt; Image.Kernel . validate_extend ( :black ) { :ok , :VIPS_EXTEND_BLACK } iex&gt; Image.Kernel . validate_extend ( :VIPS_EXTEND_REPEAT ) { :ok , :VIPS_EXTEND_REPEAT } iex&gt; Image.Kernel . validate_extend ( :unknown ) { :error , &quot;Unknown extend mode. Found :unknown&quot; }","ref":"Image.ExtendMode.html#validate_extend/1"},{"type":"type","title":"Image.ExtendMode.t/0","doc":"Defines the known extend strategies.","ref":"Image.ExtendMode.html#t:t/0"},{"type":"module","title":"Image.Interpretation","doc":"Defines the known color interpretations to which an image can be converted to and from.","ref":"Image.Interpretation.html"},{"type":"function","title":"Image.Interpretation.known_interpretations/0","doc":"Returns the known colorspace interpretations","ref":"Image.Interpretation.html#known_interpretations/0"},{"type":"function","title":"Image.Interpretation.validate_interpretation/1","doc":"Normalizes and validates a color interpretation. Arguments interpretation is any atom or string value in Image.Interpretation.known_interpretations/0 . Returns {:error, normalized_interpretation} or {:error, reason} Examples iex&gt; Image.Interpretation . validate_interpretation ( :bw ) { :ok , :VIPS_INTERPRETATION_B_W } iex&gt; Image.Interpretation . validate_interpretation ( :VIPS_INTERPRETATION_sRGB ) { :ok , :VIPS_INTERPRETATION_sRGB } iex&gt; Image.Interpretation . validate_interpretation ( :unknown ) { :error , &quot;Unknown interpretation. Found :unknown&quot; }","ref":"Image.Interpretation.html#validate_interpretation/1"},{"type":"type","title":"Image.Interpretation.t/0","doc":"Defines the known colorspace interpretations.","ref":"Image.Interpretation.html#t:t/0"},{"type":"module","title":"Image.Kernel","doc":"Defines the known resampling kernels to which an image can be converted to and from.","ref":"Image.Kernel.html"},{"type":"function","title":"Image.Kernel.known_kernel/0","doc":"Returns the known colorspace interpretations","ref":"Image.Kernel.html#known_kernel/0"},{"type":"function","title":"Image.Kernel.validate_kernel/1","doc":"Normalizes and validates a resampling kernel. Arguments kernel is any atom or string value in Image.Kernel.known_kernel/0 . Returns {:error, normalized_kernel} or {:error, reason} Examples iex&gt; Image.Kernel . validate_kernel ( :linear ) { :ok , :VIPS_KERNEL_LINEAR } iex&gt; Image.Kernel . validate_kernel ( :VIPS_KERNEL_CUBIC ) { :ok , :VIPS_KERNEL_CUBIC } iex&gt; Image.Kernel . validate_kernel ( :unknown ) { :error , &quot;Unknown kernel. Found :unknown&quot; }","ref":"Image.Kernel.html#validate_kernel/1"},{"type":"type","title":"Image.Kernel.t/0","doc":"Defines the known kernel resampling methods.","ref":"Image.Kernel.html#t:t/0"},{"type":"extras","title":"Image","doc":"Image is an image processing library for Elixir. It is based upon the fabulous vix library that provides a libvips wrapper for Elixir. Image is intended to provide well-documented common image processing functions in an idiomatic Elixir functional style as a layer above the very comprehensive set of functions in Vix and libvips . As of version 0.18.0, Image provides optional integration with Bumblebee allowing machine learning models to be deployed as part of an image processing pipeline. Image is also intended to be an idiomatic API layer over eVision (OpenCV) . As of Image verison 0.9.0 , the Image.QRcode.decode/1 function is provided to decode QRcodes with the functionality to do so provided by eVision . The eVision integration is optional and currently considered experimental. In a very simple image resizing benchmark , Image is approximately 2 to 3 times faster than Mogrify and uses about 5 times less memory. The documentation can be found at https://hexdocs.pm/image .","ref":"readme.html"},{"type":"extras","title":"Image - Installation","doc":"Image can be installed by adding image to your list of dependencies in mix.exs : def deps do [ { :image , &quot;~&gt; 0.28.0&quot; } ] end Installing Libvips Starting from v0.16.0 Vix which underpins Image can use either pre-built binaries or platform provided binaries. By default Vix provides pre-built NIF and libvips and uses them for operation. This makes deployment and release of your application a breeze. With this you don't have to install any compiler tools or libvips to use Vix . This is especially useful when using Image with Livebook . However the pre-built NIF or libvips does not include dependencies support all image formats and operations. If you require those formats or operations then you can bring your own libvips by installing it manually and configure Vix to use that instead. Vix makes sure to generate relevant functions and documentation based on the dependencies you bring. For example, if you install libvips with tiff support, vix will generate tiff related bindings for you. You can choose this using VIX_COMPILATION_MODE environment variable. This variable must be set both during compilation and runtime. Possible values are: PRECOMPILED_NIF_AND_LIBVIPS (Default): Uses vix provided NIF and libvips. No need to install any additional dependencies. Big thanks to sharp library maintainers, pre-compiled libvips is based on: https://github.com/lovell/sharp-libvips/ . PLATFORM_PROVIDED_LIBVIPS : Uses platform provided libvips and NIF will be compiled during compilation phase. The following build tools are required generate the Vix NIF: Install a platform specific libvips . This can be compiled from source (see https://www.libvips.org/install.html ) or via a platform package manager. For example: macOS: brew brew install libvips Linux: apt install libvips-dev For more details see Install pkg-config Ensure a supported C compiler is installed Installing Nx Nx provides multi-dimensional arrays (tensors) and numerical definitions for Elixir. These tensors can also be used as an interchange format for binary image data. When Nx is installed and Image is compiled, the functions Image.to_nx/2 and Image.from_nx/1 are defined. Nx is required in order to support the functions in Image.Classification . It is also required to support eVision and Bumblebee integrations. Add Nx to your mix.exs def deps do [ ... { :nx , &quot;~&gt; 0.4&quot; } , ... ] end Add a default Nx backend to config.exs . Nx supports a variety of backends that provide CPU and GPU acceleration. The CPU backend that provides the widest platform compatibility is EXLA.Backend . config :nx , default_backend : EXLA.Backend Update dependencies mix deps . get Installing Bumblebee Bumblebee provides pre-trained and transformer Neural Network models in Axon that can be used for a variety of image classification, segmentation and detection operations. When Bumblebee is configured, the functions in Image.Classification become available. Add Bumblebee and exla to your mix.exs . exla is required in order to provide CPU or GPU acceleration for the models so as to deliver acceptable performance. Nx will be installed as a transitory dependency. def deps do [ ... { :bumblebee , &quot;~&gt; 0.1&quot; } , { :exla , &quot;~&gt; 0.4&quot; } , ... ] end Add a default Nx backend to config.exs . Nx supports a variety of backends that provide CPU and GPU acceleration. The CPU backend that provides the widest platform compatibility is EXLA.Backend . config :nx , default_backend : EXLA.Backend Update dependencies mix deps . get Installing eVision eVision (OpenCV) provides Elixir bindings to OpenCV , the most well-known computer vision library. As of Image version 0.9.0 , experimental support for eVision (OpenCV) is provided. There is extensive documentation on how to install eVision and the required OpenCV . However to most cases the following should be enough: Add eVision to your mix.exs . exla may be optionally configured too, see the Nx installation section above. def deps do [ ... { :evision , &quot;~&gt; 0.1&quot; } , ... ] end Update dependencies mix deps . get Then proceed as normal. eVision will download a precompiled OpenCV for the appropriate system architecture and compile both the NIF and Elixir code.","ref":"readme.html#installation"},{"type":"extras","title":"Image - Configuring Libvips","doc":"Vix and libvips offer various configuration parameters that affect debug output, image caching, concurrency of imaging operations and memory leak detection. Each of these options has reasonable defaults so no action is required in order to start using the library. Vix NIF Error Logging Vix NIF code writes logs to stderr on certain errors. This is disabled by default. To enable logging set the VIX_LOG_ERROR environment variable to true . GLib Debug Output The platform upon which Image and Vix stand is libvips , a C library that performs the image manipulation. It's libvips that delivers the speed, memory efficiency and functionality. libvips uses the GLib library which has configurable debug output. This output depends on the setting of the environment variable G_DEBUG . The initial value will depend on the installation method of libvips for a given system. It can be changed by setting the G_DEBUG environment variable to one of the following: fatal-warnings which causes GLib to abort the operation at the first call to g_warning() or g_critical(). fatal-criticals causes GLib to abort the operation at the first call to g_critical(). gc-friendly causes newly allocated memory that isn't directly initialized, as well as memory being freed to be reset to 0. The point here is to allow memory checkers and similar programs that use Boehm GC alike algorithms to produce more accurate results. resident-modules causes all modules loaded by GModule will be made resident. This can be useful for tracking memory leaks in modules which are later unloaded; but it can also hide bugs where code is accessed after the module would have normally been unloaded. bind-now-modules causes all modules loaded by GModule to bind their symbols at load time, even when the code uses %G_MODULE_BIND_LAZY. To produce debug output for only the most critical issues, set G_DEBUG as follows (in bash and compatible shells): export G_DEBUG=fatal-criticals Memory Leak Detection The environment variable VIPS_LEAK determines whether libvips reports possible memory leaks. To enable leak detection (on bash compatible systems): export VIPS_LEAK=true To stop leak detection: unset VIPS_LEAK Concurrency Image (because of Vix and libvips ) will execute concurrent image operations using a number of system native threads (not BEAM processes). The number of threads available for concurrent image operations is configurable by either setting the environment variable VIPS_CONCURRENCY or through a call to Image.put_concurrency/1 . The current number of configured threads is returned from Image.get_concurrency/0 . The default number of threads is equal to the number of cores detected on the running system. This may create CPU contention with other workloads given that image processing is CPU intensive. Therefore it may be prudent to reduce the number of threads if overall system throughput is being affected.","ref":"readme.html#configuring-libvips"},{"type":"extras","title":"Image - Library packaging future","doc":"In a future release, :image will be split into several packages :image which will retain all the core components of image transformation based upon vix and libvips . :image_nx which will provide :nx interoperability (and will depend on :image ) :image_exif which will provide metadata support (and will depend on :image ) :image_classification which will provide image classification (and will depend on :image and :bumblebee ) :image_generation which will provide image generation (and will depend on :image and :bumblebee ) :image_detection which will provide object detection (and will depend on :image , :axon , :axon_onnx ) :image_qrcode which will provide QRcode scanning and production (and will depend on :image and :evision ) :image_video which will provide video frame extraction (and will depend on :image and :evision )","ref":"readme.html#library-packaging-future"},{"type":"extras","title":"Image - Security Considerations","doc":"There are several considerations in the use of any image processing library and any NIF-based library: If a NIF crashes it will likely bring down the BEAM virtual machine. libvips is a robust, time-tested library however this risk cannot be eliminated. Image processing is CPU intensive with its concurrent pipelining model and default concurrency level equal to the number of cores in the host machine, CPU starvation for other parts of the application is a possibility. In such cases, reducing the libvips concurrency is recommended. Image processing by its nature operates on external data and there have been exploits based upon maliciously crafted images. The two primary vectors are: An invalid image format that causes the image parser to crash and therefore crash the NIF and the BEAM Executable code embedded in image metadata (such as EXIF data) that if passed un-escaped to a web browser may result in arbitrary code execution. In comparison to Imagemagick that has a reported 638 CVEs, there have been only 8 CVE's reported for libvips , each resolved in a very timely manner.","ref":"readme.html#security-considerations"},{"type":"extras","title":"License","doc":"Copyright 2022 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - Image 0.36.1","doc":"This is the changelog for Image version 0.36.1 released on July 23rd, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Support negative offsets :x and :y for Image.compose/3 .","ref":"changelog.html#image-0-36-1"},{"type":"extras","title":"Changelog - Image 0.36.0","doc":"This is the changelog for Image version 0.36.0 released on July 16th, 2023. For older changelogs please consult the release tag on GitHub Enhancements Adds Image.Histogram.as_svg/2 and Image.Histogram.as_image/2 to return the histogram of an image as either an SVG format suitable to adding to an HTML page or as an Vix.Vips.Image.t/0 .","ref":"changelog.html#image-0-36-0"},{"type":"extras","title":"Changelog - Image 0.35.0","doc":"This is the changelog for Image version 0.35.0 released on July 4th, 2023. For older changelogs please consult the release tag on GitHub Breaking change Removes Image.autolevel/1 which is replaced by Image.equalize(image, :each) . Removes Image.normalize/1 which is replaced by Image.equalize(image, :luminance) . Enhancements Adds Image.equalize/2 which expands an image to fill the tone range. Equalization can be performed on all bands, on each band or only on the luminance band. This function replaces Image.normalize/1 and Image.autolevel/1 . Adds Image.contrast/2 to apply simple contrast adjustments to an image. The contrast parameter is provided as a float &gt;= 0.0 with contrast less than 1.0 meaning reduce contrast and greater than 1.0 meaning increase contrast. Adds Image.apply_tone_curve/2 which applies a tone curve to an image. This is typically used to affect overall image contrast. Adds Image.local_contrast/2 which applies a Constrast Limited Adaptive histogram equalization (CLAHE) to improve local contrast in images. Adds Image.sharpen/2 to apply sharpening to an image. Adds Image.modulate/2 to adjust an image using brightness, saturation, hue rotation and lightness in a single call. Adds Image.band_format/1 to return the band format of an image in Nx notation. Adds Image.with_band_format/3 to cast an image to a new band format, execute a function on the cast image and then re-cast the image back to its original band format if the function returns successfully. Adds Image.range/1 that returns the possible range of values for a pixel as a tuple in the form {min_value, max_value} . Adds Image.reduce_noise/2 and Image.reduce_noise!/2 that applies a median filter to reduce salt and pepper noise in an image.","ref":"changelog.html#image-0-35-0"},{"type":"extras","title":"Changelog - Image 0.34.0","doc":"This is the changelog for Image version 0.34.0 released on June 24th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Corrects generating text images with Image.Text.text/2 whent the text_stroke_color and text_fill_color are black. Closes #87 (again). Fixes using a combination of atom and numeric arguments to Image.compose/3 . Thanks to @sodapopcan for the PR. Closes #97. Removes a warning when testing without minio being installed. Thanks to @sodapopcan for the PR. Closes #95. Enhancements Adds Image.compare/3 to compare two images for similarity using a given metric (default is :ae or absolute error). The three metrics implemented in this release are :ae (absolute error which returns a value between 0.0 and 1.0), :mse (mean squared error) and :rmse (root mean squared error which returns a value between 0.0 and 1.0). Adds Image.brightness/2 and Image.saturation/2 to adjust the image brightness and saturation by a percentage amount between 0.0 and 1.0 . Also adds Image.brightness!/2 and Image.saturation!/2 . Adds hash_size as an argument to Image.hamming_distance/3 . This is the size in bits of the returned hash. The default is 64. The size of the returned hash is only guaranteed to be this size if the :math.sqrt(hash_size) is an integer. Adds :letter_spacing as an option to Image.Text.text/2 . Thanks to @sodapopcan for the PR. Closes #97.","ref":"changelog.html#image-0-34-0"},{"type":"extras","title":"Changelog - Image 0.33.0","doc":"This is the changelog for Image version 0.33.0 released on June 2nd, 2023. For older changelogs please consult the release tag on GitHub Breaking Changes Image.dhash/1 now returns a 64-bit hash (by default) rather than a 512-bit hash. The original algorithm is intended to return a 64-bit hash so this is both a breaking change and bug fix. Fix generation of images from text when autofit: false (the default). In these cases the text image is generated from SVG. The original implementation operated on the basis that the image would be generated with a height and width necessary to contain the text of a given font size. The result is not consistent and is influenced by whether the text has ascenders or desenders. The new implementation creates an SVG container of a size large enough to contain the text at the given font-size and then trims away the background to produce the final result. Thanks to @ilesar for the report. Closes #86. As a result of this fix, existing text-generated images may not now be the same as previous releases.","ref":"changelog.html#image-0-33-0"},{"type":"extras","title":"Changelog - Image 0.32.0","doc":"This is the changelog for Image version 0.32.0 released on May 24th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Fix Image.Text.text/2 when the text fill color is black (within a tolerance). When the text image is created, Vix.Vips.Operation.find_trim/2 is called to trim the image assuming a black background. Since the fill color is also black, the resulting trim is 0 pixels wide and 0 pixels high. When then cropping the image, the crop fails because the crop size is invalid. The fix is to not crop if there is no trim detected. Thanks to @tielur for the report. Closes #84. Fix specification for Image.compose/3 to remove dialyzer error (and include test case). Thanks to @tielur for the report. Closes #85. Fix Image.add_alpha/2 when providing a &quot;color&quot;. In fact the value should be an integer in the range 0..255 representing the level of transparency of the alpha band. The function spec, documentation and implementation are now changed to accept only an integer (or the atoms :opaque and :transparent). Enhancements Adds Image.from_svg/2 and Image.from_svg!/2 to provide a more discoverable means of creating an image from an SVG string.","ref":"changelog.html#image-0-32-0"},{"type":"extras","title":"Changelog - Image 0.31.1","doc":"This is the changelog for Image version 0.31.1 released on May 10th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Fix spec for Image.replace_color/2 and Image.replace_color!/2 . Thanks to @tielur. Closes #79.","ref":"changelog.html#image-0-31-1"},{"type":"extras","title":"Changelog - Image 0.31.0","doc":"This is the changelog for Image version 0.31.0 released on May 7th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Fix resolution of the image returned from Image.replace_color/2 . Thanks to @tielur for the report. Closes #78. Enhancements Add :blend option to Image.if_then_else/4 . When set to true with smoothly blend between the then and else images. The default is false .","ref":"changelog.html#image-0-31-0"},{"type":"extras","title":"Changelog - Image 0.30.0","doc":"This is the changelog for Image version 0.30.0 released on April 20th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Add documentation for Image.with_colorspace/3 . Fix Image.trim/2 reflecting the updated vix return data structure. Fix Image.if_then_else/3 to validate color options correctly. Enhancements Adds Image.cast/2 to convert the band format of an image to a different numeric type. Adds Image.replace_color/2 and Image.replace_color!/2 . Adds Image.if_then_else!/3 .","ref":"changelog.html#image-0-30-0"},{"type":"extras","title":"Changelog - Image 0.29.0","doc":"This is the changelog for Image version 0.29.0 released on April 14th, 2023. For older changelogs please consult the release tag on GitHub Enhancements Supports vix version 0.17.0 .","ref":"changelog.html#image-0-29-0"},{"type":"extras","title":"Changelog - Image 0.28.2","doc":"This is the changelog for Image version 0.28.2 released on April 13th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Image.Classification.serving/2 was applying the option top_k: 1 which means not all predictions were being returned. This option is now removed. Thanks to @tmariaz for raising the issue.","ref":"changelog.html#image-0-28-2"},{"type":"extras","title":"Changelog - Image 0.28.1","doc":"This is the changelog for Image version 0.28.1 released on April 7th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes Image.add_alpha/2 . Thanks to @kwando for the PR. Closes #71. Fixes :threshold option in Image.Options.ChromaKey to allow a value of 0 . Fixes Image.warp_perspective/4 to correctly flatten an image with an alpha band before the transform. Closes #70.","ref":"changelog.html#image-0-28-1"},{"type":"extras","title":"Changelog - Image 0.28.0","doc":"This is the changelog for Image version 0.28.0 released on April 6th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes resizing images with alpha bands. Resizing images with alpha bands requires premultiplying the alpha band into the image and reversing that after resizing. Enhancements Adds Image.warp_perspective/4 to apply a warp transformation to an image. Thanks very much to @sodapopcan for the PR and collaboration. Adds Image.straighten_perspective/3 to apply a warp perspective that straighens the image. It is basically Image.warp_perspective/4 with algorithmically derived destination parameter. Adds Image.map/2 which applies a transformation matrix (not a convolution kernel) to an image. A transformation matrix can be returned from Image.transform_matrix/3 . These two functions underpin Image.warp_perspective/4 . Adds Image.crop/2 which is a variation of Image.crop/5 that takes the same format of bounding box as that applied to Image.warp_perspective/4 making it easy to apply a warp transform and then crop to the transformed area. Note that cropping requires that the bounding box be a rectangle, not an arbitrary quadrilateral.","ref":"changelog.html#image-0-28-0"},{"type":"extras","title":"Changelog - Image 0.27.1","doc":"This is the changelog for Image version 0.27.1 released on March 20th, 2023. For older changelogs please consult the release tag on GitHub Behaviour Change Changes the default position for an image embedded via Image.embed/2 to be [0, 0] not [:center, :center] .","ref":"changelog.html#image-0-27-1"},{"type":"extras","title":"Changelog - Image 0.27.0","doc":"This is the changelog for Image version 0.27.0 released on March 20th, 2023. For older changelogs please consult the release tag on GitHub Image packaging future In a future release, Image will be split into several packages :image which will retain all the core components of image transformation based upon vix and libvips . :image_nx which will provide :nx interoperability (and will depend on :image ) :image_exif which will provide metadata support (and will depend on :image ) :image_classification which will provide image classification (and will depend on :image and :bumblebee ) :image_generation which will provide image generation (and will depend on :image and :bumblebee ) :image_detection which will provide object detection (and will depend on :image , :axon , :axon_onnx ) :image_qrcode which will provide QRcode scanning and production (and will depend on :image and :evision ) :image_video which will provide video frame extraction (and will depend on :image and :evision ) Enhancements Add Image.from_kino/2 and Image.from_kino!/2 to simplify create an image from a Kino image in Livebook . Add Image.average/1 and Image.average!/1 to calulate the average color of an image. Add Image.center_crop/3 and Image.center_crop!/3 Add Image.embed/4 and Image.embed!/4 to embed an image in a larger canvas, generating additional border pixels as required. Add Image.Shape.rect/3 to draw a rectangle image.","ref":"changelog.html#image-0-27-0"},{"type":"extras","title":"Changelog - Image 0.26.0","doc":"This is the changelog for Image version 0.26.0 released on March 12th, 2023. For older changelogs please consult the release tag on GitHub Breaking change Image.avatar/3 is now Image.avatar/2 . The size parameter is now the :size option. The default value of 180 pixels remains. Enhancements Image.avatar/2 takes a :shape option that is either :circle (the default) or :square . This allows the generation of either circular or square avatars. Bug Fixes Fix Image.open/2 for SVG binaries and add note to show that SVG images can be opened. Fix Image.avatar/2 to square the image after thumbnailing but before applying any mask. This ensures a circular mask is centred on the thumbnailed image. Fix Image.avatar/2 for image path parameters which no correctly flattens the image. Fix Image.avatar!/2 to accept either an image or an image path.","ref":"changelog.html#image-0-26-0"},{"type":"extras","title":"Changelog - Image 0.25.1","doc":"This is the changelog for Image version 0.25.1 released on March 1st, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Fix is_webp/1 guard and downcase all suffixes before validation. Thanks to @quentin-bettoum for the report and fix. Closes #64. Fix Image.avatar/3 to flatten the source image before compositing with the mask. Thanks to @jarrodmoldrich for the report. Closes #63. Fix Image.flatten/1 to only flatten if there is an alpha band.","ref":"changelog.html#image-0-25-1"},{"type":"extras","title":"Changelog - Image 0.25.0","doc":"This is the changelog for Image version 0.25.0 released on February March 1st, 2023. For older changelogs please consult the release tag on GitHub Behavior Change The default access mode for Image.open/2 is now access: :random in line with libvips native default. Although access: :sequential optimizes for many cases (especially with regard to memory) it resulted in poor developer experience since the error messages when trying to re-use a access: :sequential image are difficult to understand and very difficult to re-interpret in image . Bug Fixes Adds :heic and :avif suffixes to the list of valid suffixes for heif file formats. Thanks to @quentin-bettoum for the PR. Closes #50. Allows specifying the option padding: 0 for Image.Text.text/2 . Previously this only supported positive integers. Fix Image.write/3 documentation. Thanks to @jeregrine for the PR. Closes #62. Enhancements Update README.md to include updated documentation for installing libvips with Vix . Adds :x and :y options to Image.Text.text/2 which allows placing the text on its background in the specified location. :x can be specified as a non-negative integer or one of :left , :right or :center with the default being :center . :y can be specified as a non-negative integer or one of :top , :bottom or :middle with the default being :middle . Thanks to @severian1778 for the issue and collaboration. Closes #44. Adds an option :effort to Image.write/3 for :png , :heif , :heic , :avif and :webp images that determines the amount of CPU effort permitted when compressing the image data. Thanks to @quentin-bettoum for the PR. Closes #45.","ref":"changelog.html#image-0-25-0"},{"type":"extras","title":"Changelog - Image 0.24.1","doc":"This is the changelog for Image version 0.24.1 released on February 14th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes :weight option handling in Image.meme/3 to include :ultralight . Thanks to @quentin-bettoum. Closes #42. Fixes :intent option handling in Image.thumbnail/3 . Thanks to @quentin-bettoum. Closes #43.","ref":"changelog.html#image-0-24-1"},{"type":"extras","title":"Changelog - Image 0.24.0","doc":"This is the changelog for Image version 0.24.0 released on February 6th, 2023. For older changelogs please consult the release tag on GitHub Enhancements Adds Image.Draw.flood!/4 to align with Image.Draw.flood/4 . Adds Image.add_alpha/2 and Image.add_alpha!/2 . Adds :stroke_width to Image.Draw.rect/6 and Image.Draw.circle/5 . Thanks to @RyoWakabayashi for the suggestion and sample code.","ref":"changelog.html#image-0-24-0"},{"type":"extras","title":"Changelog - Image 0.23.2","doc":"This is the changelog for Image version 0.23.2 released on January 31st, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Image.Kino.show/2 returns the type Kino.Image.t/0 which as a side effect does not show a duplicate image and plays nicely with Kino.Layout.grid/2 . Thanks to @RyoWakabayashi. Closes #37.","ref":"changelog.html#image-0-23-2"},{"type":"extras","title":"Changelog - Image 0.23.1","doc":"This is the changelog for Image version 0.23.1 released on January 30th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Kino.show/2 returns the image instead of :ok so that it works correctly in a grid. Thanks to @RyoWakabayashi for the suggestion .","ref":"changelog.html#image-0-23-1"},{"type":"extras","title":"Changelog - Image 0.23.0","doc":"This is the changelog for Image version 0.23.0 released on January 29th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Fix specs for Image.Options.Write . Thanks to @jarrodmoldrich. Closes #36. Fix spec for Image.exif/1 . Thanks to @ntodd for the PR. Closes #35. Enhancements Adds Image.normalize/1 which normalizes an image by expanding the luminance of an image to cover the full dynamic range. Adds Image.autolevel/1 which scales each band of an image to fit the full dynamic range. Unlike Image.normalize/1 , each band is scaled separately. Adds Image.erode/2 which erodes pixels from the edge of an image mask. This can be useful to remove a small amount of colour fringing around the edge of an image. Adds Image.dilate/2 which dilates pixels from the edge of an image mask. Adds Image.trim/2 which trims an image to the bounding box of the non-background area. Adds Image.flatten/1 which flattens an alpha layer out of an image Image.Options.Write.validate_options/2 now validates options appropriate to each image type in order to make validation more robust. Adds :minimize_file_size option to Image.write/2 for JPEG and PNG files which if true will apply a range of techniques to minimize the size of the image file at the expense of time to save the image and potentially image quality.","ref":"changelog.html#image-0-23-0"},{"type":"extras","title":"Changelog - Image 0.22.1","doc":"This is the changelog for Image version 0.22.1 released on January 9th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Don't compile Image.Options.Video unless Evision is configured and compiled.","ref":"changelog.html#image-0-22-1"},{"type":"extras","title":"Changelog - Image 0.22.0","doc":"This is the changelog for Image version 0.22.0 released on January 9th, 2023. For older changelogs please consult the release tag on GitHub Enhancements Adds Image.Video.stream!/2 that returns an enumerable stream of frames as images. Adds Image.Video.scrub/2 that scubs the video head forward a number of frames.","ref":"changelog.html#image-0-22-0"},{"type":"extras","title":"Changelog - Image 0.21.0","doc":"This is the changelog for Image version 0.21.0 released on January 8th, 2023. For older changelogs please consult the release tag on GitHub Breaking change Image.Video.image_at_millisecond/2 and Image.Video.image_from_frame/2 are removed and replaced by Image.Video.image_from_video/2 . Enhancements Adds Image.Video.image_from_video/2 with support for :frame and :millisecond seek options. Seek options are only supported for video files, not video streams. Adds Image.Video.seek/2 to seek the extraction point to the requested frame or millisecond. Seeking is supported for video files only, not video streams. Adds support for capturing images from video streams (not only video files). For example, Image.Video.open(:default_camera) . See the updated documentation for Image.Video.open/1 . An image stream does not support seeking.","ref":"changelog.html#image-0-21-0"},{"type":"extras","title":"Changelog - Image 0.20.0","doc":"This is the changelog for Image version 0.20.0 released on January 8th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Fix Image.from_evision/1 to correctly orient the dimensions as {width, height, bands} Enhancements Add support for extracting frames from video as images using eVision . See Image.Video . Supports vix upcoming prebuilt libvips . The prebuilt libvips may not include the FFT dependency so Image.skew_angle/1 and Image.fft/1 are only included if Vix.Vips.Operation.fft!/1 is available.","ref":"changelog.html#image-0-20-0"},{"type":"extras","title":"Changelog - Image 0.19.0","doc":"This is the changelog for Image version 0.19.0 released on December 24th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Adds Image.Generation.text_to_image/2 the uses Stable Diffusion support in Bumblebee to generate an image from a text description of scene.","ref":"changelog.html#image-0-19-0"},{"type":"extras","title":"Changelog - Image 0.18.1","doc":"This is the changelog for Image version 0.18.1 released on December 21st, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Fix Image.Application.start/2 . Previously it would return nil if Bumblebee was not configured and nil is not a valid return from an application start function. Thanks to @haste for the report and PR. Closes #34.","ref":"changelog.html#image-0-18-1"},{"type":"extras","title":"Changelog - Image 0.18.0","doc":"This is the changelog for Image version 0.18.0 released on December 20th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Adds Image.Classification.classify/2 and Image.Classification.labels/2 to execute image classification models over an image using Bumblebee . Adds an option :max_height to Image.Kino.show/2 . Thanks to @kwando for the PR. Closes #33.","ref":"changelog.html#image-0-18-0"},{"type":"extras","title":"Changelog - Image 0.17.0","doc":"This is the changelog for Image version 0.17.0 released on December 19, 2022. For older changelogs please consult the release tag on GitHub Breaking change Rename Image.orientation/1 to be Image.aspect/1 to better reflect its purpose. Orientation has a more specific meaning in image metadata and in Vips.Vix.Image.orientation/1 . Bug Fixes Fix Image.aspect/1 for exactly square images. Draw functions now default to opaque if the base image has an alpha band (previously they would be transparent). Thanks for @kwando for the collaboration. Closes #32. Enhancements Adds a :fit option to Image.thumbnail/3 that uses the same terminology as the CSS object-fit property. This option sets overwrites the options :crop and :resize to produce the specified outcome. Add Image.Draw.point!/4 , Image.Draw.rect!/6 , Image.Draw.circle!/5 and Image.Draw.line!/6 .","ref":"changelog.html#image-0-17-0"},{"type":"extras","title":"Changelog - Image 0.16.0","doc":"This is the changelog for Image version 0.16.0 released on Decmber 18th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Allow percentages to be specified as Image.crop/5 parameters for left, top, width and height. Percentages are expressed as floats in the range -1.0 to 1.0 (for left and top) and greater than 0.0 and less than or equal to 1.0 (for width and height). Thanks to @tmjoen for the suggestion.","ref":"changelog.html#image-0-16-0"},{"type":"extras","title":"Changelog - Image 0.15.1","doc":"This is the changelog for Image version 0.15.1 released on Decmber 13th, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes interpretation of color encoded as #xxxxxx . Closes #26. Thanks to @a8t for the report.","ref":"changelog.html#image-0-15-1"},{"type":"extras","title":"Changelog - Image 0.15.0","doc":"This is the changelog for Image version 0.15.0 released on Decmber 4th, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Fix Image.minimize_metadata/1 which was previously creating malformed exif data. Enhancements Add :autofit option to Image.Text.text/2 . When set to true , text is rendered with Vix.Vips.Operation.text/2 . The default, false , uses SVG rendering. There are pros and cons to both strategies. The main difference is that autofit: true will automatically size the text and perform line wrapping to fit the specified :width and :height . Thanks to @dmitriid for the suggestion!","ref":"changelog.html#image-0-15-0"},{"type":"extras","title":"Changelog - Image 0.14.4","doc":"This is the changelog for Image version 0.14.4 released on November 14th, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Fix the return type for Image.write/3 for Plug.Conn . Thanks to @andreyuhai for the PR. Fix type specs for Image.write/3 when the destination is :memory . Thanks to @georgfaust for raising the issue. Fixes the rbga color model for integer alpha values again (which are automatically cast to the appropriate float value). Thanks to @andreyuhai for your patience and collaboration while this was sorted out.","ref":"changelog.html#image-0-14-4"},{"type":"extras","title":"Changelog - Image 0.14.3","doc":"This is the changelog for Image version 0.14.3 released on November 14th, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes the rbga color model for integer alpha values (which are automatically cast to the appropriate float value). Thanks to @andreyuhai for your patience and collaboration while this was sorted out. Casts the color to the correct number of bands in Image.Draw functions. This will either add or remove an alpha band to the color of the shape being drawn to match the underlying image. Thanks to @andreyuhai for the PR. Closes #22.","ref":"changelog.html#image-0-14-3"},{"type":"extras","title":"Changelog - Image 0.14.2","doc":"This is the changelog for Image version 0.14.2 released on November 13th, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Fix Image.split_bands/1 Fix Image.split_alpha/1","ref":"changelog.html#image-0-14-2"},{"type":"extras","title":"Changelog - Image 0.14.1","doc":"This is the changelog for Image version 0.14.1 released on November 11th, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Fix streaming image writes. Previously the stream chunks were being written in reverse order. Closes #19. Thanks to @loics2 for the report.","ref":"changelog.html#image-0-14-1"},{"type":"extras","title":"Changelog - Image 0.14.0","doc":"This is the changelog for Image version 0.14.0 released on November 11th, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Fixes extracting exif data when there is an exif blob but no exif tags. Closes #21. Thanks to @feld for the report. Enhancements Add Image.pixelate/2 and Image.pixelate!/2 Add Image.resize!/3","ref":"changelog.html#image-0-14-0"},{"type":"extras","title":"Changelog - Image 0.13.1","doc":"This is the changelog for Image version 0.13.1 released on October 23rd, 2022. For older changelogs please consult the release tag on GitHub Bug fixes Since a font named Impact isn't available on all systems, default meme generator can produce unexpected results for the rendered text. The Impact font is now included in Image and will be used if the font name is Impact .","ref":"changelog.html#image-0-13-1"},{"type":"extras","title":"Changelog - Image 0.13.0","doc":"This is the changelog for Image version 0.13.0 released on October 23rd, 2022. For older changelogs please consult the release tag on GitHub Breaking change Image.resize/3 renamed to Image.thumbnail/3 Bug fixes Fix Image.open/2 when opening JPEG images from a binary. Seems JPEG files agree on the &lt;&lt;0xff, 0xd8, 0xff&gt;&gt; header for the first three bytes. But not completely consistent with the following bytes. Fix options for Image.Draw functions which are expected to be a map after validation (but were a keyword list). Enhancements Add Image.chroma_key/2 and Image.chroma_mask/2 . Add Image.meme/3 and Image.meme!/3 . Add Image.QRcode.encode/1 and Image.QRcode.decode/1 . Add Image.blur/2 . Add Image.feather/2 . Add Image.new/2 that creates a new image of the same shape as the provided image. Add Image.resize/3 . Add Image.split_bands/1 . Add Image.if_then_else/3 . Add Image.preview/1 (and Image.p/1 that delegates to it) to preview an image inline in an iTerm2 terminal windows. Add Image.split_bands/1 to return a list single band images, one for each band in the original image.","ref":"changelog.html#image-0-13-0"},{"type":"extras","title":"Changelog - Image 0.12.0","doc":"This is the changelog for Image version 0.12.0 released on October 14th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Updates to support eVision 0.1.11 which has API breaking changes. There is no change to the Image.QRcode.decode/1 function which uses eVision .","ref":"changelog.html#image-0-12-0"},{"type":"extras","title":"Changelog - Image 0.11.0","doc":"This is the changelog for Image version 0.11.0 released on October 8th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Now uses eVision version 0.1 or later from hex.pm","ref":"changelog.html#image-0-11-0"},{"type":"extras","title":"Changelog - Image 0.10.0","doc":"This is the changelog for Image version 0.10.0 released on October 5th, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Since the mix build process does a File.cwd!/1 to the directory of each dependency we can't use the dirname of the dependency to decide whether to configure :evision or not. The strategy is now changed to configure :evision only if the environment CONFIGURE_EVISION is set. Note this is only relevant when developing :image itself. Consumers of the library should add :evision as a dependency manually in their application mix.exs as described in the readme . Thanks to @martosaur for the report. Closes #13.","ref":"changelog.html#image-0-10-0"},{"type":"extras","title":"Changelog - Image 0.9.0","doc":"This is the changelog for Image version 0.9.0 released on October 1st, 2022. For older changelogs please consult the release tag on GitHub Enhancements Image.open/2 supports opening .gif and .tif images from raw binary data in addition to the previous .jpeg , .png and .webp . Add Image.shape/1 Add Image.interpretation/1 Add Image.type/1 Add initial support for eVision . In this release the function Image.QRcode.decode/1 is provided to decode images that contain a QRcode. See the eVision repository for installation instructions since this library is not yet on hex.pm . Removed most dialyzer warnings. The remaining warnings require an update to Vix (a PR has been submitted).","ref":"changelog.html#image-0-9-0"},{"type":"extras","title":"Changelog - Image 0.8.0","doc":"This is the changelog for Image version 0.8.0 released on September 30, 2022. For older changelogs please consult the release tag on GitHub Enhancements Image.open/2 now accepts raw image data for the image types .jpeg , .png , .webp","ref":"changelog.html#image-0-8-0"},{"type":"extras","title":"Changelog - Image 0.7.0","doc":"This is the changelog for Image version 0.7.0 released on September 30, 2022. For older changelogs please consult the release tag on GitHub Enhancements Set the environment variable VIPS_BLOCK_UNTRUSTED at application start if it is not already set. As of libvips 8.13 this environment variable will cause libvips to not use any image loaders that are &quot;unfuzzed&quot;. Add mutable draw operations. These operations mutate an image directly and hence special care is taken to avoid race conditions. All mutuable operations are serialized via a GenServer . See the Image.Draw module. These functions are experimental for now pending additional testing. Add Image.from_binary/2 to support creating an image from a raw binary. Thanks to @timothyvanderaerden for the PR to support getting dialyzer under control. Work will continue on this over the next several releases.","ref":"changelog.html#image-0-7-0"},{"type":"extras","title":"Changelog - Image 0.6.0","doc":"This is the changelog for Image version 0.6.0 released on July 19th, 2022. For older changelogs please consult the release tag on GitHub Bug fixes Don't attempt to compile code that refers to Plug.t if Plug is not configured. Thanks to @kwando. Closes #7. Enhancements Adds Image.dshash/1 to return a 512-bit image hash. Adds Image.hamming_distance/2 to compare the similarity of two images or two image hashes. Adds Image.radial_gradient/3 to great a radial gradient image. This could be used to composite over another image to add a vignette. Adds Image.Math logical functions boolean_and/2 , boolean_or/2 , boolean_xor/2 , boolean_lshift/2 and boolean_rshift/2 . Also includes the ! versions. Add operator use Image.Math overloads for image &amp;&amp;&amp; ( and ), ||| ( or ), &lt;&lt;&lt; ( lshift ) and &gt;&gt;&gt; ( rshift ).","ref":"changelog.html#image-0-6-0"},{"type":"extras","title":"Changelog - Image 0.5.0","doc":"This is the changelog for Image version 0.5.0 released on June 24th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Adds Image.to_nx/1 to convert an image to an Nx tensor. Adds Image.from_nx/1 to convert an Nx tensor into an image.","ref":"changelog.html#image-0-5-0"},{"type":"extras","title":"Changelog - Image 0.4.0","doc":"This is the changelog for Image version 0.4.0 released on June 23rd, 2022. For older changelogs please consult the release tag on GitHub Enhancements Adds support for opening streaming images. This allows images to be streamed from File.stream!/3 or from any t:Stream.t/0 including those created from ExAws.S3 by ExAws.stream!/2 . Adds support writing streaming images. This allows images to be streamed as an enumerable which can then be consumed by Plug.Conn.chunk/2 , by ExAws.S3.upload/3 , File.stream/3 or any other function that processes stream resources. See the test/stream_image_test.exs for examples. Adds a :memory option to Image.write/3 . Instead of a path name or stream, use :memory if you'd like to return a binary form of an image in its formatted type. Note that this will run the image transformation pipeline resulting in the entire final image being loaded into memory. Therefore this option should be used sparingly since most use cases do not require this option. It is primarily added to facilitate passing images to other libraries in the Elixir ecosystem.","ref":"changelog.html#image-0-4-0"},{"type":"extras","title":"Changelog - Image 0.3.0","doc":"This is the changelog for Image version 0.3.0 released on June 4th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Add Image.dominant_color/2 to return the dominant color of an image Add Image.histogram/1 to return a histogram of an image Add Image.get_pixel to get the pixel value at a given x and y offset into an image.","ref":"changelog.html#image-0-3-0"},{"type":"extras","title":"Changelog - Image 0.2.0","doc":"This is the changelog for Image version 0.2.0 released on May 18th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Adds Image.Text to support generating an image from a string. See Image.Text.text/2 . Adds Image.Shape to support generating images from shapes. In this release there is a generalised support for polygons and stars. See Image.Shape.polygon/2 and Image.Shape.star/2 . Improves Image.compose/3 to support composing with image lists, relative image placement and more.","ref":"changelog.html#image-0-2-0"},{"type":"extras","title":"Changelog - Image 0.1.0","doc":"This is the changelog for Image version 0.1.0 released on May 4th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Initial release","ref":"changelog.html#image-0-1-0"},{"type":"extras","title":"Example Usage","doc":".column { float: left; width: 33.33%; padding: 5px; } /* Clear floats after image containers */ .row::after { content: \"\"; clear: both; display: table; } figure { border: 3px solid #FF1493; display: flex; flex-flow: column; padding: 0; width: 200px; height: 200px; margin: auto; width: 200px; height: 200px; } img { max-width: 200px; max-height: 200px; padding: 0; margin: 0 } figcaption { background-color: #222; color: #fff; font: smaller sans-serif; margin-top: 10px; padding: 3px; text-align: center; } Image.thumbnail(image, 200, crop: :none) Image.thumbnail(image, 200, crop: :attention) Image.crop!(image, 550, 320, 200, 200) image |> Image.thumbnail!(200, crop: :attention) |> Image.rounded!() Image.avatar(image, 200)","ref":"examples.html"}]